Package: gypsum
Version: 1.2.0
Date: 2024-06-20
Title: Interface to the gypsum REST API
Description: 
    Client for the gypsum REST API (https://gypsum.artifactdb.com), a cloud-based file store in the ArtifactDB ecosystem.
    This package provides functions for uploads, downloads, and various adminstrative and management tasks.
    Check out the documentation at https://github.com/ArtifactDB/gypsum-worker for more details.
Authors@R: person("Aaron", "Lun", role=c("aut", "cre"), email="infinite.monkeys.with.keyboards@gmail.com")
License: MIT + file LICENSE
Imports: utils, httr2, jsonlite, parallel, filelock, rappdirs
Suggests: knitr, rmarkdown, testthat, BiocStyle, digest, jsonvalidate,
        DBI, RSQLite, S4Vectors, methods
RoxygenNote: 7.3.1
VignetteBuilder: knitr
URL: https://github.com/ArtifactDB/gypsum-R
BugReports: https://github.com/ArtifactDB/gypsum-R/issues
biocViews: DataImport
git_url: https://git.bioconductor.org/packages/gypsum
git_branch: RELEASE_3_20
git_last_commit: 7fb25e1
git_last_commit_date: 2024-10-29
Repository: Bioconductor 3.20
Date/Publication: 2024-10-29
NeedsCompilation: no
Packaged: 2024-10-30 01:04:21 UTC; biocbuild
Author: Aaron Lun [aut, cre]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

# R client to the gypsum REST API

|Environment|Status|
|---|---|
|[BioC-release](https://bioconductor.org/packages/release/bioc/html/gypsum.html)|[![Release OK](https://bioconductor.org/shields/build/release/bioc/gypsum.svg)](http://bioconductor.org/checkResults/release/bioc-LATEST/gypsum/)|
|[BioC-devel](https://bioconductor.org/packages/devel/bioc/html/gypsum.html)|[![Devel OK](https://bioconductor.org/shields/build/devel/bioc/gypsum.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/gypsum/)|

Pretty much as it says on the can, provides an R client for the [**gypsum** REST API](https://github.com/ArtifactDB/gypsum-worker).
Readers are referred to the [API's documentation](https://gypsum-test.aaron-lun.workers.dev) or the [user guide](https://bioconductor.org/packages/devel/bioc/vignettes/gypsum/inst/doc/userguide.html) for more details.

#' Remove an asset
#'
#' Remove an asset of a project from the gypsum backend.
#'
#' @param project String containing the project to remove.
#' @param asset String containing the asset to remove.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a gypsum administrator account.
#'
#' @return \code{NULL} is invisibly returned if the asset was successfully removed. 
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{removeProject}}, to remove a project.
#'
#' \code{\link{removeVersion}}, to remove a specific version.
#'
#' @examples
#' if (interactive()) {
#'     # Mocking up a versioned asset.
#'     init <- startUpload(
#'         project="test-R", 
#'         asset="removal", 
#'         version="v1", 
#'         files=character(0),
#'         probation=TRUE
#'     )
#'     completeUpload(init) 
#'
#'     removeAsset("test-R", asset="removal")
#' }
#' @export
removeAsset <- function(project, asset, url=restUrl(), token=accessToken()) {
    suffix <- paste0(uenc(project), "/", uenc(asset))
    request_removal(suffix, url, token)
}

# This tests the removal functions 
# library(testthat); library(gypsum); source("setup.R"); source("test-remove.R")

test_that("removal functions work as expected", {
    skip_if(is.na(gh_token))
    removeProject("test-R-remove", token=gh_token)

    createProject("test-R-remove", owners="LTLA", token=gh_token)
    for (v in c("v1", "v2")) {
        init <- startUpload(
            project="test-R-remove", 
            asset="sacrifice", 
            version=v, 
            files=character(0),
            token=gh_token
        )
        completeUpload(init)
    }

    expect_error(fetchManifest("test-R-remove", "sacrifice", "v2", cache=NULL), NA)
    removeVersion("test-R-remove", "sacrifice", "v2", token=gh_token)
    expect_error(fetchManifest("test-R-remove", "sacrifice", "v2", cache=NULL), "does not exist")

    expect_identical(fetchLatest("test-R-remove", "sacrifice"), "v1")
    removeAsset("test-R-remove", "sacrifice", token=gh_token)
    expect_error(fetchLatest("test-R-remove", "sacrifice"), "does not exist")

    expect_error(fetchUsage("test-R-remove"), NA)
    removeProject("test-R-remove", token=gh_token)
    expect_error(fetchUsage("test-R-remove"), "does not exist")
})

# This tests the probation approval functions. 
# library(testthat); library(gypsum); source("setup.R"); source("test-probation.R")

test_that('probation approval works as expected', {
    skip_if(is.na(gh_token))
    removeAsset("test-R", "probation", token=gh_token)

    # Mocking up a versioned asset.
    init <- startUpload(
        project="test-R", 
        asset="probation", 
        version="v1", 
        files=character(0),
        probation=TRUE,
        token=gh_token
    )
    completeUpload(init)

    summ <- fetchSummary("test-R", "probation", "v1", cache=NULL)
    expect_true(summ$on_probation)

    approveProbation("test-R", "probation", "v1", token=gh_token)
    summ <- fetchSummary("test-R", "probation", "v1", cache=NULL)
    expect_null(summ$on_probation)
})

test_that('probation rejection works as expected', {
    skip_if(is.na(gh_token))
    removeAsset("test-R", "probation", token=gh_token)

    # Mocking up a versioned asset.
    init <- startUpload(
        project="test-R", 
        asset="probation", 
        version="v1", 
        files=character(0),
        probation=TRUE,
        token=gh_token
    )
    completeUpload(init)

    summ <- fetchSummary("test-R", "probation", "v1", cache=NULL)
    expect_true(summ$on_probation)

    rejectProbation("test-R", "probation", "v1", token=gh_token)
    expect_error(fetchSummary("test-R", "probation", "v1", cache=NULL), "does not exist")
})

# This tests the upload functions. 
# library(testthat); library(gypsum); source("setup.R"); source("test-upload.R")

test_that("upload sequence works as expected for regular files", {
    skip_if(is.na(gh_token))
    removeAsset("test-R", asset="upload", token=gh_token)

    tmp <- tempfile()
    dir.create(tmp)
    write(file=file.path(tmp, "blah.txt"), LETTERS)
    dir.create(file.path(tmp, "foo"))
    write(file=file.path(tmp, "foo", "bar.txt"), 1:10)

    init <- startUpload(
        project="test-R", 
        asset="upload", 
        version="1", 
        files=list.files(tmp, recursive=TRUE),
        directory=tmp,
        token=gh_token
    )

    expect_identical(length(init$file_urls), 2L)
    expect_type(init$abort_url, "character")
    expect_type(init$complete_url, "character")
    expect_type(init$session_token, "character")

    uploadFiles(init, directory=tmp)
    completeUpload(init)

    # Checking that the files were, in fact, correctly uploaded.
    man <- fetchManifest("test-R", "upload", "1", cache=NULL)
    expect_identical(sort(names(man)), c("blah.txt", "foo/bar.txt"))
    expect_false(any(vapply(man, function(x) !is.null(x$link), TRUE)))

    # Deduplication happens naturally.
    init <- startUpload(
        project="test-R", 
        asset="upload", 
        version="2", 
        files=list.files(tmp, recursive=TRUE),
        directory=tmp,
        token=gh_token
    )
    expect_identical(length(init$file_urls), 0L)
    uploadFiles(init, directory=tmp)
    completeUpload(init)

    man <- fetchManifest("test-R", "upload", "2", cache=NULL)
    expect_identical(sort(names(man)), c("blah.txt", "foo/bar.txt"))
    expect_true(all(vapply(man, function(x) !is.null(x$link), TRUE)))
})

test_that("upload sequence works as expected for links", {
    skip_if(is.na(gh_token))
    removeAsset("test-R", asset="upload", token=gh_token)

    tmp <- tempfile()
    dir.create(tmp)
    fpath <- file.path(tmp, "urmom.json")
    write(file=fpath, "[ \"Aaron\" ]")

    link.df <- rbind(
        data.frame(from.path="whee/stuff.txt", to.project="test-R", to.asset="basic", to.version="v1", to.path="blah.txt"),
        data.frame(from.path="michaela", to.project="test-R", to.asset="basic", to.version="v1", to.path="foo/bar.txt")
    )

    init <- startUpload(
        project="test-R", 
        asset="upload", 
        version="1", 
        files=data.frame(path="urmom.json", size=file.info(fpath)$size, md5sum=digest::digest(file=fpath)), # constructing a DF to test the other path.
        links=link.df,
        directory=tmp,
        token=gh_token
    )
    expect_identical(length(init$file_urls), 1L)
    uploadFiles(init, directory=tmp)
    completeUpload(init)

    man <- fetchManifest("test-R", "upload", "1", cache=NULL)
    expect_identical(sort(names(man)), c("michaela", "urmom.json", "whee/stuff.txt"))
    expect_false(is.null(man[["michaela"]]$link))
    expect_false(is.null(man[["whee/stuff.txt"]]$link))
    expect_null(man[["urmom.json"]]$link)
})

test_that("aborting the upload works correctly", {
    skip_if(is.na(gh_token))
    removeAsset("test-R", asset="upload", token=gh_token)

    init <- startUpload(
        project="test-R", 
        asset="upload", 
        version="1", 
        files=character(),
        token=gh_token
    )
    expect_identical(length(init$file_urls), 0L)
    expect_true("upload" %in% listAssets("test-R"))

    abortUpload(init)
    expect_false("upload" %in% listAssets("test-R"))
})

test_that("upload directory works as expected", {
    skip_if(is.na(gh_token))
    removeAsset("test-R", asset="upload-dir", token=gh_token)

    tmp <- tempfile()
    dir.create(tmp)
    write(file=file.path(tmp, "blah.txt"), LETTERS)
    dir.create(file.path(tmp, "foo"))
    write(file=file.path(tmp, "foo", "bar.txt"), 1:10)
    uploadDirectory(tmp, "test-R", "upload-dir", version="1", token=gh_token)

    # Checking that the files were, in fact, correctly uploaded.
    man <- fetchManifest("test-R", "upload-dir", "1", cache=NULL)
    expect_identical(sort(names(man)), c("blah.txt", "foo/bar.txt"))
    expect_false(any(vapply(man, function(x) !is.null(x$link), TRUE)))
})

#' Fetch project quota details
#'
#' Fetch the quota details for a project.
#' 
#' @param project String containing the project name.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @return List containing \code{baseline}, the baseline quota at time zero in bytes;
#' \code{growth_rate}, the annual growth rate for the quota in bytes;
#' and \code{year}, the creation year (i.e., time zero) for this project.
#'
#' @author Aaron Lun
#'
#' @examples
#' fetchQuota("test-R")
#'
#' @seealso
#' \code{\link{setQuota}}, to set the quota details.
#'
#' @export
fetchQuota <- function(project, url=restUrl(), config=NULL) {
    get_json(paste(project, "..quota", sep="/"), url=url)
}

# This tests the quota setter functions 
# library(testthat); library(gypsum); source("setup.R"); source("test-quota.R")

test_that("quota setting works as expected", {
    skip_if(is.na(gh_token))
    removeProject("test-R-quota", token=gh_token)
    createProject("test-R-quota", owners="LTLA", token=gh_token)

    setQuota("test-R-quota",
        baseline=1234,
        growth=5678,
        year=2020,
        token=gh_token
    )

    quot <- fetchQuota("test-R-quota")
    expect_identical(quot$baseline, 1234L)
    expect_identical(quot$growth, 5678L)
    expect_identical(quot$year, 2020L)
})

test_that("usage refreshment works as expected", {
    skip_if(is.na(gh_token))

    # Well, I just created it, so I would hope it doesn't have anything in it!
    expect_identical(fetchUsage("test-R-quota"), 0L) 

    refreshed <- refreshUsage("test-R-quota")
    expect_identical(refreshed, 0L)
})

#' Fetch a metadata schema
#'
#' Fetch a JSON schema file for metadata to be inserted into a SQLite database
#' (see \url{https://github.com/ArtifactDB/bioconductor-metadata-index}).
#' Each SQLite database is created from metadata files uploaded to the gypsum backend,
#' so clients uploading objects to be incorporated into the database should validate their metadata against the corresponding JSON schema.
#'
#' @param name String containing the name of the schema.
#' This can be the name of any JSON schema file published at \url{https://github.com/ArtifactDB/bioconductor-metadata-index}.
#' @param cache String containing the cache directory.
#' If \code{NULL}, no caching is performed.
#' @param overwrite Logical scalar indicating whether to overwrite an existing file in \code{cache}, if one is present.
#'
#' @return String containing a path to the downloaded schema.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{validateMetadata}}, to validate metadata against a chosen schema.
#'
#' \code{\link{fetchMetadataDatabase}}, to obtain the SQLite database of metadata.
#' 
#' @examples
#' fetchMetadataSchema()
#' @export
#' @importFrom filelock lock unlock
fetchMetadataSchema <- function(name="bioconductor/v1.json", cache=cacheDirectory(), overwrite=FALSE) {
    if (is.null(cache)) {
        cache.path <- tempfile(fileext=".json")
    } else {
        cache.dir <- file.path(cache, "schemas")
        cache.path <- file.path(cache.dir, name)
        dir.create(dirname(cache.path), showWarnings=FALSE, recursive=TRUE)

        if (file.exists(cache.path) && !overwrite) {
            # Seeing if we can return the path directly; we aquire lock to
            # check that we're not in the middle of a download. 
            (function() {
                flck <- lock(paste0(cache.path, ".LOCK"), exclusive=FALSE)
                on.exit(unlock(flck), add=TRUE, after=FALSE)
            })()
            return(cache.path)
        }
    }

    url <- paste0("https://artifactdb.github.io/bioconductor-metadata-index/", name)
    flck <- lock(paste0(cache.path, ".LOCK"))
    on.exit(unlock(flck), add=TRUE, after=FALSE)
    download_and_rename_file(url, cache.path)

    cache.path
}

# This checks the metadata-based utilities.
# library(testthat); library(gypsum); source("test-metadata.R")

cache <- tempfile()

test_that("fetchMetadataSchema works as expected", {
    path <- fetchMetadataSchema(cache=cache)
    expect_error(jsonlite::fromJSON(path), NA)

    # Uses the cache.
    writeLines(con=path, "FOO")
    path2 <- fetchMetadataSchema(cache=cache)
    expect_identical(path, path2)
    expect_identical(readLines(path), "FOO")

    # Unless we overwrite it.
    man <- fetchMetadataSchema(cache=cache, overwrite=TRUE)
    expect_error(jsonlite::fromJSON(path), NA)
})

test_that("fetchMetadataDatabase works as expected", {
    path <- fetchMetadataDatabase(cache=cache)
    expect_true(file.info(path)$size > 0)
    expect_type(gypsum:::last_check$req_time, "double")
    expect_true(!is.na(gypsum:::last_check$req_time))
    expect_type(gypsum:::last_check$mod_time, "double")
    expect_true(!is.na(gypsum:::last_check$mod_time))

    # Uses the cache.
    writeLines(con=path, "FOO")
    path2 <- fetchMetadataDatabase(cache=cache)
    expect_identical(path, path2)
    expect_identical(readLines(path), "FOO")
})

test_that("validateMetadata works as expected", {
    metadata <- list(                           
        title="Fatherhood",
        description="Luke ich bin dein Vater.",
        sources=list(
           list(provider="GEO", id="GSE12345")
        ),
        taxonomy_id=list("9606"),
        genome=list("GRCm38"),
        maintainer_name="Darth Vader",
        maintainer_email="vader@empire.gov",
        bioconductor_version="3.10"
    )

    schema <- fetchMetadataSchema(cache=cache)
    expect_error(validateMetadata(metadata, schema), NA)
    expect_error(validateMetadata(jsonlite::toJSON(metadata, auto_unbox=TRUE), schema), NA) # stringification works as expected.

    metadata$bioconductor_version <- NULL
    expect_error(validateMetadata(metadata, schema), "bioconductor_version")
})

#' Create a new project
#'
#' Create a new project with the associated permissions.
#'
#' @param project String containing the project name.
#' @param owners Character vector containing the GitHub users or organizations that are owners of this project.
#' @param uploaders List specifying the authorized uploaders for this project.
#' See the \code{uploaders} field in the \code{\link{fetchPermissions}} return value for the expected format. 
#' @param baseline Numeric scalar specifying the baseline quota in bytes.
#' If \code{NULL}, the backend's default is used.
#' @param growth Numeric scalar specifying the quota's annual growth rate in bytes.
#' If \code{NULL}, the backend's default is used.
#' @param year Integer scalar specifying the year of the project creation.
#' If \code{NULL}, the backend's default is used - this should be the current year.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a gypsum administrator account.
#'
#' @return \code{NULL} is invisibly returned if the project was successfully created.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{removeProject}}, to remove a project.
#'
#' @examples
#' if (interactive()) {
#'     createProject(
#'         "test-R-create", 
#'         owners="LTLA", 
#'         uploaders=list(list(id="ArtifactDB-bot"))
#'     )
#' }
#' @export
#' @import httr2
createProject <- function(project, owners, uploaders=list(), baseline=NULL, growth=NULL, year=NULL, url=restUrl(), token=accessToken()) {
    url <- chomp_url(url)
    uploaders <- sanitize_uploaders(uploaders)

    quota <- list()
    if (!is.null(baseline)) {
        quota$baseline <- baseline
    }
    if (!is.null(growth)) {
        quota$growth_rate <- growth
    }
    if (!is.null(year)) {
        quota$year <- year
    }

    body <- list(
        permissions=list(
            owners=I(owners), 
            uploaders=uploaders
        )
    )
    if (length(quota)) {
        body$quota <- quota
    }

    req <- request(paste0(url, "/create/", uenc(project)))
    req <- req_method(req, "POST")
    req <- req_body_json(req, body)
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)

    req_perform(req)
    invisible(NULL)
}

# This tests the permission setter functions 
# library(testthat); library(gypsum); source("setup.R"); source("test-permissions.R")

test_that("permission setting works as expected", {
    skip_if(is.na(gh_token))
    removeProject("test-R-perms", token=gh_token)
    createProject("test-R-perms", owners="LTLA", token=gh_token)

    until <- round(Sys.time() + 1000000)
    setPermissions("test-R-perms",
        owners="jkanche", 
        uploaders=list(
           list(id="lawremi", until=until)
        ),
        token=gh_token
    )

    perms <- fetchPermissions("test-R-perms")
    expect_identical(perms$owners, list("LTLA", "jkanche"))
    expect_identical(length(perms$uploaders), 1L)
    expect_identical(perms$uploaders[[1]]$id, "lawremi")
    expect_equal(perms$uploaders[[1]]$until, until)

    # Checking uploader appending, while also checking owners=NULL.
    setPermissions("test-R-perms", uploaders=list(list(id="ArtifactDB-bot", trusted=TRUE)), token=gh_token)
    perms <- fetchPermissions("test-R-perms")
    expect_identical(perms$owners, list("LTLA", "jkanche"))
    expect_identical(length(perms$uploaders), 2L)
    expect_identical(perms$uploaders[[1]]$id, "lawremi")
    expect_identical(perms$uploaders[[2]]$id, "ArtifactDB-bot")
    expect_true(perms$uploaders[[2]]$trusted)

    # Checking union of owners, and also that uploaders=NULL works.
    setPermissions("test-R-perms", owners=c("PeteHaitch", "LTLA"), token=gh_token)
    perms <- fetchPermissions("test-R-perms")
    expect_identical(perms$owners, list("LTLA", "jkanche", "PeteHaitch"))
    expect_identical(length(perms$uploaders), 2L)

    # Resetting the owners back.
    setPermissions("test-R-perms", owners="LTLA", append=FALSE, token=gh_token)
    perms <- fetchPermissions("test-R-perms")
    expect_identical(perms$owners, list("LTLA"))
    expect_identical(length(perms$uploaders), 2L)

    # Now resetting the uploaders. 
    setPermissions("test-R-perms", uploaders=list(), append=FALSE, token=gh_token)
    perms <- fetchPermissions("test-R-perms")
    expect_identical(perms$owners, list("LTLA"))
    expect_identical(length(perms$uploaders), 0L)
})

#' Translate a plain-text query to a gypsum.search.clause
#'
#' Translate a plain-text query in user-friendly format to a \link{gypsum.search.clause},
#' equivalent to that created by \code{\link{gsc}} with the corresponding boolean operations.
#'
#' @param query String containing a query in user-friendly format to a \link{gypsum.search.clause}.
#'
#' @return A \link{gypsum.search.clause} representing \code{query}.
#' 
#' @details
#' For text searches, we support a more human-readable syntax for boolean operations in the query.
#' The search string below will look for all metadata documents that match \code{foo} or \code{bar} but not \code{whee}:
#' 
#' \preformatted{
#' (foo OR bar) AND NOT whee
#' }
#' 
#' The \code{AND}, \code{OR} and \code{NOT} (note the all-caps!) are automatically translated to the corresponding search clauses.
#' This can be combined with parentheses to control precedence; otherwise, \code{AND} takes precedence over \code{OR}, and \code{NOT} takes precedence over both.
#' Note that any sequence of adjacent text terms are implicitly AND'd together, so the two expressions below are equivalent:
#' 
#' \preformatted{
#' foo bar whee
#' foo AND bar AND whee
#' } 
#' 
#' Users can prefix any sequence of text terms with the name of a metadata field, to only search for matches within that field of the metadata file.
#' For example:
#' 
#' \preformatted{
#' (title: prostate cancer) AND (genome: GRCh38 OR genome: GRCm38)
#' } 
#' 
#' Note that this does not extend to the \code{AND}, \code{OR} and \code{NOT} keywords,
#' e.g., \code{title:foo OR bar} will not limit the search for \code{bar} to the \code{title} field.
#' 
#' If a \code{\%} wildcard is present in a search term, its corresponding text search clause is configured to perform a partial search.
#' 
#' @author Aaron Lun
#'
#' @examples
#' str(translateTextQuery("foo AND bar"))
#' str(translateTextQuery("foo AND bar%"))
#' str(translateTextQuery("(foo AND NOT bar) OR whee"))
#' str(translateTextQuery("blah:foo whee AND stuff: bar blob"))
#' 
#' @export
translateTextQuery <- function(query) {
    .translateTextQuery(strsplit(query, "")[[1]], 1L, FALSE)$translated
}

# Translated from translate.go in https://github.com/ArtifactDB/SewerRat.

.translateTextQuery <- function(query, at, open.par) {
    status <- list(
        word = character(),
        words = list(),
        clauses = list(),
        operations = character(),
        negation = FALSE
    )

    closing.par <- FALSE
    original <- at

    while (at <= length(query)) {
        char <- query[at]

        if (char == "(") {
            word <- paste(status$word, collapse="")
            if (word == "AND" || word == "OR") {
                status <- .translateAddOperation(status, at, word)
            } else if (word == "NOT") {
                if (length(status$words) || length(status$operations) < length(status$clauses)) {
                    stop(sprintf("illegal placement of NOT at position %d", at))
                }
                status$negation <- TRUE
                status$word <- character()
            } else if (nchar(word) > 0 || length(status$words) > 0) {
                stop(sprintf("search clauses must be separated by AND or OR at position %d", at))
            }

            output <- .translateTextQuery(query, at + 1, TRUE)
            nested <- output$translated
            at <- output$at

            if (status$negation) {
                nested <- list(type="not", child=nested)
                class(nested) <- "gypsum.search.clause"
                status$negation <- FALSE
            }
            status$clauses <- c(status$clauses, list(nested))
            next
        }

        if (char == ")") {
            if (!open.par) {
                stop(sprintf("unmatched closing parenthesis at position %d", at))
            }
            closing.par <- TRUE
            at <- at + 1L
            break
        }

        if (grepl("\\s", char)) {
            word <- paste(status$word, collapse="")
            if (word == "AND" || word == "OR") {
                status <- .translateAddOperation(status, at, word)
            } else if (word == "NOT") {
                if (length(status$words) || length(status$operations) < length(status$clauses)) {
                    stop(sprintf("illegal placement of NOT at position %d", at))
                }
                status$negation <- TRUE
                status$word <- character()
            } else if (nchar(word) > 0) {
                status$words <- c(status$words, list(status$word))
                status$word <- character()
            }
        } else {
            status$word <- c(status$word, char)
        }

        at <- at + 1L
    }

    if (length(status$operations) == length(status$clauses)) {
        if (length(status$word) > 0) {
            word <- paste(status$word, collapse="")
            if (word == "AND" || word == "OR") {
                stop(sprintf("trailing AND/OR at position %d", at))
            }
            status$words <- c(status$words, list(status$word))
        }

        status <- .translateTextClause(status, at)
    }

    if (open.par && !closing.par) {
        stop(sprintf("unmatched opening parenthesis at position %d", original - 1))
    }

    # Finding the stretches of ANDs first.
    if (length(status$operations) > 0) {
        tmp.clauses <- list()
        active.clauses <- status$clauses[1]
        for (o in seq_along(status$operations)) {
            op <- status$operations[o]
            if (op == "AND") {
                active.clauses <- c(active.clauses, status$clauses[o + 1])
            } else {
                tmp.clauses <- c(tmp.clauses, list(active.clauses))
                active.clauses <- status$clauses[o + 1]
            }
        }
        tmp.clauses <- c(tmp.clauses, list(active.clauses))

        status$clauses <- list()
        for (i in seq_along(tmp.clauses)) {
            tmp <- tmp.clauses[[i]]
            if (length(tmp) > 1) {
                andified <- list(type = "and", children = tmp)
                class(andified) <- "gypsum.search.clause"
                status$clauses <- c(status$clauses, list(andified))
            } else {
                status$clauses <- c(status$clauses, tmp)
            }
        }
    }

    # Finally, resolving the ORs.
    if (length(status$clauses) > 1) {
        output <- list(type = "or", children = status$clauses)
        class(output) <- "gypsum.search.clause"
    } else {
        output <- status$clauses[[1]]
    }

    list(translated = output, at = at)
}

.translateTextClause <- function(status, at) {
    new_component <- list(type = "text")
    class(new_component) <- "gypsum.search.clause"

    if (length(status$words) == 0) {
        stop(sprintf("no search terms at position %d", at))
    }

    first.word <- status$words[[1]]
    fi <- 0L
    for (i in seq_along(first.word)) {
        x <- first.word[i]
        if (x == ':') {
            fi <- i
            break
        }
    }
    if (fi == 1L) {
        stop(sprintf("search field should be non-empty for terms ending at %d", at))
    }

    if (fi > 1L) {
        new_component$field <- paste(first.word[1:(fi-1L)], collapse="")
        if (fi == length(first.word)) {
            if (length(status$words) == 1) {
                stop(sprintf("no search terms at position %d after removing the search field", at))
            }
            status$words <- status$words[2:length(status$words)]
        } else {
            status$words[[1]] <- first.word[(fi+1):length(first.word)]
        }
    }

    converted <- vapply(status$words, paste, collapse="", FUN.VALUE="")
    if (length(converted) == 1L) {
        new_component$text <- converted
        new_component$partial <- grepl("%", converted)
    } else {
        new_children <- lapply(converted, function(x) {
            copy <- new_component
            copy$text <- x
            copy$partial <- grepl("%", x)
            copy
        })
        new_component <- list(type="and", children=new_children)
        class(new_component) <- "gypsum.search.clause"
    }

    if (status$negation) {
        new_component <- list(type = "not", child = new_component)
        class(new_component) <- "gypsum.search.clause"
        status$negation <- FALSE
    }

    status$clauses <- c(status$clauses, list(new_component))
    status$words <- list()
    status
}

.translateAddOperation <- function(status, at, word) {
    if (length(status$operations) > length(status$clauses)) {
        stop(sprintf("multiple AND or OR keywords at position %d", at))
    }

    if (length(status$operations) == length(status$clauses)) {
        # Operations are binary, so if there wasn't already a preceding
        # clause, then we must try to add a text clause.
        status <- .translateTextClause(status, at)
    }

    status$operations = c(status$operations, word)
    status$word <- character()
    status
}

# This tests the translation machinery.
# library(testthat); library(gypsum); source("test-translateTextQuery.R")

test_that("translateTextQuery works for simple requests", {
    out <- translateTextQuery("foobar")
    expect_identical(out$type, "text")
    expect_identical(out$text, "foobar")

    # Works with spaces.
    out <- translateTextQuery("foo\nbar   whee")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$text, "bar")
    expect_identical(out$children[[3]]$text, "whee")

    # Works with fields.
    out <- translateTextQuery("stuff:blah")
    expect_identical(out$type, "text")
    expect_identical(out$field, "stuff")
    expect_identical(out$text, "blah")

    # Works with a space after the colon.
    out <- translateTextQuery("stuff: yay blah")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$text, "yay")
    expect_identical(out$children[[1]]$field, "stuff")
    expect_identical(out$children[[2]]$text, "blah")
    expect_identical(out$children[[2]]$field, "stuff")

    # Recognizes partial hits.
    out <- translateTextQuery("foo%")
    expect_identical(out$type, "text")
    expect_identical(out$text, "foo%")
    expect_true(out$partial)

    out <- translateTextQuery("foo% bar")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$text, "foo%")
    expect_true(out$children[[1]]$partial)
    expect_identical(out$children[[2]]$text, "bar")
    expect_false(out$children[[2]]$partial)

    # Fails correctly.
    expect_error(translateTextQuery("\n"), "no search terms")
})

test_that("translateTextQuery works for NOT requests", {
    out <- translateTextQuery("NOT foobar")
    expect_identical(out$type, "not")
    expect_identical(out$child$type, "text")
    expect_identical(out$child$text, "foobar")

    # Works with multiple words.
    out <- translateTextQuery("NOT foo bar")
    expect_identical(out$type, "not")
    expect_identical(out$child$type, "and")
    expect_identical(out$child$children[[1]]$text, "foo")
    expect_identical(out$child$children[[2]]$text, "bar")

    # Adding parentheses and spaces.
    out <- translateTextQuery("NOT ( foobar )")
    expect_identical(out$type, "not")
    expect_identical(out$child$type, "text")
    expect_identical(out$child$text, "foobar")

    out <- translateTextQuery("NOT(foobar)")
    expect_identical(out$type, "not")
    expect_identical(out$child$type, "text")
    expect_identical(out$child$text, "foobar")

    # Fails correctly.
    expect_error(translateTextQuery("NOT "), "no search terms")
    expect_error(translateTextQuery("foo NOT bar"), "illegal placement") 
    expect_error(translateTextQuery("foo NOT(bar)"), "illegal placement") 
    expect_error(translateTextQuery("(foo) NOT (bar)"), "illegal placement") 
    expect_error(translateTextQuery("(foo)NOT(bar)"), "illegal placement") 
})

test_that("translateTextQuery works for AND requests", {
    out <- translateTextQuery("foo AND bar")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$text, "bar")

    # Works with multiple words and conditions.
    out <- translateTextQuery("foo bar AND whee stuff AND other")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$type, "and")
    expect_identical(out$children[[1]]$children[[1]]$text, "foo")
    expect_identical(out$children[[1]]$children[[2]]$text, "bar")
    expect_identical(out$children[[2]]$type, "and")
    expect_identical(out$children[[2]]$children[[1]]$text, "whee")
    expect_identical(out$children[[2]]$children[[2]]$text, "stuff")
    expect_identical(out$children[[3]]$text, "other")

    # Works with parentheses.
    out <- translateTextQuery("(foo) AND (bar)")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$text, "bar")

    out <- translateTextQuery("(foo)AND(bar)")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$text, "bar")

    # Fails correctly.
    expect_error(translateTextQuery("AND"), "trailing AND")
    expect_error(translateTextQuery("asdasd AND"), "trailing AND")
    expect_error(translateTextQuery("AND asdasd"), "no search terms")
})

test_that("translateTextQuery works for OR requests", {
    out <- translateTextQuery("foo OR bar")
    expect_identical(out$type, "or")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$text, "bar")

    # Works with multiple words and conditions.
    out <- translateTextQuery("foo bar OR whee stuff OR other")
    expect_identical(out$type, "or")
    expect_identical(out$children[[1]]$type, "and")
    expect_identical(out$children[[1]]$children[[1]]$text, "foo")
    expect_identical(out$children[[1]]$children[[2]]$text, "bar")
    expect_identical(out$children[[2]]$type, "and")
    expect_identical(out$children[[2]]$children[[1]]$text, "whee")
    expect_identical(out$children[[2]]$children[[2]]$text, "stuff")
    expect_identical(out$children[[3]]$text, "other")

    # Works with parentheses.
    out <- translateTextQuery("(foo) OR (bar)")
    expect_identical(out$type, "or")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$text, "bar")

    out <- translateTextQuery("(foo)OR(bar)")
    expect_identical(out$type, "or")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$text, "bar")

    # Fails correctly.
    expect_error(translateTextQuery("OR"), "trailing AND/OR")
    expect_error(translateTextQuery("asdasd OR"), "trailing AND/OR")
    expect_error(translateTextQuery("OR asdasd"), "no search terms")
})

test_that("translateTextQuery works for complex requests", {
    out <- translateTextQuery("foo AND bar OR NOT whee")
    expect_identical(out$type, "or")
    expect_identical(out$children[[1]]$type, "and")
    expect_identical(out$children[[1]]$children[[1]]$text, "foo")
    expect_identical(out$children[[1]]$children[[2]]$text, "bar")
    expect_identical(out$children[[2]]$type, "not")
    expect_identical(out$children[[2]]$child$text, "whee")

    out <- translateTextQuery("foo AND (bar OR NOT (whee))")
    expect_identical(out$type, "and")
    expect_identical(out$children[[1]]$text, "foo")
    expect_identical(out$children[[2]]$type, "or")
    expect_identical(out$children[[2]]$children[[1]]$text, "bar")
    expect_identical(out$children[[2]]$children[[2]]$type, "not")
    expect_identical(out$children[[2]]$children[[2]]$child$text, "whee")
})

#' Save a file from a version of a project asset
#'
#' Download a file from the gypsum bucket, for a version of an asset of a project.
#'
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param version String containing the version name.
#' @param path String containing the suffix of the object key for the file of interest,
#' i.e., the relative \dQuote{path} inside the version's \dQuote{subdirectory}.
#' The full object key is defined as \code{{project}/{asset}/{version}/{path}}.
#' @param cache String containing the path to the cache directory.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#' @param overwrite Logical scalar indicating whether to overwrite an existing file in \code{cache}.
#' If \code{FALSE} and the file exists in \code{cache}, the download is skipped.
#' 
#' @return The file is downloaded to the local file system. The destination file path is returned.
#'
#' @details
#' The full object key is defined as \code{{project}/{asset}/{version}/{path}}.
#' If no file exists in the project-asset-version combination at \code{path}, 
#' this function will check the \code{..links} file to check whether \code{path} refers to a linked-from file.
#' If so, the contents of the link destination is downloaded to the cache and a link/copy is created at the returned file path.
#'
#' @author Aaron Lun
#' 
#' @seealso
#' \code{\link{saveVersion}}, to save all files with the same prefix.
#'
#' \code{\link{cacheDirectory}}, for file caching.
#' 
#' @examples
#' out <- saveFile("test-R", "basic", "v1", "blah.txt")
#' readLines(out)
#' 
#' @export
saveFile <- function(project, asset, version, path, cache=cacheDirectory(), overwrite=FALSE, url=restUrl(), config=NULL) {
    acquire_lock(cache, project, asset, version)
    on.exit(release_lock(project, asset, version), add=TRUE, after=FALSE)

    object <- paste0(project, "/", asset, "/", version, "/", sanitize_path(path))
    destination <- file.path(cache, BUCKET_CACHE_NAME, project, asset, version, path)
    found <- save_file(object, destination, overwrite=overwrite, url=url, error=FALSE)

    if (!found) {
        link <- resolve_single_link(project, asset, version, path, cache, overwrite=overwrite, url=url)
        if (is.null(link)) {
            stop("'", path, "' does not exist in the bucket")
        }
        if (!file.link(link, destination) && !file.copy(link, destination)) {
            stop("failed to resolve link for '", path, "'")
        }
    }

    destination
}

#' @importFrom jsonlite fromJSON
resolve_single_link <- function(project, asset, version, path, cache, overwrite, url) {
    if (grepl("/", path)) {
        lpath <- paste0(sub("/[^/]+$", "", path), "/..links")
    } else {
        lpath <- "..links"
    }

    lobject <- paste0(project, "/", asset, "/", version, "/", lpath)
    ldestination <- file.path(cache, BUCKET_CACHE_NAME, project, asset, version, lpath)
    if (!save_file(lobject, ldestination, overwrite=overwrite, url=url, error=FALSE)) {
        return(NULL)
    }

    link.info <- fromJSON(ldestination, simplifyVector=FALSE)
    base <- sub(".*/", "", path)
    if (!(base %in% names(link.info))) {
        return(NULL)
    }

    target <- link.info[[base]]
    if ("ancestor" %in% names(target)) {
        target <- target[["ancestor"]]
    }

    tobject <- paste0(target$project, "/", target$asset, "/", target$version, "/", target$path)
    tdestination <- file.path(cache, BUCKET_CACHE_NAME, target$project, target$asset, target$version, target$path)
    save_file(tobject, tdestination, overwrite=overwrite, url=url)
    return(tdestination)
}

# As the name suggests, this checks that saveFile/saveVersion work as expected.
# library(testthat); library(gypsum); source("setup.R"); source("test-save.R")

test_that("saveFile works as expected", {
    cache <- tempfile()
    out <- saveFile("test-R", "basic", "v1", "blah.txt", cache=cache)
    expect_identical(readLines(out), blah_contents)

    out <- saveFile("test-R", "basic", "v1", "foo/bar.txt", cache=cache)
    expect_identical(readLines(out), foobar_contents)

    # Actually uses the cache.
    writeLines(con=out, letters)
    out <- saveFile("test-R", "basic", "v1", "foo/bar.txt", cache=cache)
    expect_identical(readLines(out), letters)

    # Until it doesn't.
    out <- saveFile("test-R", "basic", "v1", "foo/bar.txt", cache=cache, overwrite=TRUE)
    expect_identical(readLines(out), foobar_contents)

    expect_error(saveFile("test-R", "basic", "v1", "no.exist.txt", cache=cache), "does not exist")
})

test_that("saveFile works via links", {
    cache <- tempfile()
    out <- saveFile("test-R", "basic", "v2", "blah.txt", cache=cache)
    expect_identical(readLines(out), blah_contents)

    out <- saveFile("test-R", "basic", "v2", "foo/bar.txt", cache=cache)
    expect_identical(readLines(out), foobar_contents)

    # Pulling out some ancestors.
    out <- saveFile("test-R", "basic", "v3", "blah.txt", cache=cache)
    expect_identical(readLines(out), blah_contents)

    out <- saveFile("test-R", "basic", "v3", "foo/bar.txt", cache=cache)
    expect_identical(readLines(out), foobar_contents)
})

test_that("saveVersion works as expected without links", {
    cache <- tempfile()
    out <- saveVersion("test-R", "basic", "v1", cache=cache)
    expect_true(file.exists(file.path(out, "..manifest")))
    expect_identical(readLines(file.path(out, "blah.txt")), blah_contents)
    expect_identical(readLines(file.path(out, "foo", "bar.txt")), foobar_contents)

    # Caching behaves as expected.
    path <- file.path(out, "blah.txt")
    writeLines("foo", con=path)
    out <- saveVersion("test-R", "basic", "v1", cache=cache)
    expect_identical(readLines(path), "foo")

    # Unless we overwrite.
    out <- saveVersion("test-R", "basic", "v1", cache=cache, overwrite=TRUE)
    expect_identical(readLines(path), blah_contents)

    # Also works concurrently.
    cache2 <- tempfile()
    out <- saveVersion("test-R", "basic", "v1", cache=cache2, concurrent=2)
    expect_true(file.exists(file.path(cache2, "bucket", "test-R", "basic", "v1", "..manifest")))
    expect_identical(readLines(file.path(cache2, "bucket", "test-R", "basic", "v1", "blah.txt")), blah_contents)
    expect_identical(readLines(file.path(cache2, "bucket", "test-R", "basic", "v1", "foo", "bar.txt")), foobar_contents)
})

test_that("saveVersion works as expected with links", {
    cache <- tempfile()
    out <- saveVersion("test-R", "basic", "v2", cache=cache)
    expect_identical(readLines(file.path(out, "blah.txt")), blah_contents)
    expect_identical(readLines(file.path(out, "foo", "bar.txt")), foobar_contents)
    expect_true(file.exists(file.path(cache, gypsum:::BUCKET_CACHE_NAME, "test-R", "basic", "v1", "blah.txt"))) # populates the linked-to files as well.
    expect_true(file.exists(file.path(cache, gypsum:::BUCKET_CACHE_NAME, "test-R", "basic", "v1", "foo", "bar.txt"))) 

    # Unless we turn off link resolution.
    cache <- tempfile()
    out <- saveVersion("test-R", "basic", "v2", cache=cache, relink=FALSE)
    expect_false(file.exists(file.path(out, "blah.txt")))
    expect_false(file.exists(file.path(out, "foo", "bar.txt")))

    # Works recursively.
    cache <- tempfile()
    out <- saveVersion("test-R", "basic", "v3", cache=cache)
    expect_identical(readLines(file.path(out, "blah.txt")), blah_contents)
    expect_identical(readLines(file.path(out, "foo", "bar.txt")), foobar_contents)
    expect_true(file.exists(file.path(cache, gypsum:::BUCKET_CACHE_NAME, "test-R", "basic", "v1", "blah.txt"))) # populates the ancestral versions as well.
    expect_true(file.exists(file.path(cache, gypsum:::BUCKET_CACHE_NAME, "test-R", "basic", "v1", "foo", "bar.txt"))) 

    # Link resolver doesn't do more work if it's already present.
    path <- file.path(out, "foo", "bar.txt")
    writeLines(con=path, "Aaron wuz here")
    out <- saveVersion("test-R", "basic", "v3", cache=cache)
    expect_identical(readLines(path), "Aaron wuz here")

    # Unless we force it to. 
    out <- saveVersion("test-R", "basic", "v3", cache=cache, overwrite=TRUE)
    expect_identical(readLines(path), foobar_contents)
})

#' List assets
#'
#' List all assets in a project.
#'
#' @param project String containing the project name.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @author Aaron Lun
#'
#' @return Character vector of asset names.
#'
#' @examples
#' listAssets("test-R")
#' 
#' @export
listAssets <- function(project, url=restUrl(), config=NULL) {
    list_for_prefix(paste0(project, "/"), url=url)
}

# This tests the various listing functions.
# library(testthat); library(gypsum); source("setup.R"); source("test-list.R")

test_that("listVersions works as expected", {
    versions <- listVersions("test-R", "basic")
    expect_true("v1" %in% versions)
    expect_true("v2" %in% versions)
    expect_true("v3" %in% versions)

    versions <- listVersions("test-R", "i-do-not-exist")
    expect_identical(versions, character(0))
})

test_that("listAssets works as expected", {
    assets <- listAssets("test-R")
    expect_true("basic" %in% assets)
})

test_that("listProjects works as expected", {
    projects <- listProjects()
    expect_true("test-R" %in% projects)
})

test_that("listFiles works as expected", {
    in.basic <- listFiles("test-R", "basic", "v1")
    expect_identical(sort(in.basic), sort(c("..summary", "..manifest", "blah.txt", "foo/bar.txt")))

    in.basic <- listFiles("test-R", "basic", "v2")
    expect_identical(sort(in.basic), sort(c("..summary", "..manifest", "..links", "foo/..links")))

    in.basic <- listFiles("test-R", "basic", "v1", prefix="foo/")
    expect_identical(sort(in.basic), sort(c("foo/bar.txt")))

    in.basic <- listFiles("test-R", "basic", "v1", prefix="..")
    expect_identical(sort(in.basic), sort(c("..summary", "..manifest")))
})

#' Complete an upload
#'
#' Complete an upload session after all files have been uploaded.
#'
#' @param init List containing \code{complete_url} and \code{session_token}.
#' This is typically the return value from \code{\link{startUpload}}.
#' @inheritParams startUpload
#' 
#' @return \code{NULL} is invisibly returned on successful completion.
#' 
#' @seealso
#' \code{\link{startUpload}}, to create \code{init}.
#' 
#' @author Aaron Lun
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#' write(file=file.path(tmp, "blah.txt"), LETTERS)
#' dir.create(file.path(tmp, "foo"))
#' write(file=file.path(tmp, "foo", "bar.txt"), 1:10)
#'
#' if (interactive()) {
#'     init <- startUpload(
#'         project="test-R", 
#'         asset="upload-complete-check", 
#'         version="v1", 
#'         files=list.files(tmp, recursive=TRUE),
#'         probation=TRUE,
#'         directory=tmp
#'     )
#'     uploadFiles(init, directory=tmp)
#'
#'     # Finishing the upload.
#'     completeUpload(init) 
#' }
#'
#' @export
#' @import httr2
completeUpload <- function(init, url=restUrl()) {
    url <- chomp_url(url)
    req <- request(paste0(url, init$complete_url))
    req <- req_method(req, "POST")
    req <- req_auth_bearer_token(req, init$session_token)
    req <- process_error(req)
    req_perform(req)
    invisible(NULL)
}

#' Refresh the quota usage
#'
#' Recompute the quota usage of a project.
#' This is useful on rare occasions where multiple simultaneous uploads cause the usage calculations to be out of sync.
#' 
#' @param project String containing the project name.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a gypsum administrator account.
#'
#' @return Numeric scalar specifying the total quota usage of this project, in bytes.
#'
#' @author Aaron Lun
#' @seealso
#' \code{\link{fetchUsage}}, to get the usage without recomputing it.
#'
#' @examples
#' if (interactive()) {
#'     refreshUsage("test-R")
#' }
#'
#' @export
#' @importFrom jsonlite fromJSON
refreshUsage <- function(project, url=restUrl(), token=accessToken()) {
    req <- request(paste0(url, "/refresh/usage/", uenc(project)))
    req <- req_method(req, "POST")
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)
    resp <- req_perform(req)
    invisible(resp_body_json(resp)$total)
}

#' Fetch project permissions 
#'
#' Fetch the permissions for a project.
#' 
#' @param project String containing the project name.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @return List containing the permissions for this project.
#' This has the following elements:
#' \itemize{
#' \item \code{owners}, a character vector containing the GitHub users or organizations that are owners of this project.
#' \item \code{uploaders}, a list of lists specifying the users or organizations who are authorzied to upload to this project.
#' Each entry is a list with the following fields:
#' \itemize{
#' \item \code{id}, a string containing the GitHub user or organization that is authorized to upload.
#' \item (optional) \code{asset}, a string containing the name of the asset that the uploader is allowed to upload to.
#' If not provided, there is no restriction on the uploaded asset name.
#' \item (optional) \code{version}, a string containing the name of the version that the uploader is allowed to upload to.
#' If not provided, there is no restriction on the uploaded version name.
#' \item (optional) \code{until}, a \link{POSIXct} object containing the expiry date of this authorization.
#' If not provided, the authorization does not expire.
#' \item (optional) \code{trusted}, whether the uploader is trusted.
#' If not provided, defaults to \code{FALSE}.
#' }
#' }
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{setPermissions}}, to set the permissions.
#'
#' @examples
#' fetchPermissions("test-R")
#'
#' @export
fetchPermissions <- function(project, url=restUrl(), config=NULL) {
    perms <- get_json(paste0(project, "/..permissions"), url=url)

    # Converting everything to POSIX dates.
    for (i in seq_along(perms$uploaders)) {
        current <- perms$uploaders[[i]]
        if ("until" %in% names(current)) {
            perms$uploaders[[i]]$until <- .cast_datetime(current$until)
        }
    }

    perms
}

# This tests the various fetching functions.
# library(testthat); library(gypsum); source("setup.R"); source("test-fetch.R")

test_that("fetchManifest works as expected", {
    cache <- tempfile()
    man <- fetchManifest("test-R", "basic", "v1", cache=cache)
    expect_identical(sort(names(man)), c("blah.txt", "foo/bar.txt"))

    # Uses the cache.
    writeLines(con=file.path(cache, "bucket", "test-R", "basic", "v1", "..manifest"), "[]")
    man <- fetchManifest("test-R", "basic", "v1", cache=cache)
    expect_true(length(man) == 0L)

    # Unless we overwrite it.
    man <- fetchManifest("test-R", "basic", "v1", cache=cache, overwrite=TRUE)
    expect_true(length(man) > 0L)

    expect_error(fetchManifest('test-R', 'basic', 'non-existent', cache=cache), "failed to save")
})

test_that("fetchSummary works as expected", {
    cache <- tempfile()
    xx <- fetchSummary("test-R", "basic", "v1", cache=cache)
    original.user <- xx$upload_user_id
    expect_s3_class(xx$upload_start, "POSIXct")
    expect_s3_class(xx$upload_finish, "POSIXct")

    # Uses the cache.
    sumpath <- file.path(cache, "bucket", "test-R", "basic", "v1", "..summary")
    writeLines(
        con=sumpath,
        '{ "upload_user_id": "adrian", "upload_start": "2022-01-01T01:01:01Z", "upload_finish": "2022-01-01T01:01:02Z" }'
    )
    xx <- fetchSummary("test-R", "basic", "v1", cache=cache)
    expect_identical(xx$upload_user_id, "adrian")

    # Unless we overwrite it.
    xx <- fetchSummary("test-R", "basic", "v1", cache=cache, overwrite=TRUE)
    expect_identical(xx$upload_user_id, original.user)

    # Self-deletes from the cache if it's on probation.
    writeLines(
        con=sumpath,
        '{ "upload_user_id": "adrian", "upload_start": "2022-01-01T01:01:01Z", "upload_finish": "2022-01-01T01:01:02Z", "on_probation": true }'
    )
    xx <- fetchSummary("test-R", "basic", "v1", cache=cache)
    expect_true(xx$on_probation)
    expect_false(file.exists(sumpath))

    expect_error(fetchSummary('test-R', 'basic', 'non-existent', cache=cache), "failed to save")
})

test_that("fetchLatest works as expected", {
    expect_identical(fetchLatest("test-R", "basic"), "v3")
})

test_that("fetchUsage works as expected", {
    expect_true(fetchUsage("test-R") > 0)
})

test_that("fetchPermissions works as expected", {
    perms <- fetchPermissions("test-R")
    expect_type(perms$owners, "list")
    expect_type(perms$uploaders, "list")
})

#' List files for a version
#'
#' List files belonging to a version of a project asset.
#'
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param version String containing the version name.
#' @param prefix String containing the remaining prefix for the object key.
#' If provided, a file is only listed if its object key starts with \code{{project}/{asset}/{version}/{prefix}}.
#' If \code{NULL}, all files associated with this version of the asset are listed.
#' @param include.. Logical scalar indicating whether to list files with \code{/..} in their object keys.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @author Aaron Lun
#'
#' @return Character vector of relative paths of files associated with the versioned asset.
#'
#' @examples
#' listFiles("test-R", "basic", "v1")
#' 
#' @export
listFiles <- function(project, asset, version, prefix=NULL, include..=TRUE, url=restUrl(), config=NULL) {
    actual.prefix <- paste(project, asset, version, "", sep="/") # empty string to force trailing slash.
    truncator <- nchar(actual.prefix) + 1L
    if (!is.null(prefix)) {
        actual.prefix <- paste0(actual.prefix, prefix)
    }

    req <- request(paste0(url, "/list?prefix=", uenc(actual.prefix), "&recursive=true"))
    req <- process_error(req)
    res <- req_perform(req)
    out <- unlist(resp_body_json(res))

    out <- substr(out, truncator, nchar(out))
    if (!include..) {
        out <- out[!startsWith(out, "..") & !grepl("\\/\\.\\.", out)]
    }

    out
}

#' Save all files for a version of a project asset
#'
#' Download all files associated with a version of an asset of a project from the gypsum bucket.
#'
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param version String containing the version name.
#' @param cache String containing the path to the cache directory.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#' @param overwrite Logical scalar indicating whether to overwrite existing files in the cache.
#' If \code{FALSE} and the files already exist in \code{cache}, the download is skipped.
#' @param concurrent Integer specifying the number of concurrent downloads.
#' @param relink Logical scalar indicating whether links should be resolved, see \code{\link{resolveLinks}}.
#' 
#' @return The version's files are downloaded to the local file system, and the path to the local subdirectory is returned.
#'
#' @author Aaron Lun
#' 
#' @seealso
#' \code{\link{saveFile}}, to save a single file.
#'
#' \code{\link{cacheDirectory}}, for file caching.
#' 
#' @examples
#' out <- saveVersion("test-R", "basic", "v1")
#' list.files(out, recursive=TRUE, all.files=TRUE)
#' 
#' @export
saveVersion <- function(project, asset, version, cache=cacheDirectory(), overwrite=FALSE, relink=TRUE, concurrent=1, url=restUrl(), config=NULL) {
    acquire_lock(cache, project, asset, version)
    on.exit(release_lock(project, asset, version), add=TRUE, after=FALSE)
    destination <- file.path(cache, BUCKET_CACHE_NAME, project, asset, version)

    # If this version's directory was previously cached in its complete form, we skip it.
    completed <- file.path(cache, "status", project, asset, version, "COMPLETE")

    if (!file.exists(completed) || overwrite) {
        listing <- listFiles(project, asset, version, url=url)
        FUN <- function(x) {
            save_file(
                path=paste(project, asset, version, x, sep="/"), 
                destination=file.path(destination, x), 
                overwrite=overwrite, 
                url=url
            )
        }

        if (concurrent == 1L) {
            lapply(listing, FUN)
        } else {
            cl <- makeCluster(concurrent)
            on.exit(stopCluster(cl), add=TRUE, after=FALSE)
            parLapply(cl, listing, FUN)
        }

        if (relink) {
            resolveLinks(project, asset, version, cache=cache, overwrite=overwrite, url=url)
        }

        # Marking it as complete.
        dir.create(dirname(completed), recursive=TRUE, showWarnings=FALSE)
        write(character(0), file=completed)
    }

    destination
}

#' Set project quota
#' 
#' Set the storage quota for a project.
#'
#' @param project String containing the project name.
#' @param baseline Numeric scalar specifying the baseline quota (i.e., at time zero) in bytes.
#' If \code{NULL}, no change is made to the existing baseline of the project.
#' @param growth Numeric scalar specifying the annual growth rate of the quota, in bytes.
#' If \code{NULL}, no change is made to the existing growth rate of the project.
#' @param year Integer scalar specifying the year of creation (i.e., time zero) for the project.
#' If \code{NULL}, no change is made to the existing creation year of the project.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a gypsum administrator account.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{fetchQuota}}, to fetch the quota.
#'
#' @return \code{NULL} is invisibly returned upon successful setting of the quota.
#'
#' @examples
#' if (interactive()) {
#'     # Creating a project for demonstration purposes.
#'     createProject("test-R-quota", owners="LTLA")
#'
#'     # Setting a baseline of 10 GB with 5 GB in growth per year.
#'     setQuota("test-R-quota", baseline=10^10, growth=5^9, year=2019)
#' }
#'
#' @export
setQuota <- function(project, baseline=NULL, growth=NULL, year=NULL, url=restUrl(), token=accessToken()) {
    url <- chomp_url(url)

    body <- list()
    if (!is.null(baseline)) {
        body$baseline <- baseline
    }
    if (!is.null(growth)) {
        body$growth_rate <- growth
    }
    if (!is.null(year)) {
        body$year <- year
    }

    req <- request(paste0(url, "/quota/", uenc(project)))
    req <- req_method(req, "PUT")
    req <- req_body_json(req, body)
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)

    req_perform(req)
    invisible(NULL)
}

#' Fetch version summary
#'
#' Fetch the summary for a version of an asset of a project.
#'
#' @inheritParams fetchManifest
#'
#' @author Aaron Lun
#' 
#' @return List containing the summary for this version, with the following fields:
#' \itemize{
#' \item \code{upload_user_id}, string containing the identity of the uploader.
#' \item \code{upload_start}, a \link{POSIXct} object containing the upload start time.
#' \item \code{upload_finish}, a \link{POSIXct} object containing the upload finish time.
#' \item \code{on_probation} (optional), a logical scalar indicating whether the upload is probational.
#' If missing, this can be assumed to be \code{FALSE}.
#' }
#' 
#' @examples
#' fetchSummary("test-R", "basic", "v1")
#' 
#' @export
fetchSummary <- function(project, asset, version, cache=cacheDirectory(), overwrite=FALSE, url=restUrl(), config=NULL) {
    out <- get_cacheable_json(
        project, 
        asset, 
        version, 
        "..summary", 
        cache=cache, 
        overwrite=overwrite,
        url=url
    )

    out$upload_start <- .cast_datetime(out$upload_start)
    out$upload_finish <- .cast_datetime(out$upload_finish)

    if (isTRUE(out$on_probation) && !is.null(cache)) {
        # Remove cached entry because it might not be accurate in subsequent calls.
        unlink(file.path(cache, BUCKET_CACHE_NAME, project, asset, version, "..summary"))
    }

    out
}

#' @importFrom utils URLencode
uenc <- function(x) URLencode(x, reserved=TRUE)

chomp_url <- function(url) sub("/*$", "", url)

.cast_datetime <- function(x) {
    zend <- endsWith(x, "Z")

    if (any(zend)) {
        # strptime doesn't know how to handle 'Z' offsets.
        xz <- x[zend]
        x[zend] <- sprintf("%s+0000", substr(xz, 1L, nchar(xz)-1L))
    }

    if (!all(zend)) {
        # Remove colon in the timezone, which confuses as.POSIXct().
        x[!zend] <- sub(":([0-9]{2})$", "\\1", x[!zend])
    }

    # Remove fractional seconds.
    x <- sub("\\.[0-9]+", "", x)

    as.POSIXct(x, format="%Y-%m-%dT%H:%M:%S%z")
}

sanitize_uploaders <- function(uploaders) {
    for (i in seq_along(uploaders)) {
        current <- uploaders[[i]]
        if ("until" %in% names(current)) {
            uploaders[[i]]$until <- sub("([0-9]{2})$", ":\\1", strftime(current$until, "%Y-%m-%dT%H:%M:%S%z"))
        }
    }
    uploaders
}

#' @import httr2
#' @importFrom jsonlite toJSON
process_error <- function(req) {
    req_error(req, body = function(res) {
        if (identical(resp_content_type(res), "application/json")) {
            payload <- resp_body_json(res)
            if ("reason" %in% names(payload)) {
                return(payload$reason)
            }
        }
        return(resp_body_string(res))
    })
}

#' @import httr2
get_json <- function(path, url) {
    req <- request(paste0(url, "/file/", uenc(path)))
    req <- process_error(req)
    res <- req_perform(req)
    resp_body_json(res)
}

save_file <- function(path, destination, overwrite, url, error=TRUE) {
    if (overwrite || !file.exists(destination)) {
        dir.create(dirname(destination), recursive=TRUE, showWarnings=FALSE)

        # We use a write-and-rename approach to avoid problems with interrupted
        # downloads that make it seem as if the cache is populated.
        tmp <- tempfile(tmpdir=dirname(destination))
        on.exit(unlink(tmp), add=TRUE, after=FALSE)

        status <- tryCatch(
            {
                req <- request(paste0(url, "/file/", uenc(path)))
                req <- process_error(req)
                res <- req_perform(req, path=tmp)
            },
            error=function(e) e$message
        )

        if (is.character(status)) {
            if (error) {
                stop("failed to save '", path, "'; ", status)
            } else {
                return(FALSE)
            }
        }

        rename_file(tmp, destination)
    }

    return(TRUE)
}

rename_file <- function(src, dest) {
    if (!file.rename(src, dest) && !file.copy(src, dest)) {
        stop("cannot move temporary file for '", src, "' to its destination '", dest, "'")
    }
}

#' @import httr2
download_and_rename_file <- function(url, dest) {
    # Using the usual write-and-rename strategy.
    tmp <- tempfile(tmpdir=dirname(dest))
    on.exit(unlink(tmp), add=TRUE, after=FALSE)
    req <- request(url)
    req_perform(req, path=tmp)
    rename_file(tmp, dest)
}

BUCKET_CACHE_NAME <- 'bucket'

#' @importFrom jsonlite fromJSON
get_cacheable_json <- function(project, asset, version, path, cache, url, overwrite) {
    bucket_path <- paste(project, asset, version, path, sep="/")
    if (is.null(cache)) {
        get_json(bucket_path, url=url)
    } else {
        out <- file.path(cache, BUCKET_CACHE_NAME, project, asset, version, path)
        acquire_lock(cache, project, asset, version)
        on.exit(release_lock(project, asset, version), add=TRUE, after=FALSE)
        save_file(bucket_path, destination=out, overwrite=overwrite, url=url)
        fromJSON(out, simplifyVector=FALSE)
    }
}

is.locked <- new.env()
is.locked$locks <- list()

#' @importFrom filelock lock
acquire_lock <- function(cache, project, asset, version) {
    key <- paste(project, asset, version, sep="/")
    if (is.null(is.locked$locks[[key]])) {
        lockloc <- file.path(cache, "status", project, asset, version, "LOCK")
        dir.create(dirname(lockloc), recursive=TRUE, showWarnings=FALSE)
        is.locked$locks[[key]] <- lock(lockloc)
    }
}

#' @importFrom filelock unlock
release_lock <- function(project, asset, version) {
    key <- paste(project, asset, version, sep="/")
    if (!is.null(is.locked$locks[[key]])) {
        unlock(is.locked$locks[[key]])
        is.locked$locks[[key]] <- NULL
    }
}

list_for_prefix <- function(prefix, url) {
    url <- paste0(url, "/list")
    if (!is.null(prefix)) {
        url <- paste0(url, "?prefix=", uenc(prefix))
    }

    req <- request(url)
    req <- process_error(req)
    res <- req_perform(req)
    out <- unlist(resp_body_json(res))

    if (is.null(out)) {
        out <- character(0)
    }

    out <- out[endsWith(out, "/")]
    if (!is.null(prefix)) {
        out <- substr(out, nchar(prefix) + 1L, nchar(out) - 1L)
    } else {
        out <- substr(out, 1L, nchar(out) - 1L)
    }
    out[!startsWith(out, "..")]
}

sanitize_path <- function(x) {
    if (.Platform$OS.type == "windows") {
        x <- gsub("\\\\", "/", x)
    }
    gsub("//+", "/", x)
}

# Test some miscellaneous functions.
# library(testthat); library(gypsum); source("test-misc.R")

test_that("restUrl works as expected", {
    old <- restUrl("FOO")
    expect_identical(restUrl(), "FOO")
    reset <- restUrl(old)
    expect_identical(old, restUrl())
})

test_that("cacheDirectory works as expected", {
    old <- cacheDirectory("FOO")
    expect_identical(cacheDirectory(), "FOO")
    reset <- cacheDirectory(old)
    expect_identical(old, cacheDirectory())
})

test_that("publicS3Config caches as expected", {
    cache <- tempfile()
    out <- publicS3Config(cache=cache)
    expect_type(out$endpoint, "character")
    disked <- file.path(cache, "credentials", "s3.json")
    expect_true(file.exists(disked))

    # Reloads from disk perfectly well.
    cache2 <- tempfile()
    dir.create(file.path(cache2, "credentials"), recursive=TRUE)
    file.copy(disked, file.path(cache2, "credentials", "s3.json"))
    out2 <- publicS3Config(cache=cache2)
    expect_identical(out, out2)

    # Subsequent requests just re-use the in-memory cache.
    unlink(disked)
    reout <- publicS3Config(cache=cache)
    expect_identical(reout, out)
    expect_false(file.exists(disked))

    # ... unless we force a refresh.
    reout <- publicS3Config(refresh=TRUE, cache=cache)
    expect_true(file.exists(disked))

    # Works without any caching.
    uout <- publicS3Config(cache=NULL)
    expect_type(out$endpoint, "character")
    reuout <- publicS3Config(cache=NULL)
    expect_identical(uout, reuout)
})

test_that("URL chomper works as expected", {
    expect_identical(gypsum:::chomp_url("https://asdasd.com/asdasd"), "https://asdasd.com/asdasd")
    expect_identical(gypsum:::chomp_url("https://asdasd.com/asdasd//"), "https://asdasd.com/asdasd")
})

test_that("URL encoder works as expected", {
    expect_identical(gypsum:::uenc('asd/asdas'), "asd%2Fasdas")
})

test_that("S3 credential request works as expected", {
    out <- publicS3Config()
    expect_type(out$endpoint, "character")
    expect_type(out$key, "character")
    expect_type(out$secret, "character")
    expect_type(out$bucket, "character")
})

test_that("casting of datetimes works as expected", {
    out <- gypsum:::.cast_datetime("2023-12-04T14:41:19+01:00")
    expect_false(is.na(out))

    # Behaves with fractional seconds.
    out <- gypsum:::.cast_datetime("2023-12-04T14:41:19.21323+01:00")
    expect_false(is.na(out))

    # Behaves with 'Z'.
    out <- gypsum:::.cast_datetime("2023-12-04T14:41:19Z")
    expect_false(is.na(out))
})

#' Fetch the latest version
#'
#' Fetch the latest version of a project's asset.
#' 
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @return String containing the latest version of the project.
#'
#' @author Aaron Lun
#'
#' @examples
#' fetchLatest("test-R", "basic")
#'
#' @seealso
#' \code{\link{refreshLatest}}, to refresh the latest version.
#'
#' @export
fetchLatest <- function(project, asset, url=restUrl(), config=NULL) { 
    vers <- get_json(paste(project, asset, "..latest", sep="/"), url=url)
    vers$version
}

# This tests the latest refresher functions 
# library(testthat); library(gypsum); source("setup.R"); source("test-latest.R")

test_that("latest setting works as expected", {
    skip_if(is.na(gh_token))
    v <- refreshLatest("test-R", "basic")
    expect_identical(v, "v3")
    expect_identical(fetchLatest("test-R", "basic"), v)
})

#' Fetch a metadata database
#'
#' Fetch a SQLite database containing metadata from the gypsum backend
#' (see \url{https://github.com/ArtifactDB/bioconductor-metadata-index}).
#' Each database is generated by aggregating metadata across multiple assets and/or projects,
#' and can be used to perform searches for interesting objects.
#'
#' @param name String containing the name of the database.
#' This can be the name of any SQLite file in \url{https://github.com/ArtifactDB/bioconductor-metadata-index/releases/tag/latest}.
#' @param cache String containing the cache directory.
#' If \code{NULL}, no caching is performed.
#' @param overwrite Logical scalar indicating whether to overwrite an existing file in \code{cache}, if one is present.
#'
#' @return String containing a path to the downloaded database.
#'
#' @author Aaron Lun
#'
#' @details
#' This function will automatically check for updates to the SQLite files and will download new versions accordingly.
#' New checks are performed when one hour or more has elapsed since the last check.
#' If the check fails, a warning is raised and the function returns the currently cached file.
#'
#' @seealso
#' \code{\link{fetchMetadataSchema}}, to get the JSON schema used to define the database tables.
#' 
#' @examples
#' fetchMetadataDatabase()
#' @export
#' @importFrom filelock lock unlock
fetchMetadataDatabase <- function(name="bioconductor.sqlite3", cache=cacheDirectory(), overwrite=FALSE) {
    base.url <- "https://github.com/ArtifactDB/bioconductor-metadata-index/releases/download/latest/"

    if (is.null(cache)) {
        cache.path <- tempfile(fileext=".sqlite3")
    } else {
        cache.dir <- file.path(cache, "databases")
        cache.path <- file.path(cache.dir, name)
        dir.create(dirname(cache.path), showWarnings=FALSE, recursive=TRUE)

        if (file.exists(cache.path) && !overwrite) {
            # Seeing if we can acquire the lock, just to make sure that
            # no other process is downloading a new file at the same time.
            old_lastmod_raw <- (function() {
                flck <- lock(paste0(cache.path, ".LOCK"), exclusive=FALSE)
                on.exit(unlock(flck), add=TRUE, after=FALSE)
                readLines(paste0(cache.path, ".modified"), warn=FALSE)
            })()

            # Only returning the cached file if there haven't been any changes.
            old_lastmod <- as.double(old_lastmod_raw)
            new_lastmod <- get_last_modified_date(base.url)
            if (!is.null(new_lastmod) && old_lastmod == new_lastmod) {
                return(cache.path)
            }
        }
    }

    flck <- lock(paste0(cache.path, ".LOCK"))
    on.exit(unlock(flck), add=TRUE, after=FALSE)
    mod.path <- paste0(cache.path, ".modified")
    download_and_rename_file(paste0(base.url, "modified"), mod.path)
    download_and_rename_file(paste0(base.url, name), cache.path)

    last_check$req_time <- get_current_unix_time()
    last_check$mod_time <- as.double(readLines(mod.path, warn=FALSE))

    cache.path
}

last_check <- new.env()
last_check$req_time <- NULL
last_check$mod_time <- NULL

get_current_unix_time <- function() {
    as.double(Sys.time()) * 1000 # get to milliseconds
}

get_last_modified_date <- function(base.url) {
    # Only make a new request if an hour has elapsed; and even
    # then, don't sweat it if it fails, we'll just return NULL.
    curtime <- get_current_unix_time()
    if (!is.null(last_check$req_time) && last_check$req_time + 60 * 60 * 1000 >= curtime) {
        return(last_check$mod_time)
    }

    mod_time <- tryCatch({
        url <- paste0(base.url, "modified")
        req <- request(url)
        resp <- req_perform(req)
        as.double(resp_body_string(resp))
    }, error=function(e) {
        warning("failed to check the last modified timestamp; ", as.character(e))
        NULL
    })

    if (!is.null(mod_time)) {
        last_check$req_time <- curtime
        last_check$mod_time <- mod_time
    }
    mod_time
}

#' Upload files for a versioned asset
#'
#' Upload files in an initialized upload session for a version of an asset.
#'
#' @param init List containing \code{file_urls} and \code{session_token}.
#' This is typically the return value from \code{\link{startUpload}}.
#' @inheritParams startUpload
#' @param concurrent Integer specifying the number of concurrent uploads.
#' 
#' @return \code{NULL} is invisibly returned on successful upload of all files.
#' 
#' @seealso
#' \code{\link{startUpload}}, to create \code{init}.
#' 
#' @author Aaron Lun
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#' write(file=file.path(tmp, "blah.txt"), LETTERS)
#' dir.create(file.path(tmp, "foo"))
#' write(file=file.path(tmp, "foo", "bar.txt"), 1:10)
#'
#' if (interactive()) {
#'     init <- startUpload(
#'         project="test-R", 
#'         asset="upload-files-check", 
#'         version="v1", 
#'         files=list.files(tmp, recursive=TRUE),
#'         directory=tmp
#'     )
#' 
#'     # Executing the upload for all files.
#'     uploadFiles(init, directory=tmp)
#'
#'     # Cleaning up after we're done.
#'     abortUpload(init) 
#' }
#'
#' @export
#' @importFrom parallel makeCluster stopCluster parLapply
uploadFiles <- function(init, directory=NULL, url=restUrl(), concurrent=1) {
    url <- chomp_url(url)
    if (concurrent <= 1) {
        lapply(init$file_urls, .upload_file, directory=directory, url=url, token=init$session_token)
    } else {
        cl <- makeCluster(concurrent)
        on.exit(stopCluster(cl), add=TRUE, after=FALSE)
        parLapply(cl, init$file_urls, .upload_file, directory=directory, url=url, token=init$session_token)
    }
    invisible(NULL)
}

#' @import httr2
.upload_file <- function(info, directory, url, token) {
    path <- info$path
    if (!is.null(directory)) {
        path <- file.path(directory, path)
    }

    if (info$method == "presigned") {
        req <- request(paste0(url, info$url))
        req <- req_method(req, "POST")
        req <- req_auth_bearer_token(req, token)
        req <- process_error(req)
        res <- req_perform(req)
        presigned <- resp_body_json(res)

        req2 <- request(presigned$url)
        req2 <- req_method(req2, "PUT")
        req2 <- req_body_file(req2, path)
        req2 <- req_headers(req2, `Content-MD5`=presigned$md5sum_base64)
        req_perform(req2)

    } else {
        stop("unknown upload method '", info$method, "' for file '", info$path, "'")
    }
}

creds.env <- new.env()
creds.env$uncached <- NULL
creds.env$info <- list()

config_cache_path <- function(cache) {
    file.path(cache, "credentials", "s3.json")
}

#' Public S3 configuration
#'
#' Fetch S3 credentials and other configuration details for read-only access to the underlying gypsum bucket.
#'
#' @param refresh Logical scalar indicating whether to refresh the credentials in the in-memory cache.
#' @param url String containing a URL to the gypsum REST API.
#' @param cache String containing a path to the cache directory, to store the configuration across R sessions.
#'
#' @return List containing:
#' \itemize{
#' \item \code{key}, a string containing the read-only S3 access key ID.
#' \item \code{secret}, a string containing the associated S3 access secret.
#' \item \code{bucket}, a string containing the name of the bucket.
#' \item \code{endpoint}, a string containing the URL for the S3 API.
#' }
#'
#' @details
#' The configuration is obtained through a query to \code{url} on the first use of this function.
#' The result is automatically cached in memory and on disk to reduce the number of network requests to the API.
#' New credentials are automatically fetched if the on-disk cache is older than a week;
#' this refresh can be performed manually by calling this function with \code{refresh=TRUE}.
#'
#' @author Aaron Lun
#'
#' @examples
#' publicS3Config()
#'
#' @export
#' @import httr2
#' @importFrom jsonlite fromJSON
#' @importFrom filelock lock unlock
publicS3Config <- function(refresh = FALSE, url=restUrl(), cache=cacheDirectory()) {
    if (!refresh) {
        if (is.null(cache)) {
            creds <- creds.env$uncached
            if (!is.null(creds)) {
                return(creds)
            }
        } else {
            # We use 'cache'-specific credentials here, so that the behavior of the
            # in-memory cache is consistent with the behavior of the on-disk cache
            # at 'cache'. I suppose this is useful just in case people have
            # different cache locations for different 'url' calls.
            creds <- creds.env$info[[cache]]
            if (!is.null(creds)) {
                return(creds)
            }

            config.path <- config_cache_path(cache)
            if (file.exists(config.path)) {
                creds <- (function() {
                    # Lock inside a function to guarantee unlocking prior to the later lock() call.
                    lck <- lock(paste0(config.path, ".LOCK"), exclusive=FALSE)
                    on.exit(unlock(lck), add=TRUE, after=FALSE)
                    fromJSON(config.path, simplifyVector=FALSE)
                })()

                # Only using these configuration parameters if they are less than a week old. 
                if (difftime(Sys.time(), file.info(config.path)$ctime, units="weeks") <= 1) {
                    creds.env$info[[cache]] <- creds
                    return(creds)
                }
            }
        }
    }

    req <- request(paste0(url, "/credentials/s3-api"))
    res <- req_perform(req)
    creds <- resp_body_json(res)

    if (is.null(cache)) {
        creds.env$uncached <- creds
    } else {
        creds.env$info[[cache]] <- creds
        config.path <- config_cache_path(cache)
        dir.create(dirname(config.path), showWarnings=FALSE, recursive=TRUE)
        lck <- lock(paste0(config.path, ".LOCK"))
        on.exit(unlock(lck), add=TRUE, after=FALSE)
        write(file=config.path, toJSON(creds, auto_unbox=TRUE))
    }

    creds
}

#' Clone a version's directory structure
#'
#' Clone the directory structure for a versioned asset into a separate location.
#' This is typically used to prepare a new version for a lightweight upload.
#' 
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param version String containing the version name.
#' @param destination String containing a path to a destination directory at which to create the clone.
#' @param download Logical scalar indicating whether the version's files should be downloaded first.
#' This can be set to \code{FALSE} to create a clone without actually downloading any of the version's files.
#' @param cache String containing the path to the cache directory.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#' @param ... Further arguments to pass to \code{\link{saveVersion}}.
#' Only used if \code{download=TRUE}.
#'
#' @return The directory structure of the specified version is cloned to \code{destination},
#' and a \code{NULL} is invisibly returned.
#'
#' @details
#' Cloning of a versioned asset involves creating a directory at \code{destination} that has the same contents as the corresponding project-asset-version directory.
#' All files in the specified version are represented as symlinks from \code{destination} to the corresponding file in the \code{cache}. 
#' The idea is that, when \code{destination} is used in \code{\link{prepareDirectoryUpload}}, 
#' the symlinks are converted into upload links, i.e., \code{links=} in \code{\link{startUpload}}.
#' This allows users to create new versions very cheaply as duplicate files are not uploaded to/stored in the backend.
#'
#' Users can more-or-less do whatever they want inside the cloned \code{destination}, but they should treat the symlink targets as read-only.
#' That is, they should not modify the contents of the linked-to file, as these refer to assumed-immutable files in the \code{cache}.
#' If a file in \code{destination} needs to be modified, the symlink should be deleted and replaced with an actual file;
#' this avoids mutating the \code{cache} and it ensures that \code{\link{prepareDirectoryUpload}} recognizes that a new file actually needs to be uploaded.
#'
#' Advanced users can set \code{download=FALSE}, in which case symlinks are created even if their targets are not present in \code{cache}.
#' In such cases, \code{destination} should be treated as write-only due to the potential presence of dangling symlinks.
#' This mode is useful for uploading a new version of an asset without downloading the files from the existing version,
#' assuming that the modifications associated with the former can be achieved without reading any of the latter.
#'
#' On Windows, the user may not have permissions to create symbolic links, so the function will transparently fall back to creating hard links or copies instead.
#' This precludes any optimization by \code{\link{prepareDirectoryUpload}} as the hard links/copies cannot be converted into upload links.
#' It also assumes that \code{download=TRUE} as dangling links/copies cannot be created.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{prepareDirectoryUpload}}, to prepare an upload based on the directory contents.
#'
#' @examples
#' tmp <- tempfile()
#' out <- cloneVersion("test-R", "basic", "v1", destination=tmp)
#' list.files(tmp, recursive=TRUE)
#' Sys.readlink(file.path(tmp, "foo", "bar.txt"))
#'
#' # Files should be replaced rather than modified via the symlink:
#' existing <- file.path(tmp, "foo", "bar.txt")
#' unlink(existing) # Deleting the symlink...
#' write(file=existing, "YAY") # ... and writing a replacement file.
#'
#' # Symlinks are converted to upload links:
#' prepareDirectoryUpload(tmp)
#' @export
cloneVersion <- function(project, asset, version, destination, download=TRUE, cache=cacheDirectory(), url=restUrl(), config=NULL, ...) {
    if (download) {
        saveVersion(project, asset, version, cache=cache, url=url, ...)
    }

    final.cache <- file.path(cache, BUCKET_CACHE_NAME, project, asset, version)
    listing <- fetchManifest(project, asset, version, cache=cache, url=url)
    dir.create(destination, recursive=TRUE, showWarnings=FALSE)

    # Only run this after the manifest has been fetched,
    # as this guarantees that the cache exists.
    final.cache <- normalizePath(final.cache, mustWork=TRUE)

    # Create symlinks back to the cache.
    for (x in names(listing)) {
        dpath <- file.path(destination, x)
        dir.create(dirname(dpath), recursive=TRUE, showWarnings=FALSE)
        target <- file.path(final.cache, x)
        file.symlink(target, dpath)

        # It's perfectly acceptable to create dangling links, so we can't use
        # the output of file.symlink to check success. We also can't use
        # file.exists as this attempts to follow symbolic links.
        link.exists <- basename(dpath) %in% list.files(dirname(dpath), all.files=TRUE)
        if (!link.exists) {
            if (.Platform$OS.type != "windows") {
                stop("failed to create a symbolic link to '", target, "' at '", dpath, "'")
            } else if (!file.link(target, dpath) && !file.copy(target, dpath)) {
                # Of course Windows has its own little shenanigans whereby
                # symbolic links aren't supported, so we have to smoothly fall
                # back to hard links/copies instead.
                stop("failed to create a hard link to '", target, "' at '", dpath, "'")
            }
        }
    }

    invisible(NULL)
}

# This checks the cloneVersion function.
# library(testthat); library(gypsum); source("test-prepareDirectoryUpload.R")

test_that("prepareDirectoryUpload works as expected", {
    cache <- tempfile()
    dest <- tempfile()
    cloneVersion("test-R", "basic", "v1", destination=dest, cache=cache)
    write(file=file.path(dest, "heanna"), "sumire")

    prepped <- prepareDirectoryUpload(dest, cache=cache)
    if (.Platform$OS.type == "windows") { # because windows doesn't have guaranteed support for symbolic links.
        expect_identical(prepped$files, c("blah.txt", "foo/bar.txt", "heanna"))
        expect_identical(nrow(prepped$links), 0L)
    } else {
        expect_identical(prepped$files, "heanna")
        expect_identical(prepped$links$from.path, c("blah.txt", "foo/bar.txt"))
        expect_identical(prepped$links$to.project, rep("test-R", 2))
        expect_identical(prepped$links$to.asset, rep("basic", 2))
        expect_identical(prepped$links$to.version, rep("v1", 2))
        expect_identical(prepped$links$to.path, c("blah.txt", "foo/bar.txt"))
    }

    prepped <- prepareDirectoryUpload(dest, cache=cache, links="never")
    expect_identical(prepped$files, c("blah.txt", "foo/bar.txt", "heanna"))
    expect_identical(nrow(prepped$links), 0L)
})

test_that("prepareDirectoryUpload works with some odd things", {
    skip_on_os("windows") # giving up on flaky support for symbolic links on Windows.

    cache <- tempfile()
    dest <- tempfile()
    cloneVersion("test-R", "basic", "v1", destination=dest, cache=cache)

    write(file=file.path(dest, "..check"), "stuff") # check that we ignore hidden files.
    random <- tempfile()
    file.symlink(random, file.path(dest, "arkansas")) # create a dangling link to a non-cache file.

    expect_error(prepareDirectoryUpload(dest, cache=cache, links="always"), "failed to convert")
    expect_error(prepareDirectoryUpload(dest, cache=cache, links="never"), "cannot use a dangling link")
    expect_error(prepareDirectoryUpload(dest, cache=cache), "cannot use a dangling link")

    write(file=random, "YAY") # make it non-dangling, and check that it is sucked in properly.
    prepped <- prepareDirectoryUpload(dest, cache=cache)
    expect_identical(prepped$files, "arkansas")
    expect_identical(prepped$links$from.path, c("blah.txt", "foo/bar.txt"))
})

test_that("prepareDirectoryUpload handles dangling links correctly", {
    skip_on_os("windows") # giving up on flaky support for symbolic links on Windows.

    cache <- tempfile()
    dest <- tempfile()
    cloneVersion("test-R", "basic", "v1", destination=dest, cache=cache, download=FALSE)

    prepped <- prepareDirectoryUpload(dest, cache=cache)
    expect_identical(prepped$files, character(0))
    expect_identical(nrow(prepped$links), 2L)

    expect_error(prepareDirectoryUpload(dest, cache=cache, links="never"), "cannot use a dangling link")
})

# This checks the cloneVersion function.
# library(testthat); library(gypsum); source("test-cloneVersion.R")

test_that("cloneVersion works as expected with existing files", {
    cache <- tempfile()
    dest <- tempfile()
    out <- cloneVersion("test-R", "basic", "v1", destination=dest, cache=cache)

    d1 <- file.path(dest, "blah.txt")
    if (.Platform$OS.type != "windows") { # as windows might not support symbolic links.
        l1 <- Sys.readlink(d1)
        expect_true(file.exists(l1))
        expect_true(endsWith(l1, "test-R/basic/v1/blah.txt"))
    } else {
        expect_true(file.exists(d1))
    }

    d2 <- file.path(dest, "foo/bar.txt")
    if (.Platform$OS.type != "windows") {
        l2 <- Sys.readlink(d2)
        expect_true(file.exists(l2))
        expect_true(endsWith(l2, "test-R/basic/v1/foo/bar.txt"))
    } else {
        expect_true(file.exists(d2))
    }
})

test_that("cloneVersion happily works without any download", {
    skip_on_os("windows") # download=FALSE can't work on windows if symbolic links aren't available.

    cache <- tempfile()
    dest <- tempfile()
    out <- cloneVersion("test-R", "basic", "v1", download=FALSE, destination=dest, cache=cache)

    l1 <- Sys.readlink(file.path(dest, "blah.txt"))
    expect_true(endsWith(l1, "test-R/basic/v1/blah.txt"))
    expect_false(file.exists(l1))

    l2 <- Sys.readlink(file.path(dest, "foo/bar.txt"))
    expect_true(endsWith(l2, "test-R/basic/v1/foo/bar.txt"))
    expect_false(file.exists(l2))
})

test_that("cloneVersion works correctly if version itself contains links", {
    skip_on_os("windows") # download=FALSE can't work on windows if symbolic links aren't available.

    cache <- tempfile()
    dest <- tempfile()
    out <- cloneVersion("test-R", "basic", "v2", destination=dest, cache=cache, download=FALSE, relink=FALSE)

    l1 <- Sys.readlink(file.path(dest, "blah.txt"))
    expect_true(endsWith(l1, "test-R/basic/v2/blah.txt"))
    expect_false(file.exists(l1))

    l2 <- Sys.readlink(file.path(dest, "foo/bar.txt"))
    expect_true(endsWith(l2, "test-R/basic/v2/foo/bar.txt"))
    expect_false(file.exists(l2))
})

#' List all projects
#'
#' List all projects in the gypsum backent.
#'
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @author Aaron Lun
#'
#' @return Character vector of project names.
#'
#' @examples
#' if (interactive()) {
#'     listProjects()
#' }
#' 
#' @export
listProjects <- function(url=restUrl(), config=NULL) {
    list_for_prefix(NULL, url=url)
}

#' Cache directory
#'
#' Specify the cache directory in the local filesystem for gypsum-related data. 
#'
#' @param dir String containing the path to a cache directory.
#'
#' @return If \code{dir} is missing, the current setting of the cache directory is returned.
#'
#' If \code{dir} is provided, it is used to replace the current setting of the cache directory,
#' and the \emph{previous} setting is invisibly returned.
#'
#' @details
#' If the \code{GYPSUM_CACHE_DIR} environment variable is set before the first call to \code{\link{cacheDirectory}}, it is used as the initial location of the cache directory.
#' Otherwise, the initial location is based on \code{\link{R_user_dir}}. 
#'
#' @author Aaron Lun
#'
#' @examples
#' cacheDirectory()
#' old <- cacheDirectory(tempfile())
#' cacheDirectory()
#' cacheDirectory(old) # setting it back.
#'
#' @export
#' @importFrom rappdirs user_cache_dir
cacheDirectory <- (function() {
    current <- NULL
    function(dir) {
        if (is.null(current)) {
            location <- Sys.getenv("GYPSUM_CACHE_DIR", user_cache_dir("gypsum", "ArtifactDB"))
            assign("current", location, envir=parent.env(environment()))
        }
        if (missing(dir)) {
            return(current)
        } else {
            prev <- current
            assign("current", dir, envir=parent.env(environment()))
            return(invisible(prev))
        }
    }
})()

#' Unlock a project
#'
#' Unlock a project on the gypsum backend.
#' This is typically caused by a partial upload that was not properly aborted.
#'
#' @param project String containing the project to remove.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a gypsum administrator account.
#'
#' @return \code{NULL} is invisibly returned if the project was successfully removed. 
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{abortUpload}}, to correctly abort an upload upon failure.
#'
#' @examples
#' if (interactive()) {
#'     unlockProject("test-R")
#' }
#' @export
unlockProject <- function(project, url=restUrl(), token=accessToken()) {
    url <- chomp_url(url)
    req <- request(paste0(url, "/unlock/", project))
    req <- req_method(req, "DELETE")
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)

    req_perform(req)
    invisible(NULL)
}

# This tests the latest refresher functions 
# library(testthat); library(gypsum); source("setup.R"); source("test-unlockProject.R")

test_that("project unlocking works as expected", {
    skip_if(is.na(gh_token))
    expect_error(unlockProject("test-R"), NA)
})

#' URL for the REST API
#'
#' Get or set the URL for the gypsum REST API.
#'
#' @param url String containing the URL of the REST API.
#'
#' @return If \code{url} is missing, the current setting of the URL is returned.
#'
#' If \code{url} is provided, it is used to replace the current setting of the URL,
#' and the \emph{previous} setting of the URL is invisibly returned.
#'
#' @author Aaron Lun
#' @examples
#' restUrl()
#' old <- restUrl("https://some-other.rest-api.io") # replace it.
#' restUrl()
#' restUrl(old) # setting it back.
#' @export
restUrl <- (function() {
    current <- "https://gypsum.artifactdb.com"
    function(url) {
        if (missing(url)) {
            return(current)
        } else {
            prev <- current
            assign("current", url, envir=parent.env(environment()))
            return(invisible(prev))
        }
    }
})()

#' Set project permissions 
#' 
#' Set the owner and uploader permissions for a project.
#'
#' @param project String containing the project name.
#' @param owners Character vector containing the GitHub users or organizations that are owners of this project.
#' If \code{NULL}, no change is made to the existing owners of the project.
#' @param uploaders List specifying the authorized uploaders for this project.
#' See the \code{uploaders} field in the \code{\link{fetchPermissions}} return value for the expected format. 
#' If \code{NULL}, no change is made to the existing uploaders of the project.
#' @param append Logical scalar indicating whether \code{owners} and \code{uploaders} should be appended to the existing owners and uploaders, respectively, of the project.
#' If \code{FALSE}, the \code{owners} and \code{uploaders} are used to replace the existing values.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to an owner of the \code{project}.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{fetchPermissions}}, to fetch the permissions.
#'
#' @return \code{NULL} is invisibly returned upon successful setting of the permissions.
#'
#' @examples
#' if (interactive()) {
#'     # Creating a project for demonstration purposes.
#'     createProject("test-R-perms", owners="LTLA")
#'
#'     # Setting extra permissions on this project.
#'     setPermissions("test-R-perms",
#'         owners="jkanche", 
#'         uploaders=list(list(id="lawremi", until=Sys.time() + 1000))
#'     )
#' }
#'
#' @export
setPermissions <- function(project, owners=NULL, uploaders=NULL, append=TRUE, url=restUrl(), token=accessToken()) {
    url <- chomp_url(url)

    perms <- list()
    if (append) {
        old.perms <- fetchPermissions(project, url=url)
        if (!is.null(owners)) {
            perms$owners <- as.list(union(unlist(old.perms$owners), owners))
        }
        if (!is.null(uploaders)) {
            perms$uploaders <- c(old.perms$uploaders, uploaders)
        }
    } else {
        if (!is.null(owners)) {
            perms$owners <- as.list(owners)
        }
        if (!is.null(uploaders)) {
            perms$uploaders <- uploaders 
        }
    }

    if (!is.null(perms$uploaders)) {
        perms$uploaders <- sanitize_uploaders(perms$uploaders)
    }

    req <- request(paste0(url, "/permissions/", uenc(project)))
    req <- req_method(req, "PUT")
    req <- req_body_json(req, perms)
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)

    req_perform(req)
    invisible(NULL)
}

#' Refresh the latest version
#'
#' Recompute the latest version of a project's asset.
#' This is useful on rare occasions where multiple simultaneous uploads cause the latest version to be slightly out of sync.
#' 
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a gypsum administrator account.
#'
#' @return String containing the latest version of the project, or \code{NULL} if there are no non-probational versions.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{fetchLatest}}, to get the latest version without recomputing it.
#' 
#' @examples
#' if (interactive()) {
#'     refreshLatest("test-R", "basic")
#' }
#'
#' @export
#' @importFrom jsonlite fromJSON
refreshLatest <- function(project, asset, url=restUrl(), token=accessToken()) {
    req <- request(paste0(url, "/refresh/latest/", uenc(project), "/", uenc(asset)))
    req <- req_method(req, "POST")
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)
    resp <- req_perform(req)
    invisible(resp_body_json(resp)$version)
}

#' Search the metadata database
#'
#' Search a SQLite database containing metadata from the gypsum backend.
#' This is based on a precomputed tokenization of all string properties in each metadata document;
#' see \url{https://github.com/ArtifactDB/bioconductor-metadata-index} for details.
#'
#' @param query A gypsum.search.clause object, typically produced by \code{gsc} or \code{\link{translateTextQuery}}.
#' @param path For \code{searchMetadata}, a string containing a path to a SQLite file, usually obtained via \code{\link{fetchMetadataDatabase}}.
#' 
#' For \code{gsc}, the suffix of the object key of the metadata document, 
#' i.e., the relative \dQuote{path} to the metadata file inside the version's \dQuote{directory}.
#' This may be missing as long as other arguments are supplied to \code{gsc}.
#' @param latest Logical scalar indicating whether to only search for matches within the latest version of each asset.
#' @param include.metadata Logical scalar indicating whether metadata should be returned.
#' @param pid.name String containing the name/alias of the column of the \code{paths} table that contains the path ID.
#' @param project.name String containing the name/alias of the column of the \code{versions} table that contains the project name.
#' @param asset.name String containing the name/alias of the column of the \code{versions} table that contains the asset name.
#' @param version.name String containing the name/alias of the column of the \code{versions} table that contains the version name.
#' @param path.name String containing the name/alias of the column of the \code{paths} table that contains the path name.
#' @param user.name String containing the name/alias of the column of the \code{versions} table that contains the user ID of the uploader.
#' @param time.name String containing the name/alias of the column of the \code{versions} table that contains the upload time.
#' @param text String containing the text to query on.
#' This will be automatically tokenized, see Details.
#' This may be missing as long as other arguments are supplied to \code{gsc}.
#' @param project String containing the name of the project.
#' This may be missing as long as other arguments are supplied to \code{gsc}.
#' @param asset String containing the name of the asset.
#' This may be missing as long as other arguments are supplied to \code{gsc}.
#' @param version String containing the name of the version.
#' This may be missing as long as other arguments are supplied to \code{gsc}.
#' @param user String containing the user ID of the uploader.
#' This may be missing as long as other arguments are supplied to \code{gsc}.
#' @param time Number specifying the Unix timestamp (in seconds) at which the upload was finished.
#' This may be missing as long as other arguments are supplied to \code{gsc}.
#' @param field String specifying the name of the metadata field in which to search for \code{text}.
#' If \code{NULL}, the search is performed on all available metadata fields.
#' @param partial For \code{gsc}, a logical scalar indicating whether \code{text}, \code{project}, \code{asset}, \code{version}, \code{path} or \code{user} 
#' contains SQLite wildcards (\code{\%}, \code{_}) for a partial search.
#' For \code{text}, setting \code{partial=TRUE} also ensures that the wildcards are preserved during tokenization.
#' @param after Logical scalar indicating whether to search for documents that were uploaded after \code{time}.
#' If \code{FALSE}, the search will instead consider documents that were uploaded at or before \code{time}.
#'
#' @return 
#' For \code{searchMetadata}, a data frame specifying the contaning the search results.
#' \itemize{
#' \item The \code{project}, \code{asset} and \code{version} columns specify the version of the project asset with matching metadata.
#' \item The \code{path} column contains the suffix of the object key of the metadata document,
#' i.e., the relative \dQuote{path} within the version's \dQuote{directory} to the metadata document.
#' The full object key of the document inside the bucket is defined as \code{{project}/{asset}/{version}/{path}}.
#' \item The \code{user} column contains the identity of the uploading user.
#' \item The \code{time} column contains the time of the upload.
#' \item If \code{include.metadata=TRUE}, a \code{metadata} column is present with the nested metadata for each match.
#' \item If \code{latest=TRUE}, a \code{latest} column is present indicating whether the matching version is the latest for its asset.
#' Otherwise, only the latest version is returned.
#' }
#'
#' For \code{searchMetadataFilter}, a list containing \code{where}, a string can be directly used as a WHERE filter condition in a SQL SELECT statement;
#' and \code{parameters}, the parameter bindings to be used in \code{where}.
#' The return value may also be \code{NULL} if the query has no well-defined filter.
#'
#' For \code{gsc}, a gypsum.search.clause object that can be used in \code{|}, \code{&} and \code{!} to create more complex queries involving multiple clauses.
#'
#' @author Aaron Lun
#'
#' @details
#' Each query string is tokenized by converting it to lower case and splitting it on characters that are not Unicode letters/numbers or a dash.
#' We currently do not remove diacritics so these will need to be converted to ASCII by the user. 
#' If a text query involves only non-letter/number/dash characters, the filter will not be well-defined and will be ignored when constructing SQL statements.
#' The metadata document/field is only considered to match the query string if all of the tokens can be found in that document/field (in any order).
#' 
#' @seealso
#' \code{\link{fetchMetadataDatabase}}, to download and cache the database files.
#'
#' \url{https://github.com/ArtifactDB/bioconductor-metadata-index}, for details on the SQLite file contents and table structure.
#' 
#' \code{\link{translateTextQuery}}, to create a gypsum.search.clause from human-friendly syntax.
#'
#' @examples
#' path <- fetchMetadataDatabase()
#' searchMetadata(path, gsc("mouse brain"), include.metadata=FALSE)
#'
#' # Now for a slightly more complex query:
#' query <- (gsc("brain") | gsc("pancreas")) & gsc("10090", field="taxonomy_id")
#' searchMetadata(path, query, include.metadata=FALSE)
#'
#' # Throwing in some wildcards.
#' has.neuro <- gsc("Neuro%", partial=TRUE)
#' searchMetadata(path, has.neuro, include.metadata=FALSE)
#'
#' # We can also query other properties.
#' datasets <- gsc(project="scRNAseq") & gsc(asset="l%", partial=TRUE)
#' searchMetadata(path, datasets, include.metadata=FALSE)
#'
#' @aliases
#' gypsum.search.clause
#' Ops.gypsum.search.clause
#' searchMetadataText
#' defineTextQuery
#' searchMetadataTextFilter
#'
#' @export
searchMetadata <- function(path, query, latest=TRUE, include.metadata=TRUE) {
    where <- searchMetadataFilter(query)
    cond <- where$where
    params <- where$parameters

    conn <- DBI::dbConnect(RSQLite::SQLite(), path)
    on.exit(DBI::dbDisconnect(conn), add=TRUE, after=FALSE)
    version <- DBI::dbGetQuery(conn, "PRAGMA user_version")[,1]

    stmt <- "SELECT versions.project AS project, versions.asset AS asset, versions.version AS version, path"
    if (version >= 1001000) {
        stmt <- paste0(stmt, ", versions.user AS user, versions.time AS time")
    }
    if (include.metadata) {
        stmt <- paste0(stmt, ", json_extract(metadata, '$') AS metadata")
    }
    if (!latest) {
        stmt <- paste0(stmt, ", versions.latest AS latest")
    }
    stmt <- paste0(stmt, " FROM paths LEFT JOIN versions ON paths.vid = versions.vid")

    if (latest) {
        cond <- c(cond, "versions.latest = 1")
    }
    if (length(cond)) {
        stmt <- paste0(stmt, " WHERE ", paste(cond, collapse=" AND "))
    }

    if (is.null(params)) {
        everything <- DBI::dbGetQuery(conn, stmt)
    } else {
        everything <- DBI::dbGetQuery(conn, stmt, params=params)
    }
    if (include.metadata) {
        everything$metadata <- lapply(everything$metadata, fromJSON, simplifyVector=FALSE)
    }
    if (version >= 1001000) {
        everything$time <- as.POSIXct(everything$time)
    }

    everything
}

#' @export
searchMetadataText <- function(...) {
    searchMetadata(...) # Soft-deprecated.
}

#' @export
#' @rdname searchMetadata
gsc <- function(text=NULL, project=NULL, asset=NULL, version=NULL, path=NULL, user=NULL, time=NULL, field=NULL, partial=FALSE, after=TRUE) {
    collected <- list()

    if (!is.null(text)) {
        collected <- c(collected, list(list(type="text", text=text, field=field, partial=partial)))
    }

    if (!is.null(project)) {
        collected <- c(collected, list(list(type = "project", project = project, partial = partial)))
    }

    if (!is.null(asset)) {
        collected <- c(collected, list(list(type = "asset", asset = asset, partial = partial)))
    }

    if (!is.null(version)) {
        collected <- c(collected, list(list(type = "version", version = version, partial = partial)))
    }

    if (!is.null(path)) {
        collected <- c(collected, list(list(type = "path", path = path, partial = partial)))
    }

    if (!is.null(user)) {
        collected <- c(collected, list(list(type = "user", user = user, partial = partial)))
    }

    if (!is.null(time)) {
        collected <- c(collected, list(list(type = "time", time = as.double(time), after=after)))
    }

    for (i in seq_along(collected)) {
        class(collected[[i]]) <- "gypsum.search.clause"
    }

    if (length(collected) == 0) {
        stop("at least one of 'text', 'project', 'asset', 'version', 'path', 'user' or 'time' must be specified")
    } else if (length(collected) == 1) {
        collected[[1]]
    } else {
        output <- list(type = "and", children = collected)
        class(output) <- "gypsum.search.clause"
        output
    }
}

#' @export
defineTextQuery <- function(text, field=NULL, partial=FALSE) {
    gsc(text, field=field, partial=partial) # Soft-deprecated.
}

#' @export
Ops.gypsum.search.clause <- function(e1, e2) {
    if (.Generic == "&") {
        output <- list(type="and", children=list(e1, e2))
    } else if (.Generic == "|") {
        output <- list(type="or", children=list(e1, e2))
    } else if (.Generic == "!") {
        output <- list(type="not", child=e1) 
    } else {
        stop("unsupported generic '", .Generic, "' for 'gypsum.search.clause'")
    }
    class(output) <- "gypsum.search.clause"
    output
}

#' @export
#' @rdname searchMetadata
searchMetadataFilter <- function(
    query,
    pid.name = 'paths.pid', 
    project.name="versions.project",
    asset.name="versions.asset",
    version.name="versions.version",
    path.name="paths.path",
    user.name="versions.user",
    time.name="versions.time")
{
    query <- sanitize_query(query)
    if (is.null(query)) {
        return(NULL)
    }

    names <- list(
        pid=pid.name,
        project=project.name,
        asset=asset.name,
        version=version.name,
        path=path.name,
        user=user.name,
        time=time.name
    )

    env <- new.env()
    env$parameters <- list()
    cond <- build_query(query, names, env)
    list(where=cond, parameters=env$parameters)
}

#' @export
searchMetadataTextFilter <- function(...) {
    searchMetadataFilter(...) # Soft-deprecated.
}

sanitize_query <- function(query) {
    if (is.character(query)) {
        .Deprecated(msg="character vectors in 'query=' are deprecated, use 'translateTextQuery()' instead")
        if (length(query) > 1) {
            query <- list(type="and", children=lapply(query, gsc))
            class(query) <- "gypsum.search.clause"
        } else if (length(query) == 1L) {
            query <- gsc(query)
        } else {
            stop("character vector must be non-empty")
        }
    }

    qt <- query$type
    if (qt %in% c("project", "asset", "version", "path", "user", "time")) {
        return(query)
    }

    if (qt == "not") {
        child <- sanitize_query(query$child)
        if (is.null(child)) {
            return(NULL)
        } 
        return(list(type="not", child=child))
    }

    if (qt == "and" || qt == "or") {
        rechildren <- lapply(query$children, sanitize_query)

        keep <- !vapply(rechildren, is.null, FALSE)
        if (!any(keep)) {
            return(NULL)
        }
        if (!all(keep)) {
            rechildren <- rechildren[keep]
        }
        if (length(rechildren) == 1L) {
            return(rechildren[[1]])
        }

        # Collapse AND/ORs into a single layer to reduce nesting of subqueries.
        can.merge <- vapply(rechildren, function(x) x$type, "") == qt
        if (any(can.merge)) {
            grandchildren <- lapply(rechildren[can.merge], function(x) x$children)
            rechildren <- c(unlist(grandchildren, recursive=FALSE), rechildren[!can.merge])
        }

        output <- list(type=qt, children=rechildren)
        class(output) <- "gypsum.search.clause"
        return(output)
    }

    extras <- ""
    if (isTRUE(query$partial)) {
        extras <- "%_"
    }

    text <- strsplit(tolower(query$text), sprintf("[^\\p{N}\\p{L}\\p{Co}%s-]", extras), perl=TRUE)[[1]]
    keep <- vapply(text, nchar, 0L) > 0L
    if (!any(keep)) {
        return(NULL)
    }

    children <- lapply(text[keep], defineTextQuery, field=query$field, partial=isTRUE(query$partial))
    if (length(children) == 1L) {
        return(children[[1]])
    }

    output <- list(type="and", children=children)
    class(output) <- "gypsum.search.clause"
    output 
}

add_query_parameter <- function(env, value) {
    newname <- paste0("p", length(env$parameters))
    env$parameters[[newname]] <- value
    newname
}

add_token_search_clause <- function(query, env) {
    nt <- add_query_parameter(env, query$text)
    if (isTRUE(query$partial)) {
        paste0("tokens.token LIKE :", nt) 
    } else {
        paste0("tokens.token = :", nt) 
    }
}

setup_token_search_subquery_basic <- function(names, where) {
    sprintf("%s IN (SELECT pid from links LEFT JOIN tokens ON tokens.tid = links.tid WHERE %s)", names$pid, where)
}

setup_token_search_subquery_with_field <- function(names, where) {
    sprintf("%s IN (SELECT pid from links LEFT JOIN tokens ON tokens.tid = links.tid LEFT JOIN fields ON fields.fid = links.fid WHERE %s)", names$pid, where)
}

build_query <- function(query, names, env) {
    qt <- query$type

    if (qt == "text") {
        match.str <- add_token_search_clause(query, env)
        field <- query$field
        if (!is.null(field)) {
            nf <- add_query_parameter(env, field)
            return(setup_token_search_subquery_with_field(names, sprintf("fields.field = :%s AND %s", nf, match.str)))
        } else {
            return(setup_token_search_subquery_basic(names, match.str))
        }
    }

    if (qt %in% c("project", "asset", "version", "path", "user")) {
        nt <- add_query_parameter(env, query[[qt]])
        db.name <- names[[qt]]
        if (isTRUE(query$partial)) {
            return(sprintf("%s LIKE :%s", db.name, nt))
        } else {
            return(sprintf("%s = :%s", db.name, nt))
        }
    }

    if (qt == "time") {
        nt <- add_query_parameter(env, query[[qt]])
        db.name <- names[[qt]]
        op <- if (isTRUE(query$after)) ">" else "<="
        return(sprintf("%s %s :%s", db.name, op, nt))
    }

    if (qt == "not") {
        return(paste0("NOT ", build_query(query$child, names, env)))
    }

    if (qt == "and") {
        out <- lapply(query$children, build_query, name=names, env=env)
        return(paste0("(", paste(out, collapse=" AND "), ")"))
    }

    # Collapse text children into a single subquery.
    is.text <- vapply(query$children, function(x) x$type, "") == "text"
    out <- character(0)
    if (any(is.text)) {
        textual <- query$children[is.text]
        needs.field <- FALSE

        for (i in seq_along(textual)) {
            current <- textual[[i]]
            match.str <- add_token_search_clause(current, env)
            field <- current$field
            if (is.null(field)) {
                textual[[i]] <- match.str
            } else {
                nf <- add_query_parameter(env, field)
                textual[[i]] <- sprintf("(%s AND fields.field = :%s)", match.str, nf)
                needs.field <- TRUE
            }
        }

        textual <- paste(unlist(textual), collapse=" OR ")
        if (needs.field) {
            out <- c(out, setup_token_search_subquery_with_field(names, textual))
        } else {
            out <- c(out, setup_token_search_subquery_basic(names, textual))
        }
    }

    # All non-text children to be processed as separate subqueries, I'm afraid.
    if (!all(is.text)) {
        out <- c(out, vapply(query$children[!is.text], build_query, names=names, env=env, ""))
    }
    paste0("(", paste(out, collapse=" OR "), ")")
}

# This tests the searchMetadata function.
# library(testthat); library(gypsum); source("test-searchMetadata.R")

library(DBI)
library(RSQLite)

tmp <- tempfile(fileext=".sqlite3")
(function() {
    conn <- dbConnect(SQLite(), tmp)
    on.exit(dbDisconnect(conn))

    dbWriteTable(conn, "versions", data.frame(
        vid = 1:3,
        project = "foo",
        asset = "bar",
        version = as.character(1:3),
        latest = c(FALSE, FALSE, TRUE),
        user = c("foo", "bar", "stuff"),
        time = 1:3
    ))

    metadata <- list(
        list(first_name="mikoto", last_name="misaka", school="tokiwadai", ability="railgun", gender="female", comment="rank 3"),
        list(first_name="mitsuko", last_name="kongou", school="tokiwadai", ability="aerohand", gender="female"),
        list(first_name="kuroko", last_name="shirai", school="tokiwadai", ability="teleport", gender="female", affiliation="judgement"),
        list(first_name="misaki", last_name="shokuhou", school="tokiwadai", ability="mental out", gender="female", comment="rank 5"),
        list(first_name="ruiko", last_name="saten", school="sakugawa", gender="female"),
        list(first_name="kazari", last_name="uiharu", school="sakugawa", gender="female", affiliation="judgement"),
        list(first_name="accelerator", ability="vector manipulation", gender="male", comment="rank 1")
    )

    dbWriteTable(conn, "paths", data.frame(
        pid = seq_along(metadata),
        vid = rep(1:3, length.out=length(metadata)),
        path = paste0(vapply(metadata, function(x) x$first_name, ""), ".txt"),
        metadata = vapply(metadata, jsonlite::toJSON, auto_unbox=TRUE, "")
    ))

    all.tokens <- unlist(strsplit(unique(unlist(metadata, use.names=FALSE)), " "))
    dbWriteTable(conn, "tokens", data.frame(tid = seq_along(all.tokens), token = all.tokens))

    all.fields <- unique(unlist(lapply(metadata, names)))
    dbWriteTable(conn, "fields", data.frame(fid = seq_along(all.fields), field = all.fields))

    links <- list(pid = integer(0), fid = integer(0), tid = integer(0))
    for (i in seq_along(metadata)) {
        my.fields <- names(metadata[[i]])
        my.tokens <- lapply(metadata[[i]], function(x) unique(strsplit(x, " ")[[1]]))
        my.fields <- rep(my.fields, lengths(my.tokens))
        my.tokens <- unlist(my.tokens, use.names=FALSE)
        links$pid <- c(links$pid, rep(i, length(my.tokens)))
        links$fid <- c(links$fid, match(my.fields, all.fields))
        links$tid <- c(links$tid, match(my.tokens, all.tokens))
    }
    dbWriteTable(conn, "links", data.frame(links))
})()

test_that("searchMetadata works for text searches", {
    out <- searchMetadata(tmp, gsc("mikoto"), include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, "mikoto.txt")

    # Tokenization works correctly.
    out <- searchMetadata(tmp, gsc(" kuroko "), include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("kuroko.txt"))
    out <- searchMetadata(tmp, gsc("TOKIWADAI"), include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "mitsuko.txt", "kuroko.txt", "misaki.txt"))

    # Partial matching works correctly.
    query <- gsc("Mi%", partial=TRUE)
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "mitsuko.txt", "misaki.txt"))

    # Field-specific matching works correctly.
    query <- gsc("sa%", partial=TRUE, field="last_name")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("ruiko.txt"))
})

test_that("searchMetadata works for AND searches", {
    # AND automatically happens upon tokenization.
    out <- searchMetadata(tmp, gsc("sakugawa judgement"), include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, "kazari.txt")

    # We can also be more explicit.
    query <- gsc("rank") & gsc("male")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, "accelerator.txt")

    # Nested ANDs are handled properly.
    query <- (gsc("s%", partial=TRUE) & gsc("tokiwadai")) & gsc("judgement")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, "kuroko.txt")
})

test_that("searchMetadata works for OR searches", {
    query <- gsc("uiharu") | gsc("rank")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "misaki.txt", "kazari.txt", "accelerator.txt"))

    # ORs work correctly with partial matches.
    query <- gsc("judgement") | gsc("Mi%", partial=TRUE)
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "mitsuko.txt", "kuroko.txt", "misaki.txt", "kazari.txt"))

    # ORs work correctly with field matches.
    query <- gsc("mi%", partial=TRUE, field="last_name") | gsc("judgement")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "kuroko.txt", "kazari.txt"))

    # Nested ORs are collapsed properly.
    query <- (gsc("teleport") | gsc("aerohand")) | gsc("mental")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mitsuko.txt", "kuroko.txt", "misaki.txt"))

    query <- (gsc("%sa%", field="school", partial=TRUE) | gsc("mental"))
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("misaki.txt", "ruiko.txt", "kazari.txt"))
})

test_that("searchMetadata works with combined AND and OR searches", {
    # OR that contains an AND.
    query <- (gsc("judgement") & gsc("sakugawa")) | gsc("aerohand") | gsc("vector")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mitsuko.txt", "kazari.txt", "accelerator.txt"))

    # OR that contains multiple ANDs.
    query <- (gsc("judgement") & gsc("sakugawa")) | (gsc("female") & gsc("rank"))
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "misaki.txt", "kazari.txt"))

    # AND that contains an OR.
    query <- gsc("rank") & (gsc("shokuhou") | gsc("kongou"))
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("misaki.txt"))

    # AND that contains multiple ORs.
    query <- (gsc("rank") | gsc("judgement")) & (gsc("male") | gsc("teleport"))
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("kuroko.txt", "accelerator.txt"))
})

test_that("searchMetadata works for NOT searches", {
    query <- !gsc("uiharu") 
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "mitsuko.txt", "kuroko.txt", "misaki.txt", "ruiko.txt", "accelerator.txt"))

    query <- !gsc("mi%", partial=TRUE) 
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("kuroko.txt", "ruiko.txt", "kazari.txt", "accelerator.txt"))

    query <- !(gsc("uiharu") | gsc("rank"))
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mitsuko.txt", "kuroko.txt", "ruiko.txt"))

    query <- gsc("rank") & !gsc("tokiwadai")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("accelerator.txt"))
})

test_that("searchMetadata works for non-text-based searches", {
    query <- gsc(project="foo", asset="bar")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(sort(out$path), sort(c("mikoto.txt", "mitsuko.txt", "kuroko.txt", "misaki.txt", "ruiko.txt", "kazari.txt", "accelerator.txt"))) 

    query <- gsc(version="2")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mitsuko.txt", "ruiko.txt"))

    query <- gsc(path="%ko_txt", partial=TRUE)
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mitsuko.txt", "kuroko.txt", "ruiko.txt"))

    query <- gsc(user="foo")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(sort(out$path), sort(c("mikoto.txt", "misaki.txt", "accelerator.txt"))) 

    query <- gsc(time=2, after=TRUE) & gsc(time=3, after=FALSE)
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(sort(out$path), sort(c("kuroko.txt", "kazari.txt")))

    # Combines with the other searches.
    query <- gsc(path="kuroko.txt") | gsc("railgun")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(out$path, c("mikoto.txt", "kuroko.txt"))
})

test_that("searchMetadata works with ill-defined filters", {
    # We return everything.
    out <- searchMetadata(tmp, gsc("     "), include.metadata=FALSE, latest=FALSE)
    expect_identical(nrow(out), 7L)

    # Ill-defined filters are ignored in boolean operations.
    query <- gsc("female") & gsc("    ")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(nrow(out), 6L)

    query <- gsc("male") | gsc("    ")
    out <- searchMetadata(tmp, query, include.metadata=FALSE, latest=FALSE)
    expect_identical(nrow(out), 1L)
})

test_that("searchMetadata respects the other output options", {
    out <- searchMetadata(tmp, gsc("female"))
    expect_identical(out$path, c("kuroko.txt", "kazari.txt"))
    expect_identical(out$path, paste0(vapply(out$metadata, function(x) x$first_name, ""), ".txt"))
})

#' Get and set GitHub access tokens
#'
#' Get and set GitHub access tokens for authentication to the gypsum API's endpoints.
#'
#' @param full Logical scalar indicating whether to return the full token details.
#' @param request Logical scalar indicating whether to request a new token if no cached token is available or if the current token has expired.
#' @param token String containing a GitHub personal access token.
#' This should have the \code{"read:org"} and \code{"read:user"} scopes.
#' If missing, the user will be prompted to use GitHub's Oauth web application flow to acquire a token.
#' If \code{NULL}, any existing tokens are cleared from cache.
#' @param github.url String containing the URL for the GitHub API.
#' This is used to acquire more information about the token.
#' @param app.key String containing the key for a GitHub Oauth app.
#' @param app.secret String containing the secret for a GitHub Oauth app.
#' @param app.url String containing a URL of the gypsum REST API.
#' This is used to obtain \code{app.key} and \code{app.secret} if either are \code{NULL}.
#' @param user.agent String specifying the user agent for queries to various endpoints.
#' @param cache String containing a path to the cache directory, to store the token across R sessions.
#' If \code{NULL}, the token is not cached to (or read from) disk, which improves security on shared filesystems. 
#'
#' @return
#' \code{setAccessToken} sets the access token and invisibly returns a list containing:
#' \itemize{
#' \item \code{token}, a string containing the token.
#' \item \code{name}, the name of the GitHub user authenticated by the token.
#' \item \code{expires}, the Unix time at which the token expires.
#' }
#' 
#' If \code{full=TRUE}, \code{accessToken} returns the same list, typically retrieved from one of the caches.
#' If no token was cached or the cached token has expired, it will call \code{setAccessToken} with default arguments to obtain one if \code{request=TRUE};
#' otherwise if \code{request=FALSE}, \code{NULL} is returned.
#'
#' If \code{full=FALSE}, \code{accessToken} will return a string containing a token (or \code{NULL}, if no token is available and \code{request=FALSE}).
#'
#' @author Aaron Lun
#'
#' @examples
#' if (interactive()) {
#'     accessToken()
#' }
#' @name accessToken
NULL

token.cache <- new.env()
token.cache$auth.info <- NULL

token_cache_path <- function(cache) {
    file.path(cache, "credentials", "token.txt")
}

#' @export
#' @rdname accessToken
#' @importFrom filelock lock unlock
accessToken <- function(full = FALSE, request=TRUE, cache=cacheDirectory()) {
    if (full) {
        OFn <- identity
    } else {
        OFn <- function(x) x$token
    }
    expiry_leeway <- 10 # number of seconds until use of the token.

    in.memory <- token.cache$auth.info
    if (!is.null(in.memory)) {
        if (in.memory$expires > Sys.time() + expiry_leeway) {
            return(OFn(in.memory))
        } else {
            token.cache$auth.info <- NULL
        }
    }

    if (!is.null(cache)) {
        cache.path <- token_cache_path(cache)
        if (file.exists(cache.path)) {
            dump <- (function() {
                # Lock inside a function to guarantee unlocking prior to a possible lock() inside setAccessToken().
                lck <- lock(paste0(cache.path, ".LOCK"), exclusive=FALSE)
                on.exit(unlock(lck), add=TRUE, after=FALSE)
                readLines(cache.path)
            })()

            exp <- as.double(dump[3])
            if (exp > Sys.time() + expiry_leeway) {
                info <- list(token=dump[1], name=dump[2], expires=exp)
                token.cache$auth.info <- info
                return(OFn(info))
            } else {
                unlink(cache.path)
            }
        }
    }

    if (request) {
        payload <- setAccessToken(cache=cache)
        OFn(payload) # making it visible.
    } else {
        NULL
    }
}

#' @export
#' @rdname accessToken
#' @import httr2
#' @importFrom filelock lock unlock
setAccessToken <- function(token, app.url=restUrl(), app.key = NULL, app.secret = NULL, github.url="https://api.github.com", user.agent=NULL, cache=cacheDirectory()) {
    cache.path <- NULL
    if (!is.null(cache)) {
        cache.path <- token_cache_path(cache)
    }

    if (!missing(token) && is.null(token)) {
        token.cache$auth.info <- NULL
        if (!is.null(cache.path)) {
            unlink(cache.path)
        }
        return(invisible(NULL))
    }

    if (missing(token)) {
        if (!interactive()) {
            stop("cannot request a new access token in a non-interactive session")
        }

        if (is.null(app.key) || is.null(app.secret)) {
            req <- request(paste0(chomp_url(app.url), "/credentials/github-app"))
            req <- req_user_agent(req, user.agent)
            res <- req_perform(req)
            info <- resp_body_json(res)
            app.key <- info$id
            app.secret <- info$secret
        }

        oapp <- oauth_client(
            id = app.key,
            secret = app.secret,
            token_url = "https://github.com/login/oauth/access_token",
            name = "gypsum"
        )
        ores <- oauth_flow_auth_code(oapp, auth_url = "https://github.com/login/oauth/authorize")
        token <- ores$access_token
    }

    req <- request(paste0(chomp_url(github.url), "/user"))
    req <- req_auth_bearer_token(req, token)
    req <- req_user_agent(req, user.agent)
    res <- req_perform(req)
    name <- resp_body_json(res)$login
    expiry <- Inf
    expires <- resp_headers(res)[["github-authentication-token-expiration"]]
    if (!is.null(expires)) {
        frags <- strsplit(expires, " ")[[1]]
        expiry <- as.double(as.POSIXct(paste(frags[1], frags[2]), tz=frags[3]))
    }

    if (!is.null(cache.path)) {
        dir.create(dirname(cache.path), showWarnings=FALSE, recursive=TRUE)
        lck <- lock(paste0(cache.path, ".LOCK"))
        on.exit(unlock(lck), add=TRUE, after=FALSE)
        writeLines(c(token, name, expiry), con=cache.path)
        Sys.chmod(cache.path, mode="0600") # prevent anyone else from reading this on shared file systems.
    }

    vals <- list(token=token, name=name, expires=expiry)
    token.cache$auth.info <- vals
    invisible(vals)
}

# This tests that the GitHub token is correctly set.
# library(testthat); library(gypsum); source("setup.R"); source("test-accessToken.R")

test_that("setting the token works as expected", {
    skip_if(is.na(gh_token))

    out <- setAccessToken(gh_token, cache=NULL)
    expect_identical(out$token, gh_token)
    expect_identical(accessToken(cache=NULL), gh_token)

    # Works when we cache it to disk.
    cache <- tempfile()
    out <- setAccessToken(gh_token, cache=cache)
    expect_identical(out$token, gh_token)
    expect_identical(accessToken(cache=cache), gh_token)
    tokpath <- file.path(cache, "credentials", "token.txt")
    expect_identical(readLines(tokpath)[1], gh_token)

    # Unsetting it works as expected.
    out <- setAccessToken(NULL, cache=NULL)
    expect_null(gypsum:::token.cache$auth_info)
    expect_true(file.exists(tokpath))

    out <- setAccessToken(NULL, cache=cache)
    expect_null(gypsum:::token.cache$auth_info)
    expect_false(file.exists(tokpath))
})

test_that("access token retrieval works as expected", {
    setAccessToken(NULL, cache=NULL) # wipe out in-memory cache.

    cache <- tempfile()
    tokpath <- file.path(cache, "credentials", "token.txt")
    dir.create(dirname(tokpath), recursive=TRUE)
    writeLines(c("foobar", "urmom", Sys.time() + 10000), con=tokpath)

    info <- accessToken(full=TRUE, request=FALSE, cache=cache)
    expect_identical(info$token, "foobar")
    expect_identical(info$name, "urmom")
    expect_type(info$expires, "double")

    # Works from cache.
    info <- accessToken(full=TRUE, request=FALSE, cache=NULL)
    expect_identical(info$token, "foobar")
    expect_identical(info$name, "urmom")
    expect_type(info$expires, "double")

    # Falls through to request.
    setAccessToken(NULL, cache=NULL) # wipe out in-memory cache.
    unlink(tokpath)
    info <- accessToken(full=TRUE, request=FALSE, cache=cache)
    expect_null(info)
})

test_that("access token expiry works as expected", {
    setAccessToken(NULL, cache=NULL) # wipe out in-memory cache.

    cache <- tempfile()
    tokpath <- file.path(cache, "credentials", "token.txt")
    dir.create(dirname(tokpath), recursive=TRUE)
    writeLines(c("foobar", "urmom", Sys.time() - 10000), con=tokpath)

    info <- accessToken(full=TRUE, request=FALSE, cache=cache)
    expect_null(info)

    # Works in memory as well.
    info <- accessToken(full=TRUE, request=FALSE, cache=NULL)
    expect_null(info)
})

#' Remove a project 
#'
#' Remove a project from the gypsum backend.
#'
#' @param project String containing the project to remove.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a gypsum administrator account.
#'
#' @return \code{NULL} is invisibly returned if the project was successfully removed. 
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{createProject}}, to create a project.
#'
#' \code{\link{removeAsset}} and \code{\link{removeVersion}}, to remove an asset or version.
#'
#' @examples
#' if (interactive()) {
#'     createProject("test-R-remove", owners="LTLA")
#'     removeProject("test-R-remove")
#' }
#' @export
#' @import httr2
removeProject <- function(project, url=restUrl(), token=accessToken()) {
    suffix <- uenc(project)
    request_removal(suffix, url, token)
}

request_removal <- function(suffix, url, token) {
    url <- chomp_url(url)
    req <- request(paste0(url, "/remove/", suffix))
    req <- req_method(req, "DELETE")
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)

    req_perform(req)
    invisible(NULL)
}

#' Format object-related metadata
#'
#' Create object-related metadata to validate against the default schema from \code{\link{fetchMetadataSchema}}.
#' This is intended for downstream package developers who are auto-generating metadata documents to be validated by \code{\link{validateMetadata}}.
#'
#' @param x An R object, typically an instance of a Bioconductor class.
#'
#' @return List containing the object-related metadata, typically stored in the \code{applications.takane} field of the metadata. 
#'
#' @author Aaron Lun
#'
#' @examples
#' df <- S4Vectors::DataFrame(alpha=LETTERS, numeric=runif(26))
#' formatObjectMetadata(df)
#' 
#' @export
formatObjectMetadata <- function(x) {
    output <- list()

    if (methods::is(x, "SummarizedExperiment")) {
        # CRAZY SHIT HERE to avoid Suggests'ing these packages.
        senm <- getNamespace("SummarizedExperiment")
        output$summarized_experiment = list(
           rows = nrow(x),
           columns = ncol(x),
           assays = as.list(get("assayNames", envir=senm)(x)),
           column_annotations = as.list(colnames(get("colData", envir=senm)(x)))
        )

        if (methods::is(x, "SingleCellExperiment")) {
            scenm <- getNamespace("SingleCellExperiment")
            output$single_cell_experiment <- list(
                reduced_dimensions = as.list(get("reducedDimNames", envir=scenm)(x)),
                alternative_experiments = as.list(get("altExpNames", envir=scenm)(x))
            )
        }

    } else if (methods::is(x, "DataFrame")) {
        output$data_frame <- list(
            rows = nrow(x),
            column_names = as.list(colnames(x))
        )
    }

    output
}

#' Validate metadata against a JSON schema
#'
#' Validate metadata against a JSON schema for a SQLite database.
#' This ensures that it can be successfully inserted in the database in downstream indexing steps.
#'
#' @param metadata Metadata to be checked.
#' This is usually an R object like a named list, but may also be a JSON-formatted string.
#' @param schema String containing a path to a schema.
#' @param stringify Logical scalar indicating whether to convert \code{metadata} to a JSON-formatted string.
#' Defaults to \code{TRUE} if \code{metadata} is not already a string.
#'
#' @return NULL is invisibly returned upon successful validation.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{fetchMetadataSchema}}, to get the JSON schemas.
#'
#' \code{\link{fetchMetadataDatabase}}, to obtain the SQLite database files.
#'
#' @examples
#' metadata <- list(
#'     title="Fatherhood",
#'     description="Luke ich bin dein Vater.",
#'     sources=list(
#'        list(provider="GEO", id="GSE12345")
#'     ),
#'     taxonomy_id=list("9606"),
#'     genome=list("GRCm38"),
#'     maintainer_name="Darth Vader",
#'     maintainer_email="vader@empire.gov",
#'     bioconductor_version="3.10"
#' )
#' 
#' validateMetadata(metadata)
#'
#' @export
#' @importFrom jsonlite toJSON
validateMetadata <- function(metadata, schema=fetchMetadataSchema(), stringify=NULL) {
    if (is.null(stringify)) {
        stringify <- !is.character(metadata)
    }
    if (stringify) {
        metadata <- toJSON(metadata, auto_unbox=TRUE)
    }
    jsonvalidate::json_validate(metadata, schema, error=TRUE, engine="ajv")
    invisible(NULL)
}

#' List asset versions
#'
#' List all versions of a project asset.
#'
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @author Aaron Lun
#'
#' @return Character vector of versions.
#'
#' @examples
#' listVersions("test-R", "basic")
#' 
#' @export
listVersions <- function(project, asset, url=restUrl(), config=NULL) {
    list_for_prefix(paste0(project, "/", asset, "/"), url=url)
}

#' Resolve links in the cache directory
#'
#' Create hard links (or copies, if filesystem links are not supported) for linked-from files to their link destinations.
#'
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param version String containing the version name.
#' @param cache String containing the path to the cache directory.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#' @param overwrite Logical scalar indicating whether to replace existing files at the linked-from paths.
#' 
#' @return \code{NULL} is returned on successful completion.
#'
#' @author Aaron Lun
#'
#' @examples
#' cache <- tempfile()
#' saveVersion("test-R", "basic", "v3", relink=FALSE, cache=cache)
#' list.files(cache, recursive=TRUE, all.files=TRUE)
#' 
#' resolveLinks("test-R", "basic", "v3", cache=cache)
#' list.files(cache, recursive=TRUE, all.files=TRUE)
#'
#' @export
resolveLinks <- function(project, asset, version, cache=cacheDirectory(), overwrite=FALSE, url=restUrl(), config=NULL) {
    acquire_lock(cache, project, asset, version)
    on.exit(release_lock(project, asset, version), add=TRUE, after=FALSE)
    destination <- file.path(cache, BUCKET_CACHE_NAME, project, asset, version)

    manifests <- list()
    selfmanifest <- fetchManifest(project, asset, version, cache=cache, url=url)
    manifests[[paste(project, asset, version, sep="/")]] <- selfmanifest

    for (l in names(selfmanifest)) {
        entry <- selfmanifest[[l]]
        if (is.null(entry$link)) {
            next
        } 

        oldloc <- file.path(project, asset, version, l) 
        if (file.exists(oldloc) && !overwrite) {
            next
        }
        linkdata <- entry$link

        if (!is.null(linkdata$ancestor)) {
            linkdata <- linkdata$ancestor
        }
        out <- saveFile(linkdata$project, linkdata$asset, linkdata$version, linkdata$path, cache=cache, url=url, overwrite=overwrite)

        oldpath <- file.path(cache, BUCKET_CACHE_NAME, oldloc)
        unlink(oldpath, force=TRUE) # remove any existing file.
        dir.create(dirname(oldpath), showWarnings=FALSE, recursive=TRUE)
        if (!file.link(out, oldpath) && !file.copy(out, oldpath)) {
            stop("failed to resolve link for '", l, "'")
        }
    }

    invisible(NULL)
}

#' Fetch version manifest 
#'
#' Fetch the manifest for a version of an asset of a project.
#'
#' @inheritParams saveFile
#' @param cache String containing the cache directory.
#' If \code{NULL}, no caching is performed.
#' @param overwrite Logical scalar indicating whether to overwrite an existing file in \code{cache}, if one is present.
#'
#' @author Aaron Lun
#' 
#' @return List containing the manifest for this version.
#' Each element is named after the relative path of a file in this version.
#' The value of each element is another list with the following fields:
#' \itemize{
#' \item \code{size}, an integer specifying the size of the file in bytes.
#' \item \code{md5sum}, a string containing the hex-encoded MD5 checksum of the file.
#' \item \code{link} (optional): a list specifying the link destination for a file. 
#' This contains the strings \code{project}, \code{asset}, \code{version} and \code{path}.
#' If the link destination is itself a link, an \code{ancestor} list will be present that specifies the final location of the file after resolving all intermediate links.
#' }
#' 
#' @examples
#' fetchManifest("test-R", "basic", "v1")
#' 
#' @export
fetchManifest <- function(project, asset, version, cache=cacheDirectory(), overwrite=FALSE, url=restUrl(), config=NULL) {
    get_cacheable_json(
       project, 
       asset, 
       version, 
       "..manifest", 
       url=url,
       cache=cache,
       overwrite=overwrite
    )
}

#' Approve a probational upload
#'
#' Pretty much as it says: approve a probational upload of a version of a project's asset.
#' This removes the \code{on_probation} tag from the uploaded version.
#' 
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' @param version String containing the version name.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to an owner of \code{project}.
#'
#' @return \code{NULL} is invisibly returned upon successful approval.
#'
#' @seealso
#' \code{\link{rejectProbation}}, to reject the probational upload.
#'
#' \code{\link{startUpload}}, to specify probational uploads.
#' 
#' @author Aaron Lun
#' @examples
#' if (interactive()) {
#'     # Mocking up a versioned asset.
#'     init <- startUpload(
#'         project="test-R", 
#'         asset="probation-approve", 
#'         version="v1", 
#'         files=character(0),
#'         probation=TRUE
#'     )
#'     completeUpload(init) 
#'
#'     # Approving the probation:
#'     approveProbation("test-R", "probation-approve", "v1")
#' 
#'     # Just cleaning up after we're done.
#'     removeProjectAsset("test-R", "probation-approve")
#' }
#' 
#' @export
#' @import httr2
approveProbation <- function(project, asset, version, url=restUrl(), token=accessToken()) {
    url <- chomp_url(url)
    req <- request(paste0(url, "/probation/approve/", uenc(project) , "/", uenc(asset), "/", uenc(version)))
    req <- req_method(req, "POST")
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)
    req_perform(req)
    invisible(NULL)
}

#' Upload a directory to the gypsum backend
#'
#' Convenience method to upload a directory to the gypsum backend as a versioned asset of a project.
#' This requires uploader permissions to the relevant project.
#' 
#' @param directory String containing the path to a directory to be uploaded.
#' @inheritParams startUpload
#' @param concurrent Integer scalar specifying the number of concurrent uploads in \code{\link{uploadFiles}}.
#' @param abort.failed Logical scalar indicating whether to abort the upload on any failure.
#' Setting this to \code{FALSE} can be helpful for diagnosing upload problems.
#' @param cache String containing the path to the cache for saving files, e.g., in \code{\link{saveVersion}}.
#' Used to convert symbolic links to upload links, see \code{\link{prepareDirectoryUpload}}.
#'
#' @return On successful upload, \code{NULL} is invisibly returned.
#'
#' @details
#' This function is a wrapper around \code{\link{prepareDirectoryUpload}} and \code{\link{startUpload}} and friends.
#' The aim is to streamline the upload of a directory's contents when no customization of the file listing is required.
#' 
#' @author Aaron Lun
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#' write(file=file.path(tmp, "blah.txt"), LETTERS)
#' dir.create(file.path(tmp, "foo"))
#' write(file=file.path(tmp, "foo", "bar.txt"), 1:10)
#'
#' if (interactive()) {
#'     # Uploading a probational version for test purposes.
#'     uploadDirectory(staging, "test-R", "upload-dir-check", version, probation=TRUE)
#'
#'     # Cleaning up after ourselves.
#'     gypsum::rejectProbation("test-R", "upload-dir-check", version)
#' }
#'
#' @export
#' @importFrom gypsum cacheDirectory restUrl accessToken startUpload abortUpload uploadFiles completeUpload prepareDirectoryUpload
uploadDirectory <- function(directory, project, asset, version, cache=cacheDirectory(), deduplicate=TRUE, probation=FALSE, url=restUrl(), token=accessToken(), concurrent=1, abort.failed=TRUE) {
    listing <- prepareDirectoryUpload(directory, links="always", cache=cache)

    blob <- startUpload(
        project=project,
        asset=asset,
        version=version, 
        files=listing$files,
        links=listing$links,
        directory=directory,
        probation=probation,
        url=url,
        token=token
    )

    success <- FALSE
    if (abort.failed) {
        on.exit({
            if (!success) {
                abortUpload(blob)
            }
        }, add=TRUE, after=FALSE)
    }

    uploadFiles(blob, directory=directory, url=url, concurrent=concurrent)
    completeUpload(blob, url=url)

    success <- TRUE
    invisible(NULL)
}

#' Fetch project usage details
#'
#' Fetch the quota usage for a project.
#' 
#' @param project String containing the project name.
#' @param url String containing the URL of the gypsum REST API.
#' @param config Deprecated and ignored.
#'
#' @return Numeric scalar specifying the quota usage for the project, in bytes.
#'
#' @author Aaron Lun
#'
#' @examples
#' fetchUsage("test-R")
#'
#' @seealso
#' \code{\link{refreshUsage}}, to recompute the used quota.
#'
#' @export
fetchUsage <- function(project, url=restUrl(), config=NULL) {
    used <- get_json(paste(project, "..usage", sep="/"), url=url)
    used$total
}

# Creating a test project and populating it for use in examples and tests.

createProject(
    "test-R", 
    owners="LTLA", 
    uploaders=list(list(id="ArtifactDB-bot"))
)

# Uploading the first version.
tmp <- tempfile()
dir.create(tmp)
write(file=file.path(tmp, "blah.txt"), LETTERS)
dir.create(file.path(tmp, "foo"))
write(file=file.path(tmp, "foo", "bar.txt"), 1:10)

blob <- startUpload(
    project="test-R", 
    asset="basic", 
    version="v1", 
    files=list.files(tmp, recursive=TRUE),
    directory=tmp
)
uploadFiles(blob, directory=tmp)
completeUpload(blob)

# Uploading a second version with implicit links.
blob <- startUpload(
    project="test-R", 
    asset="basic", 
    version="v2", 
    files=list.files(tmp, recursive=TRUE),
    directory=tmp
)
completeUpload(blob)

# Uploading a third version with implicit links to the ancestral v1.
blob <- startUpload(
    project="test-R", 
    asset="basic", 
    version="v3", 
    files=list.files(tmp, recursive=TRUE),
    directory=tmp
)
completeUpload(blob)

#' Prepare to upload a directory 
#'
#' Prepare to upload a directory's contents via \code{\link{startUpload}}.
#' This goes through the directory to list its contents and convert symlinks to upload links.
#'
#' @param directory String containing the path to a directory, the contents of which are to be uploaded via \code{\link{startUpload}}.
#' @param links String indicating how to handle symlinks in \code{directory}.
#' \itemize{
#' \item \code{"auto"} will attempt to convert symlinks into upload links.
#' If the conversion fails, a regular upload is performed.
#' \item \code{"always"} will attempt to convert symlinks into upload links.
#' If the conversion fails, an error is raised.
#' \item \code{"never"} will never attempt to convert symlinks into upload links.
#' All symlinked files are treated as regular uploads.
#' }
#' @param cache String containing a path to the cache directory, used to convert symlinks into upload links.
#'
#' @details
#' Files in \code{directory} (that are not symlinks) are used as regular uploads, i.e., \code{files=} in \code{\link{startUpload}}.
#' 
#' If \code{directory} contains a symlink to a file in \code{cache}, 
#' we assume that it points to a file that was previously downloaded by, e.g., \code{\link{saveFile}} or \code{\link{saveVersion}}.
#' Thus, instead of performing a regular upload, we attempt to create an upload link, i.e., \code{links=} in \code{\link{startUpload}}.
#' This is achieved by examining the destination path of the symlink and inferring the link destination in the backend.
#' Note that this still works if the symlinks are dangling.
#'
#' If a symlink cannot be converted into an upload link, it will be used as a regular upload,
#' i.e., the contents of the symlink destination will be uploaded by \code{\link{startUpload}}.
#' In this case, an error will be raised if the symlink is dangling as there is no file that can actually be uploaded.
#' If \code{links="always"}, an error is raised instead upon symlink conversion failure.
#'
#' This function is intended to be used with \code{\link{cloneVersion}}, which creates symlinks to files in \code{cache}.
#'
#' @return List containing \code{files}, a character vector to be used as \code{files=} in \code{\link{startUpload}};
#' and \code{links}, a data frame to be used as \code{links=} in \code{\link{startUpload}}.
#' 
#' @seealso
#' \code{\link{startUpload}}, to actually start the upload.
#'
#' \code{\link{cloneVersion}}, to prepare the symlinks.
#'
#' @examples
#' tmp <- tempfile()
#' out <- cloneVersion("test-R", "basic", "v1", destination=tmp)
#' write(file=file.path(tmp, "heanna"), "sumire")
#' prepareDirectoryUpload(tmp)
#'
#' @export
prepareDirectoryUpload <- function(directory, links=c("auto", "always", "never"), cache=cacheDirectory()) {
    links <- match.arg(links)

    out <- list.files(directory, recursive=TRUE)
    out.files <- character()
    out.links <- list(
        from.path=character(0), 
        to.project=character(0), 
        to.asset=character(0), 
        to.version=character(0), 
        to.path=character(0)
    )

    cache <- normalize_and_sanitize_path(cache)
    if (!endsWith(cache, "/")) {
        cache <- paste0(cache, "/")
    }

    for (x in out) {
        dest <- Sys.readlink(file.path(directory, x))
        if (dest == "") {
            out.files <- c(out.files, x)
            next
        }

        if (links == "never") {
            if (!file.exists(dest)) {
                stop("cannot use a dangling link to '", dest, "' as a regular upload")
            }
            out.files <- c(out.files, x)
            next
        }

        dest <- normalize_and_sanitize_path(dest)
        dest.components <- match_path_to_cache(dest, cache)
        if (!is.null(dest.components)) {
            out.links$from.path <- c(out.links$from.path, x)
            out.links$to.project <- c(out.links$to.project, dest.components$project)
            out.links$to.asset <- c(out.links$to.asset, dest.components$asset)
            out.links$to.version <- c(out.links$to.version, dest.components$version)
            out.links$to.path <- c(out.links$to.path, dest.components$path)
            next
        }

        if (links == "always") {
            stop("failed to convert symlink '", dest, "' to an upload link")
        } else if (!file.exists(dest)) {
            stop("cannot use a dangling link to '", dest, "' as a regular upload")
        }
        out.files <- c(out.files, x)
    }

    list(files=out.files, links=do.call(data.frame, out.links))
}

normalize_and_sanitize_path <- function(path) {
    # We normalize the paths so that we can compare prefixes accurately; but
    # don't attempt normalization if the path doesn't exist, e.g., because it's
    # the destination of a dangling symlink.
    if (file.exists(path)) {
        # We only normalize the directory, not the basename, in order to avoid
        # resolution if 'path' is itself a symlink. This preserves the intended
        # symlink target instead of following links to the ancestor.
        path <- file.path(normalizePath(dirname(path), mustWork=TRUE), basename(path))
    }

    # We sanitize all paths so that we can use exact string matching
    # without worrying about whether \ or / is the file separator.
    sanitize_path(path)
}

#' @importFrom utils tail
match_path_to_cache <- function(path, cache) {
    if (!startsWith(path, cache)) {
        return(NULL)
    }

    remainder <- substr(path, nchar(cache) + 1L, nchar(path))
    components <- strsplit(remainder, "/")[[1]]
    if (length(components) <= 4L || components[1] != BUCKET_CACHE_NAME) { # we need CACHE_BUCKET_NAME/project/asset/version/path
        return(NULL)
    }

    list(
        project=components[2], 
        asset=components[3], 
        version=components[4], 
        path=paste(tail(components, -4L), collapse="/")
    )
}

#' Start an upload
#'
#' Start an upload of a new version of an asset, or a new asset of a project.
#'
#' @param project String containing the project name.
#' @param asset String containing the asset name.
#' This should not contain \code{/} or start with \code{..}.
#' @param version String containing the version name.
#' This should not contain \code{/} or start with \code{..}.
#' @param files Character vector containing the paths of the files to be uploaded.
#' These should be relative to the version's \code{directory}. 
#'
#' Alternatively, a data frame where each row corresponds to a file and contains information about those files.
#' This data frame should contain the following fields:
#' \itemize{
#' \item \code{path}, a string containing the relative path of the file inside the version's subdirectory.
#' \item \code{size}, a non-negative integer specifying the size of the file in bytes.
#' \item \code{md5sum}, a string containing the hex-encoded MD5 checksum of the file.
#' \item (optional) \code{dedup}, a logical indicating whether deduplication should be attempted for each file.
#' }
#' @param links A data frame where each row corresponds to a linked-from file and contains the link destination for that file.
#' This data frame should contain the following fields:
#' \itemize{
#' \item \code{from.path}, a string containing the relative path of the file inside the version's subdirectory.
#' \item \code{to.project}, a string containing the project of the list destination.
#' \item \code{to.asset}, a string containing the asset of the list destination.
#' \item \code{to.version}, a string containing the version of the list destination.
#' \item \code{to.path}, a string containing the path of the list destination.
#' }
#' @param deduplicate Logical scalar indicating whether the backend should attempt deduplication of \code{files} in the immediately previous version.
#' Only has an effect if \code{files} is not a data frame or if the \code{dedup} field is missing.
#' @param probation Logical scalar indicating whether to perform a probational upload.
#' Such uploads must be approved by the project owner before they are considered official.
#' @param url String containing the URL of the gypsum REST API.
#' @param token String containing a GitHub access token to authenticate to the gypsum REST API.
#' The token must refer to a user that is authorized to upload to the specified \code{project}.
#' @param directory String containing the path to a directory containing the \code{files} to be uploaded.
#' This directory is assumed to correspond to a version of an asset.
#' It only has an effect if \code{files} is a character vector, as it is used to determine the MD5 checksums and sizes.
#' If \code{NULL}, \code{directory} is set to the current working directory.
#' 
#' @return List containing:
#' \itemize{
#' \item \code{file_urls}, a list of lists containing information about each file to be uploaded.
#' This is used by \code{\link{uploadFiles}}.
#' \item \code{complete_url}, a string containing the completion URL, to be used by \code{\link{completeUpload}}.
#' \item \code{abort_url}, a string specifying the abort URL, to be used by \code{\link{abortUpload}}.
#' \item \code{session_token}, a string for authenticating to the newly initialized upload session.
#' }
#'
#' @seealso
#' \code{\link{uploadFiles}}, to actually upload the files.
#'
#' \code{\link{completeUpload}}, to indicate that the upload is completed.
#'
#' \code{\link{abortUpload}}, to abort an upload in progress.
#'
#' \code{\link{prepareDirectoryUpload}}, to create \code{files} and \code{links} from a directory.
#'
#' @author Aaron Lun
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#' write(file=file.path(tmp, "blah.txt"), LETTERS)
#' dir.create(file.path(tmp, "foo"))
#' write(file=file.path(tmp, "foo", "bar.txt"), 1:10)
#'
#' if (interactive()) {
#'     blob <- startUpload(
#'         project="test-R", 
#'         asset="upload-start-check", 
#'         version="v1", 
#'         files=list.files(tmp, recursive=TRUE),
#'         directory=tmp
#'     )
#'     print(blob)
#'
#'     abortUpload(blob) # just cleaning up after we're done.
#' }
#'
#' @export
#' @import httr2
startUpload <- function(project, asset, version, files, links=NULL, deduplicate=TRUE, probation=FALSE, url=restUrl(), token=accessToken(), directory=NULL) {
    if (is.character(files)) {
        targets <- files
        if (!is.null(directory)) {
            targets <- file.path(directory, files)
        }

        files <- data.frame(
            path = files,
            size = vapply(targets, function(x) file.info(x)$size, 0, USE.NAMES=FALSE),
            md5sum = vapply(targets, function(x) digest::digest(file=x, algo="md5"), "", USE.NAMES=FALSE),
            dedup = rep(deduplicate, length(targets))
        )
    } else if (!("dedup" %in% colnames(files))) {
        files$dedup <- rep(deduplicate, nrow(files))
    }

    formatted <- vector("list", nrow(files))
    for (i in seq_len(nrow(files))) {
        type <- "simple"
        if (files$dedup[i]) {
            type <- "dedup"
        }
        formatted[[i]] <- list(
            type = type,
            path = sanitize_path(files$path[i]),
            size = files$size[i],
            md5sum = files$md5sum[i]
        )
    }

    if (!is.null(links)) {
        out.links <- vector("list", nrow(links)) 
        for (i in seq_len(nrow(links))) {
            out.links[[i]] <- list(
                type = "link",
                path = sanitize_path(links$from.path[i]),
                link = list(
                    project = links$to.project[i],
                    asset = links$to.asset[i],
                    version = links$to.version[i],
                    path = sanitize_path(links$to.path[i])
                )
            )
        }
        formatted <- c(formatted, out.links)
    }

    url <- chomp_url(url)
    req <- request(paste0(url, "/upload/start/", uenc(project), "/", uenc(asset), "/", uenc(version)))
    req <- req_method(req, "POST")
    req <- req_body_json(req, list(files=formatted, on_probation=probation))
    req <- req_auth_bearer_token(req, token)
    req <- process_error(req)

    res <- req_perform(req)
    resp_body_json(res)
}

---
title: Interacting with the gypsum REST API
author:
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
package: gypsum
date: "Revised: April 2, 2024"
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Hitting the gypsum API}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE}
library(BiocStyle)
self <- Biocpkg("gypsum")
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)
```

# Introduction

The `r self` package implements an R client for the [API of the same name](https://gypsum-test.aaron-lun.workers.dev).
This allows Bioconductor packages to easily store and retrieve data from the **gypsum** backend.
It also provides mechanisms to allow package maintainers to easily manage upload authorizations and third-party contributions.
Readers are referred to [API's documentation](https://github.com/ArtifactDB/gypsum-worker) for a description of the concepts;
this guide will strictly focus on the usage of the `r self` package.

# Reading files

`r self` provides several convenience methods for reading from the **gypsum** bucket:

```{r}
library(gypsum)
listAssets("test-R")
listVersions("test-R", "basic")
listFiles("test-R", "basic", "v1")

out <- saveFile("test-R", "basic", "v1", "blah.txt")
readLines(out)

dir <- saveVersion("test-R", "basic", "v1")
list.files(dir, all.files=TRUE, recursive=TRUE)
```

We can fetch the summaries and manifests for each version of a project's assets.

```{r}
fetchManifest("test-R", "basic", "v1")
fetchSummary("test-R", "basic", "v1")
```

We can get the latest version of an asset:

```{r}
fetchLatest("test-R", "basic")
```

All read operations involve a publicly accessible bucket so no authentication is required.

# Uploading files

## Basic usage

To demonstrate, let's say we have a directory of files that we wish to upload to the backend.

```{r}
tmp <- tempfile()
dir.create(tmp)
write(file=file.path(tmp, "foo"), letters)
write(file=file.path(tmp, "bar"), LETTERS)
write(file=file.path(tmp, "whee"), 1:10)
```

We run the upload sequence of `startUpload()`, `uploadFiles()` and `completeUpload()`.
This requires authentication via GitHub, which is usually prompted but can also be set beforehand via `setAccessToken()` (e.g., for batch jobs).

```r
init <- startUpload(
    project=project_name,
    asset=asset_name,
    version=version_name,
    files=list.files(tmp, recursive=TRUE),
    directory=tmp
)

tryCatch({
    uploadFiles(init, directory=tmp)
    completeUpload(init)
}, error=function(e) {
    abortUpload(init) # clean up if the upload fails.
    stop(e)
})
```

We can also set `concurrent=` to parallelize the uploads in `uploadFiles()`.

## Link generation

More advanced developers can use `links=` in `startUpload()` to improve efficiency by deduplicating redundant files on the **gypsum** backend.
For example, if we wanted to link to some files in our `test-R` project, we might do:

```r
# Creates links from lun/aaron.txt ==> test-R/basic/v1/foo/bar.txt
# and kancherla/jayaram ==> test-R/basic/v1/blah.txt
init <- startUpload(
    project=project_name,
    asset=asset_name,
    version=version_name,
    files=character(0),
    links=data.frame(
        from.path=c("lun/aaron.txt", "kancherla/jayaram.txt"),
        to.project=c("test-R", "test-R"),
        to.asset=c("basic", "basic"),
        to.version=c("v1", "v1"),
        to.path=c("foo/bar.txt", "blah.txt")
    ),
    directory=tmp
)
```

This functionality is particularly useful when creating new versions of existing assets.
Only the modified files need to be uploaded, while the rest of the files can be linked to their counterparts in the previous version.
In fact, this pattern is so common that it can be expedited via `cloneVersion()` and `prepareDirectoryUpload()`:

```{r}
dest <- tempfile()
cloneVersion("test-R", "basic", "v1", destination=dest)

# Do some modifications in 'dest' to create a new version, e.g., add a file.
# However, users should treat symlinks as read-only - so if you want to modify
# a file, instead delete the symlink and replace it with a new file.
write(file=file.path(dest, "BFFs"), c("Aaron", "Jayaram"))

to.upload <- prepareDirectoryUpload(dest)
to.upload
```

Then we can just pass these values along to `startUpload()` to take advantage of the upload links:

```r
init <- startUpload(
    project=project_name,
    asset=asset_name,
    version=version_name,
    files=to.upload$files,
    links=to.upload$links,
    directory=dest
)
```

# Changing permissions

Upload authorization is determined by each project's permissions, which are controlled by project owners.
Both uploaders and owners are identified based on their GitHub logins:

```{r}
fetchPermissions("test-R")
```

Owners can add more uploaders (or owners) via the `setPermissions()` function.
Uploaders can be scoped to individual assets or versions, and an expiry date may be attached to each authorization:

```r
setPermissions("test-R", 
    uploaders=list(
        list(
            id="jkanche", 
            until=Sys.time() + 24 * 60 * 60,
            asset="jays-happy-fun-time",
            version="1"
        )
    )
)
```

Organizations may also be added in the permissions, in which case the authorization extends to all members of that organization.

# Probational uploads

Unless specified otherwise, all uploaders are considered to be "untrusted".
Any uploads from such untrusted users are considered "probational" and must be approved by the project owners before they are considered complete.
Alternatively, an owner may reject an upload, which deletes all the uploaded files from the backend.

```r
approveProbation("test-R", "third-party-upload", "good")
rejectProbation("test-R", "third-party-upload", "bad")
```

An uploader can be trusted by setting `trusted=TRUE` in `setPermissions()`.
Owners and trusted uploaders may still perform probational uploads (e.g., for testing) by setting `probation=TRUE` in `startUpload()`.

# Inspecting the quota

Each project has a quota that specifies how much storage space is available for uploaders.
The quota is computed as a linear function of `baseline + growth_rate * (NOW - year)`,
which provides some baseline storage that grows over time.

```{r}
fetchQuota("test-R")
```

Once the project's contents exceed this quota, all uploads are blocked.
The current usage of the project can be easily inspected:

```{r}
fetchUsage("test-R")
```

Changes to the quota must be performed by administrators, see [below](#administration).

# Validating metadata

Databases can operate downstream of the **gypsum** backend to create performant search indices, usually based on special metadata files.
`r self` provides some utilities to check that metadata follows the JSON schema of some known downstream databases.

```{r}
schema <- fetchMetadataSchema()
cat(head(readLines(schema)), sep="\n")
```

Uploaders can verify that their metadata respects this schema via the `validateMetadata()` function.
This ensures that the uploaded files can be successfully indexed by the database, given that the **gypsum** backend itself applies no such checks.

```{r}
metadata <- list(                           
    title="Fatherhood",
    description="Luke ich bin dein Vater.",
    sources=list(
       list(provider="GEO", id="GSE12345")
    ),
    taxonomy_id=list("9606"),
    genome=list("GRCm38"),
    maintainer_name="Darth Vader",
    maintainer_email="vader@empire.gov",
    bioconductor_version="3.10"
)

validateMetadata(metadata, schema)
```

# Administration

Administrators of the **gypsum** instance can create projects with new permissions:

```r
createProject("my-new-project", 
    owners="jkanche", 
    uploaders=list(
        list(
            id="LTLA", 
            asset="aarons-stuff"
        )
    )
)
```

They can alter the quota parameters for a project:

```r
setQuota("my-new-project",
    baseline=10 * 2^30,
    growth=5 * 2^30,
    year=2019
)
```

They can manually refresh the latest version for an asset and the quota usage for a project.
This is only required on very rare occasions where there are simultaneous uploads to the same project.

```r
refreshLatest("test-R", "basic")
refreshUsage("test-R")
```

Administrators may also delete projects, assets or versions, though this should be done sparingly as it violates **gypsum**'s expectations of immutability.

```r
removeProject("my-new_project")
```

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchManifest.R
\name{fetchManifest}
\alias{fetchManifest}
\title{Fetch version manifest}
\usage{
fetchManifest(
  project,
  asset,
  version,
  cache = cacheDirectory(),
  overwrite = FALSE,
  url = restUrl(),
  config = NULL
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{cache}{String containing the cache directory.
If \code{NULL}, no caching is performed.}

\item{overwrite}{Logical scalar indicating whether to overwrite an existing file in \code{cache}, if one is present.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
List containing the manifest for this version.
Each element is named after the relative path of a file in this version.
The value of each element is another list with the following fields:
\itemize{
\item \code{size}, an integer specifying the size of the file in bytes.
\item \code{md5sum}, a string containing the hex-encoded MD5 checksum of the file.
\item \code{link} (optional): a list specifying the link destination for a file. 
This contains the strings \code{project}, \code{asset}, \code{version} and \code{path}.
If the link destination is itself a link, an \code{ancestor} list will be present that specifies the final location of the file after resolving all intermediate links.
}
}
\description{
Fetch the manifest for a version of an asset of a project.
}
\examples{
fetchManifest("test-R", "basic", "v1")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setQuota.R
\name{setQuota}
\alias{setQuota}
\title{Set project quota}
\usage{
setQuota(
  project,
  baseline = NULL,
  growth = NULL,
  year = NULL,
  url = restUrl(),
  token = accessToken()
)
}
\arguments{
\item{project}{String containing the project name.}

\item{baseline}{Numeric scalar specifying the baseline quota (i.e., at time zero) in bytes.
If \code{NULL}, no change is made to the existing baseline of the project.}

\item{growth}{Numeric scalar specifying the annual growth rate of the quota, in bytes.
If \code{NULL}, no change is made to the existing growth rate of the project.}

\item{year}{Integer scalar specifying the year of creation (i.e., time zero) for the project.
If \code{NULL}, no change is made to the existing creation year of the project.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
\code{NULL} is invisibly returned upon successful setting of the quota.
}
\description{
Set the storage quota for a project.
}
\examples{
if (interactive()) {
    # Creating a project for demonstration purposes.
    createProject("test-R-quota", owners="LTLA")

    # Setting a baseline of 10 GB with 5 GB in growth per year.
    setQuota("test-R-quota", baseline=10^10, growth=5^9, year=2019)
}

}
\seealso{
\code{\link{fetchQuota}}, to fetch the quota.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchMetadataDatabase.R
\name{fetchMetadataDatabase}
\alias{fetchMetadataDatabase}
\title{Fetch a metadata database}
\usage{
fetchMetadataDatabase(
  name = "bioconductor.sqlite3",
  cache = cacheDirectory(),
  overwrite = FALSE
)
}
\arguments{
\item{name}{String containing the name of the database.
This can be the name of any SQLite file in \url{https://github.com/ArtifactDB/bioconductor-metadata-index/releases/tag/latest}.}

\item{cache}{String containing the cache directory.
If \code{NULL}, no caching is performed.}

\item{overwrite}{Logical scalar indicating whether to overwrite an existing file in \code{cache}, if one is present.}
}
\value{
String containing a path to the downloaded database.
}
\description{
Fetch a SQLite database containing metadata from the gypsum backend
(see \url{https://github.com/ArtifactDB/bioconductor-metadata-index}).
Each database is generated by aggregating metadata across multiple assets and/or projects,
and can be used to perform searches for interesting objects.
}
\details{
This function will automatically check for updates to the SQLite files and will download new versions accordingly.
New checks are performed when one hour or more has elapsed since the last check.
If the check fails, a warning is raised and the function returns the currently cached file.
}
\examples{
fetchMetadataDatabase()
}
\seealso{
\code{\link{fetchMetadataSchema}}, to get the JSON schema used to define the database tables.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/startUpload.R
\name{startUpload}
\alias{startUpload}
\title{Start an upload}
\usage{
startUpload(
  project,
  asset,
  version,
  files,
  links = NULL,
  deduplicate = TRUE,
  probation = FALSE,
  url = restUrl(),
  token = accessToken(),
  directory = NULL
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.
This should not contain \code{/} or start with \code{..}.}

\item{version}{String containing the version name.
This should not contain \code{/} or start with \code{..}.}

\item{files}{Character vector containing the paths of the files to be uploaded.
These should be relative to the version's \code{directory}. 

Alternatively, a data frame where each row corresponds to a file and contains information about those files.
This data frame should contain the following fields:
\itemize{
\item \code{path}, a string containing the relative path of the file inside the version's subdirectory.
\item \code{size}, a non-negative integer specifying the size of the file in bytes.
\item \code{md5sum}, a string containing the hex-encoded MD5 checksum of the file.
\item (optional) \code{dedup}, a logical indicating whether deduplication should be attempted for each file.
}}

\item{links}{A data frame where each row corresponds to a linked-from file and contains the link destination for that file.
This data frame should contain the following fields:
\itemize{
\item \code{from.path}, a string containing the relative path of the file inside the version's subdirectory.
\item \code{to.project}, a string containing the project of the list destination.
\item \code{to.asset}, a string containing the asset of the list destination.
\item \code{to.version}, a string containing the version of the list destination.
\item \code{to.path}, a string containing the path of the list destination.
}}

\item{deduplicate}{Logical scalar indicating whether the backend should attempt deduplication of \code{files} in the immediately previous version.
Only has an effect if \code{files} is not a data frame or if the \code{dedup} field is missing.}

\item{probation}{Logical scalar indicating whether to perform a probational upload.
Such uploads must be approved by the project owner before they are considered official.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a user that is authorized to upload to the specified \code{project}.}

\item{directory}{String containing the path to a directory containing the \code{files} to be uploaded.
This directory is assumed to correspond to a version of an asset.
It only has an effect if \code{files} is a character vector, as it is used to determine the MD5 checksums and sizes.
If \code{NULL}, \code{directory} is set to the current working directory.}
}
\value{
List containing:
\itemize{
\item \code{file_urls}, a list of lists containing information about each file to be uploaded.
This is used by \code{\link{uploadFiles}}.
\item \code{complete_url}, a string containing the completion URL, to be used by \code{\link{completeUpload}}.
\item \code{abort_url}, a string specifying the abort URL, to be used by \code{\link{abortUpload}}.
\item \code{session_token}, a string for authenticating to the newly initialized upload session.
}
}
\description{
Start an upload of a new version of an asset, or a new asset of a project.
}
\examples{
tmp <- tempfile()
dir.create(tmp)
write(file=file.path(tmp, "blah.txt"), LETTERS)
dir.create(file.path(tmp, "foo"))
write(file=file.path(tmp, "foo", "bar.txt"), 1:10)

if (interactive()) {
    blob <- startUpload(
        project="test-R", 
        asset="upload-start-check", 
        version="v1", 
        files=list.files(tmp, recursive=TRUE),
        directory=tmp
    )
    print(blob)

    abortUpload(blob) # just cleaning up after we're done.
}

}
\seealso{
\code{\link{uploadFiles}}, to actually upload the files.

\code{\link{completeUpload}}, to indicate that the upload is completed.

\code{\link{abortUpload}}, to abort an upload in progress.

\code{\link{prepareDirectoryUpload}}, to create \code{files} and \code{links} from a directory.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/listVersions.R
\name{listVersions}
\alias{listVersions}
\title{List asset versions}
\usage{
listVersions(project, asset, url = restUrl(), config = NULL)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
Character vector of versions.
}
\description{
List all versions of a project asset.
}
\examples{
listVersions("test-R", "basic")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/listAssets.R
\name{listAssets}
\alias{listAssets}
\title{List assets}
\usage{
listAssets(project, url = restUrl(), config = NULL)
}
\arguments{
\item{project}{String containing the project name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
Character vector of asset names.
}
\description{
List all assets in a project.
}
\examples{
listAssets("test-R")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/uploadFiles.R
\name{uploadFiles}
\alias{uploadFiles}
\title{Upload files for a versioned asset}
\usage{
uploadFiles(init, directory = NULL, url = restUrl(), concurrent = 1)
}
\arguments{
\item{init}{List containing \code{file_urls} and \code{session_token}.
This is typically the return value from \code{\link{startUpload}}.}

\item{directory}{String containing the path to a directory containing the \code{files} to be uploaded.
This directory is assumed to correspond to a version of an asset.
It only has an effect if \code{files} is a character vector, as it is used to determine the MD5 checksums and sizes.
If \code{NULL}, \code{directory} is set to the current working directory.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{concurrent}{Integer specifying the number of concurrent uploads.}
}
\value{
\code{NULL} is invisibly returned on successful upload of all files.
}
\description{
Upload files in an initialized upload session for a version of an asset.
}
\examples{
tmp <- tempfile()
dir.create(tmp)
write(file=file.path(tmp, "blah.txt"), LETTERS)
dir.create(file.path(tmp, "foo"))
write(file=file.path(tmp, "foo", "bar.txt"), 1:10)

if (interactive()) {
    init <- startUpload(
        project="test-R", 
        asset="upload-files-check", 
        version="v1", 
        files=list.files(tmp, recursive=TRUE),
        directory=tmp
    )

    # Executing the upload for all files.
    uploadFiles(init, directory=tmp)

    # Cleaning up after we're done.
    abortUpload(init) 
}

}
\seealso{
\code{\link{startUpload}}, to create \code{init}.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/createProject.R
\name{createProject}
\alias{createProject}
\title{Create a new project}
\usage{
createProject(
  project,
  owners,
  uploaders = list(),
  baseline = NULL,
  growth = NULL,
  year = NULL,
  url = restUrl(),
  token = accessToken()
)
}
\arguments{
\item{project}{String containing the project name.}

\item{owners}{Character vector containing the GitHub users or organizations that are owners of this project.}

\item{uploaders}{List specifying the authorized uploaders for this project.
See the \code{uploaders} field in the \code{\link{fetchPermissions}} return value for the expected format.}

\item{baseline}{Numeric scalar specifying the baseline quota in bytes.
If \code{NULL}, the backend's default is used.}

\item{growth}{Numeric scalar specifying the quota's annual growth rate in bytes.
If \code{NULL}, the backend's default is used.}

\item{year}{Integer scalar specifying the year of the project creation.
If \code{NULL}, the backend's default is used - this should be the current year.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
\code{NULL} is invisibly returned if the project was successfully created.
}
\description{
Create a new project with the associated permissions.
}
\examples{
if (interactive()) {
    createProject(
        "test-R-create", 
        owners="LTLA", 
        uploaders=list(list(id="ArtifactDB-bot"))
    )
}
}
\seealso{
\code{\link{removeProject}}, to remove a project.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchSummary.R
\name{fetchSummary}
\alias{fetchSummary}
\title{Fetch version summary}
\usage{
fetchSummary(
  project,
  asset,
  version,
  cache = cacheDirectory(),
  overwrite = FALSE,
  url = restUrl(),
  config = NULL
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{cache}{String containing the cache directory.
If \code{NULL}, no caching is performed.}

\item{overwrite}{Logical scalar indicating whether to overwrite an existing file in \code{cache}, if one is present.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
List containing the summary for this version, with the following fields:
\itemize{
\item \code{upload_user_id}, string containing the identity of the uploader.
\item \code{upload_start}, a \link{POSIXct} object containing the upload start time.
\item \code{upload_finish}, a \link{POSIXct} object containing the upload finish time.
\item \code{on_probation} (optional), a logical scalar indicating whether the upload is probational.
If missing, this can be assumed to be \code{FALSE}.
}
}
\description{
Fetch the summary for a version of an asset of a project.
}
\examples{
fetchSummary("test-R", "basic", "v1")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchLatest.R
\name{fetchLatest}
\alias{fetchLatest}
\title{Fetch the latest version}
\usage{
fetchLatest(project, asset, url = restUrl(), config = NULL)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
String containing the latest version of the project.
}
\description{
Fetch the latest version of a project's asset.
}
\examples{
fetchLatest("test-R", "basic")

}
\seealso{
\code{\link{refreshLatest}}, to refresh the latest version.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/formatObjectMetadata.R
\name{formatObjectMetadata}
\alias{formatObjectMetadata}
\title{Format object-related metadata}
\usage{
formatObjectMetadata(x)
}
\arguments{
\item{x}{An R object, typically an instance of a Bioconductor class.}
}
\value{
List containing the object-related metadata, typically stored in the \code{applications.takane} field of the metadata.
}
\description{
Create object-related metadata to validate against the default schema from \code{\link{fetchMetadataSchema}}.
This is intended for downstream package developers who are auto-generating metadata documents to be validated by \code{\link{validateMetadata}}.
}
\examples{
df <- S4Vectors::DataFrame(alpha=LETTERS, numeric=runif(26))
formatObjectMetadata(df)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/removeAsset.R
\name{removeAsset}
\alias{removeAsset}
\title{Remove an asset}
\usage{
removeAsset(project, asset, url = restUrl(), token = accessToken())
}
\arguments{
\item{project}{String containing the project to remove.}

\item{asset}{String containing the asset to remove.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
\code{NULL} is invisibly returned if the asset was successfully removed.
}
\description{
Remove an asset of a project from the gypsum backend.
}
\examples{
if (interactive()) {
    # Mocking up a versioned asset.
    init <- startUpload(
        project="test-R", 
        asset="removal", 
        version="v1", 
        files=character(0),
        probation=TRUE
    )
    completeUpload(init) 

    removeAsset("test-R", asset="removal")
}
}
\seealso{
\code{\link{removeProject}}, to remove a project.

\code{\link{removeVersion}}, to remove a specific version.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/validateMetadata.R
\name{validateMetadata}
\alias{validateMetadata}
\title{Validate metadata against a JSON schema}
\usage{
validateMetadata(metadata, schema = fetchMetadataSchema(), stringify = NULL)
}
\arguments{
\item{metadata}{Metadata to be checked.
This is usually an R object like a named list, but may also be a JSON-formatted string.}

\item{schema}{String containing a path to a schema.}

\item{stringify}{Logical scalar indicating whether to convert \code{metadata} to a JSON-formatted string.
Defaults to \code{TRUE} if \code{metadata} is not already a string.}
}
\value{
NULL is invisibly returned upon successful validation.
}
\description{
Validate metadata against a JSON schema for a SQLite database.
This ensures that it can be successfully inserted in the database in downstream indexing steps.
}
\examples{
metadata <- list(
    title="Fatherhood",
    description="Luke ich bin dein Vater.",
    sources=list(
       list(provider="GEO", id="GSE12345")
    ),
    taxonomy_id=list("9606"),
    genome=list("GRCm38"),
    maintainer_name="Darth Vader",
    maintainer_email="vader@empire.gov",
    bioconductor_version="3.10"
)

validateMetadata(metadata)

}
\seealso{
\code{\link{fetchMetadataSchema}}, to get the JSON schemas.

\code{\link{fetchMetadataDatabase}}, to obtain the SQLite database files.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rejectProbation.R
\name{rejectProbation}
\alias{rejectProbation}
\title{Reject a probational upload}
\usage{
rejectProbation(
  project,
  asset,
  version,
  url = restUrl(),
  token = accessToken()
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to an owner of \code{project}.}
}
\value{
\code{NULL} is invisibly returned upon successful rejection.
}
\description{
Pretty much as it says: reject a probational upload of a version of a project's asset.
This removes all files associated with that version.
}
\examples{
if (interactive()) {
    # Mocking up a versioned asset.
    init <- startUpload(
        project="test-R", 
        asset="probation-reject", 
        version="v1", 
        files=character(0),
        probation=TRUE
    )
    completeUpload(init) 

    # Rejecting the probation:
    rejectProbation("test-R", "probation-reject", "v1")
}

}
\seealso{
\code{\link{approveProbation}}, to approve the probational upload.

\code{\link{startUpload}}, to specify probational uploads.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/removeVersion.R
\name{removeVersion}
\alias{removeVersion}
\title{Remove a version of an asset}
\usage{
removeVersion(project, asset, version, url = restUrl(), token = accessToken())
}
\arguments{
\item{project}{String containing the project to remove.}

\item{asset}{String containing the asset to remove.}

\item{version}{String containing the version of the asset to remove.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
\code{NULL} is invisibly returned if the project or its contents was successfully removed.
}
\description{
Remove a version of an asset from the gypsum backend.
}
\examples{
if (interactive()) {
    # Mocking up a versioned asset.
    init <- startUpload(
        project="test-R", 
        asset="removal", 
        version="v1", 
        files=character(0),
        probation=TRUE
    )
    completeUpload(init) 

    removeVersion("test-R", asset="removal", version="v1")
}
}
\seealso{
\code{\link{removeAsset}} and \code{\link{removeProject}}, to remove an asset or project.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchPermissions.R
\name{fetchPermissions}
\alias{fetchPermissions}
\title{Fetch project permissions}
\usage{
fetchPermissions(project, url = restUrl(), config = NULL)
}
\arguments{
\item{project}{String containing the project name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
List containing the permissions for this project.
This has the following elements:
\itemize{
\item \code{owners}, a character vector containing the GitHub users or organizations that are owners of this project.
\item \code{uploaders}, a list of lists specifying the users or organizations who are authorzied to upload to this project.
Each entry is a list with the following fields:
\itemize{
\item \code{id}, a string containing the GitHub user or organization that is authorized to upload.
\item (optional) \code{asset}, a string containing the name of the asset that the uploader is allowed to upload to.
If not provided, there is no restriction on the uploaded asset name.
\item (optional) \code{version}, a string containing the name of the version that the uploader is allowed to upload to.
If not provided, there is no restriction on the uploaded version name.
\item (optional) \code{until}, a \link{POSIXct} object containing the expiry date of this authorization.
If not provided, the authorization does not expire.
\item (optional) \code{trusted}, whether the uploader is trusted.
If not provided, defaults to \code{FALSE}.
}
}
}
\description{
Fetch the permissions for a project.
}
\examples{
fetchPermissions("test-R")

}
\seealso{
\code{\link{setPermissions}}, to set the permissions.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveVersion.R
\name{saveVersion}
\alias{saveVersion}
\title{Save all files for a version of a project asset}
\usage{
saveVersion(
  project,
  asset,
  version,
  cache = cacheDirectory(),
  overwrite = FALSE,
  relink = TRUE,
  concurrent = 1,
  url = restUrl(),
  config = NULL
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{cache}{String containing the path to the cache directory.}

\item{overwrite}{Logical scalar indicating whether to overwrite existing files in the cache.
If \code{FALSE} and the files already exist in \code{cache}, the download is skipped.}

\item{relink}{Logical scalar indicating whether links should be resolved, see \code{\link{resolveLinks}}.}

\item{concurrent}{Integer specifying the number of concurrent downloads.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
The version's files are downloaded to the local file system, and the path to the local subdirectory is returned.
}
\description{
Download all files associated with a version of an asset of a project from the gypsum bucket.
}
\examples{
out <- saveVersion("test-R", "basic", "v1")
list.files(out, recursive=TRUE, all.files=TRUE)

}
\seealso{
\code{\link{saveFile}}, to save a single file.

\code{\link{cacheDirectory}}, for file caching.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/searchMetadata.R
\name{searchMetadata}
\alias{searchMetadata}
\alias{gypsum.search.clause}
\alias{Ops.gypsum.search.clause}
\alias{searchMetadataText}
\alias{defineTextQuery}
\alias{searchMetadataTextFilter}
\alias{gsc}
\alias{searchMetadataFilter}
\title{Search the metadata database}
\usage{
searchMetadata(path, query, latest = TRUE, include.metadata = TRUE)

gsc(
  text = NULL,
  project = NULL,
  asset = NULL,
  version = NULL,
  path = NULL,
  user = NULL,
  time = NULL,
  field = NULL,
  partial = FALSE,
  after = TRUE
)

searchMetadataFilter(
  query,
  pid.name = "paths.pid",
  project.name = "versions.project",
  asset.name = "versions.asset",
  version.name = "versions.version",
  path.name = "paths.path",
  user.name = "versions.user",
  time.name = "versions.time"
)
}
\arguments{
\item{path}{For \code{searchMetadata}, a string containing a path to a SQLite file, usually obtained via \code{\link{fetchMetadataDatabase}}.

For \code{gsc}, the suffix of the object key of the metadata document, 
i.e., the relative \dQuote{path} to the metadata file inside the version's \dQuote{directory}.
This may be missing as long as other arguments are supplied to \code{gsc}.}

\item{query}{A gypsum.search.clause object, typically produced by \code{gsc} or \code{\link{translateTextQuery}}.}

\item{latest}{Logical scalar indicating whether to only search for matches within the latest version of each asset.}

\item{include.metadata}{Logical scalar indicating whether metadata should be returned.}

\item{text}{String containing the text to query on.
This will be automatically tokenized, see Details.
This may be missing as long as other arguments are supplied to \code{gsc}.}

\item{project}{String containing the name of the project.
This may be missing as long as other arguments are supplied to \code{gsc}.}

\item{asset}{String containing the name of the asset.
This may be missing as long as other arguments are supplied to \code{gsc}.}

\item{version}{String containing the name of the version.
This may be missing as long as other arguments are supplied to \code{gsc}.}

\item{user}{String containing the user ID of the uploader.
This may be missing as long as other arguments are supplied to \code{gsc}.}

\item{time}{Number specifying the Unix timestamp (in seconds) at which the upload was finished.
This may be missing as long as other arguments are supplied to \code{gsc}.}

\item{field}{String specifying the name of the metadata field in which to search for \code{text}.
If \code{NULL}, the search is performed on all available metadata fields.}

\item{partial}{For \code{gsc}, a logical scalar indicating whether \code{text}, \code{project}, \code{asset}, \code{version}, \code{path} or \code{user} 
contains SQLite wildcards (\code{\%}, \code{_}) for a partial search.
For \code{text}, setting \code{partial=TRUE} also ensures that the wildcards are preserved during tokenization.}

\item{after}{Logical scalar indicating whether to search for documents that were uploaded after \code{time}.
If \code{FALSE}, the search will instead consider documents that were uploaded at or before \code{time}.}

\item{pid.name}{String containing the name/alias of the column of the \code{paths} table that contains the path ID.}

\item{project.name}{String containing the name/alias of the column of the \code{versions} table that contains the project name.}

\item{asset.name}{String containing the name/alias of the column of the \code{versions} table that contains the asset name.}

\item{version.name}{String containing the name/alias of the column of the \code{versions} table that contains the version name.}

\item{path.name}{String containing the name/alias of the column of the \code{paths} table that contains the path name.}

\item{user.name}{String containing the name/alias of the column of the \code{versions} table that contains the user ID of the uploader.}

\item{time.name}{String containing the name/alias of the column of the \code{versions} table that contains the upload time.}
}
\value{
For \code{searchMetadata}, a data frame specifying the contaning the search results.
\itemize{
\item The \code{project}, \code{asset} and \code{version} columns specify the version of the project asset with matching metadata.
\item The \code{path} column contains the suffix of the object key of the metadata document,
i.e., the relative \dQuote{path} within the version's \dQuote{directory} to the metadata document.
The full object key of the document inside the bucket is defined as \code{{project}/{asset}/{version}/{path}}.
\item The \code{user} column contains the identity of the uploading user.
\item The \code{time} column contains the time of the upload.
\item If \code{include.metadata=TRUE}, a \code{metadata} column is present with the nested metadata for each match.
\item If \code{latest=TRUE}, a \code{latest} column is present indicating whether the matching version is the latest for its asset.
Otherwise, only the latest version is returned.
}

For \code{searchMetadataFilter}, a list containing \code{where}, a string can be directly used as a WHERE filter condition in a SQL SELECT statement;
and \code{parameters}, the parameter bindings to be used in \code{where}.
The return value may also be \code{NULL} if the query has no well-defined filter.

For \code{gsc}, a gypsum.search.clause object that can be used in \code{|}, \code{&} and \code{!} to create more complex queries involving multiple clauses.
}
\description{
Search a SQLite database containing metadata from the gypsum backend.
This is based on a precomputed tokenization of all string properties in each metadata document;
see \url{https://github.com/ArtifactDB/bioconductor-metadata-index} for details.
}
\details{
Each query string is tokenized by converting it to lower case and splitting it on characters that are not Unicode letters/numbers or a dash.
We currently do not remove diacritics so these will need to be converted to ASCII by the user. 
If a text query involves only non-letter/number/dash characters, the filter will not be well-defined and will be ignored when constructing SQL statements.
The metadata document/field is only considered to match the query string if all of the tokens can be found in that document/field (in any order).
}
\examples{
path <- fetchMetadataDatabase()
searchMetadata(path, gsc("mouse brain"), include.metadata=FALSE)

# Now for a slightly more complex query:
query <- (gsc("brain") | gsc("pancreas")) & gsc("10090", field="taxonomy_id")
searchMetadata(path, query, include.metadata=FALSE)

# Throwing in some wildcards.
has.neuro <- gsc("Neuro\%", partial=TRUE)
searchMetadata(path, has.neuro, include.metadata=FALSE)

# We can also query other properties.
datasets <- gsc(project="scRNAseq") & gsc(asset="l\%", partial=TRUE)
searchMetadata(path, datasets, include.metadata=FALSE)

}
\seealso{
\code{\link{fetchMetadataDatabase}}, to download and cache the database files.

\url{https://github.com/ArtifactDB/bioconductor-metadata-index}, for details on the SQLite file contents and table structure.

\code{\link{translateTextQuery}}, to create a gypsum.search.clause from human-friendly syntax.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/resolveLinks.R
\name{resolveLinks}
\alias{resolveLinks}
\title{Resolve links in the cache directory}
\usage{
resolveLinks(
  project,
  asset,
  version,
  cache = cacheDirectory(),
  overwrite = FALSE,
  url = restUrl(),
  config = NULL
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{cache}{String containing the path to the cache directory.}

\item{overwrite}{Logical scalar indicating whether to replace existing files at the linked-from paths.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
\code{NULL} is returned on successful completion.
}
\description{
Create hard links (or copies, if filesystem links are not supported) for linked-from files to their link destinations.
}
\examples{
cache <- tempfile()
saveVersion("test-R", "basic", "v3", relink=FALSE, cache=cache)
list.files(cache, recursive=TRUE, all.files=TRUE)

resolveLinks("test-R", "basic", "v3", cache=cache)
list.files(cache, recursive=TRUE, all.files=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cloneVersion.R
\name{cloneVersion}
\alias{cloneVersion}
\title{Clone a version's directory structure}
\usage{
cloneVersion(
  project,
  asset,
  version,
  destination,
  download = TRUE,
  cache = cacheDirectory(),
  url = restUrl(),
  config = NULL,
  ...
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{destination}{String containing a path to a destination directory at which to create the clone.}

\item{download}{Logical scalar indicating whether the version's files should be downloaded first.
This can be set to \code{FALSE} to create a clone without actually downloading any of the version's files.}

\item{cache}{String containing the path to the cache directory.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}

\item{...}{Further arguments to pass to \code{\link{saveVersion}}.
Only used if \code{download=TRUE}.}
}
\value{
The directory structure of the specified version is cloned to \code{destination},
and a \code{NULL} is invisibly returned.
}
\description{
Clone the directory structure for a versioned asset into a separate location.
This is typically used to prepare a new version for a lightweight upload.
}
\details{
Cloning of a versioned asset involves creating a directory at \code{destination} that has the same contents as the corresponding project-asset-version directory.
All files in the specified version are represented as symlinks from \code{destination} to the corresponding file in the \code{cache}. 
The idea is that, when \code{destination} is used in \code{\link{prepareDirectoryUpload}}, 
the symlinks are converted into upload links, i.e., \code{links=} in \code{\link{startUpload}}.
This allows users to create new versions very cheaply as duplicate files are not uploaded to/stored in the backend.

Users can more-or-less do whatever they want inside the cloned \code{destination}, but they should treat the symlink targets as read-only.
That is, they should not modify the contents of the linked-to file, as these refer to assumed-immutable files in the \code{cache}.
If a file in \code{destination} needs to be modified, the symlink should be deleted and replaced with an actual file;
this avoids mutating the \code{cache} and it ensures that \code{\link{prepareDirectoryUpload}} recognizes that a new file actually needs to be uploaded.

Advanced users can set \code{download=FALSE}, in which case symlinks are created even if their targets are not present in \code{cache}.
In such cases, \code{destination} should be treated as write-only due to the potential presence of dangling symlinks.
This mode is useful for uploading a new version of an asset without downloading the files from the existing version,
assuming that the modifications associated with the former can be achieved without reading any of the latter.

On Windows, the user may not have permissions to create symbolic links, so the function will transparently fall back to creating hard links or copies instead.
This precludes any optimization by \code{\link{prepareDirectoryUpload}} as the hard links/copies cannot be converted into upload links.
It also assumes that \code{download=TRUE} as dangling links/copies cannot be created.
}
\examples{
tmp <- tempfile()
out <- cloneVersion("test-R", "basic", "v1", destination=tmp)
list.files(tmp, recursive=TRUE)
Sys.readlink(file.path(tmp, "foo", "bar.txt"))

# Files should be replaced rather than modified via the symlink:
existing <- file.path(tmp, "foo", "bar.txt")
unlink(existing) # Deleting the symlink...
write(file=existing, "YAY") # ... and writing a replacement file.

# Symlinks are converted to upload links:
prepareDirectoryUpload(tmp)
}
\seealso{
\code{\link{prepareDirectoryUpload}}, to prepare an upload based on the directory contents.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchUsage.R
\name{fetchUsage}
\alias{fetchUsage}
\title{Fetch project usage details}
\usage{
fetchUsage(project, url = restUrl(), config = NULL)
}
\arguments{
\item{project}{String containing the project name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
Numeric scalar specifying the quota usage for the project, in bytes.
}
\description{
Fetch the quota usage for a project.
}
\examples{
fetchUsage("test-R")

}
\seealso{
\code{\link{refreshUsage}}, to recompute the used quota.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/listFiles.R
\name{listFiles}
\alias{listFiles}
\title{List files for a version}
\usage{
listFiles(
  project,
  asset,
  version,
  prefix = NULL,
  include.. = TRUE,
  url = restUrl(),
  config = NULL
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{prefix}{String containing the remaining prefix for the object key.
If provided, a file is only listed if its object key starts with \code{{project}/{asset}/{version}/{prefix}}.
If \code{NULL}, all files associated with this version of the asset are listed.}

\item{include..}{Logical scalar indicating whether to list files with \code{/..} in their object keys.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
Character vector of relative paths of files associated with the versioned asset.
}
\description{
List files belonging to a version of a project asset.
}
\examples{
listFiles("test-R", "basic", "v1")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/removeProject.R
\name{removeProject}
\alias{removeProject}
\title{Remove a project}
\usage{
removeProject(project, url = restUrl(), token = accessToken())
}
\arguments{
\item{project}{String containing the project to remove.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
\code{NULL} is invisibly returned if the project was successfully removed.
}
\description{
Remove a project from the gypsum backend.
}
\examples{
if (interactive()) {
    createProject("test-R-remove", owners="LTLA")
    removeProject("test-R-remove")
}
}
\seealso{
\code{\link{createProject}}, to create a project.

\code{\link{removeAsset}} and \code{\link{removeVersion}}, to remove an asset or version.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cacheDirectory.R
\name{cacheDirectory}
\alias{cacheDirectory}
\title{Cache directory}
\usage{
cacheDirectory(dir)
}
\arguments{
\item{dir}{String containing the path to a cache directory.}
}
\value{
If \code{dir} is missing, the current setting of the cache directory is returned.

If \code{dir} is provided, it is used to replace the current setting of the cache directory,
and the \emph{previous} setting is invisibly returned.
}
\description{
Specify the cache directory in the local filesystem for gypsum-related data.
}
\details{
If the \code{GYPSUM_CACHE_DIR} environment variable is set before the first call to \code{\link{cacheDirectory}}, it is used as the initial location of the cache directory.
Otherwise, the initial location is based on \code{\link{R_user_dir}}.
}
\examples{
cacheDirectory()
old <- cacheDirectory(tempfile())
cacheDirectory()
cacheDirectory(old) # setting it back.

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/completeUpload.R
\name{completeUpload}
\alias{completeUpload}
\title{Complete an upload}
\usage{
completeUpload(init, url = restUrl())
}
\arguments{
\item{init}{List containing \code{complete_url} and \code{session_token}.
This is typically the return value from \code{\link{startUpload}}.}

\item{url}{String containing the URL of the gypsum REST API.}
}
\value{
\code{NULL} is invisibly returned on successful completion.
}
\description{
Complete an upload session after all files have been uploaded.
}
\examples{
tmp <- tempfile()
dir.create(tmp)
write(file=file.path(tmp, "blah.txt"), LETTERS)
dir.create(file.path(tmp, "foo"))
write(file=file.path(tmp, "foo", "bar.txt"), 1:10)

if (interactive()) {
    init <- startUpload(
        project="test-R", 
        asset="upload-complete-check", 
        version="v1", 
        files=list.files(tmp, recursive=TRUE),
        probation=TRUE,
        directory=tmp
    )
    uploadFiles(init, directory=tmp)

    # Finishing the upload.
    completeUpload(init) 
}

}
\seealso{
\code{\link{startUpload}}, to create \code{init}.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refreshUsage.R
\name{refreshUsage}
\alias{refreshUsage}
\title{Refresh the quota usage}
\usage{
refreshUsage(project, url = restUrl(), token = accessToken())
}
\arguments{
\item{project}{String containing the project name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
Numeric scalar specifying the total quota usage of this project, in bytes.
}
\description{
Recompute the quota usage of a project.
This is useful on rare occasions where multiple simultaneous uploads cause the usage calculations to be out of sync.
}
\examples{
if (interactive()) {
    refreshUsage("test-R")
}

}
\seealso{
\code{\link{fetchUsage}}, to get the usage without recomputing it.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepareDirectoryUpload.R
\name{prepareDirectoryUpload}
\alias{prepareDirectoryUpload}
\title{Prepare to upload a directory}
\usage{
prepareDirectoryUpload(
  directory,
  links = c("auto", "always", "never"),
  cache = cacheDirectory()
)
}
\arguments{
\item{directory}{String containing the path to a directory, the contents of which are to be uploaded via \code{\link{startUpload}}.}

\item{links}{String indicating how to handle symlinks in \code{directory}.
\itemize{
\item \code{"auto"} will attempt to convert symlinks into upload links.
If the conversion fails, a regular upload is performed.
\item \code{"always"} will attempt to convert symlinks into upload links.
If the conversion fails, an error is raised.
\item \code{"never"} will never attempt to convert symlinks into upload links.
All symlinked files are treated as regular uploads.
}}

\item{cache}{String containing a path to the cache directory, used to convert symlinks into upload links.}
}
\value{
List containing \code{files}, a character vector to be used as \code{files=} in \code{\link{startUpload}};
and \code{links}, a data frame to be used as \code{links=} in \code{\link{startUpload}}.
}
\description{
Prepare to upload a directory's contents via \code{\link{startUpload}}.
This goes through the directory to list its contents and convert symlinks to upload links.
}
\details{
Files in \code{directory} (that are not symlinks) are used as regular uploads, i.e., \code{files=} in \code{\link{startUpload}}.

If \code{directory} contains a symlink to a file in \code{cache}, 
we assume that it points to a file that was previously downloaded by, e.g., \code{\link{saveFile}} or \code{\link{saveVersion}}.
Thus, instead of performing a regular upload, we attempt to create an upload link, i.e., \code{links=} in \code{\link{startUpload}}.
This is achieved by examining the destination path of the symlink and inferring the link destination in the backend.
Note that this still works if the symlinks are dangling.

If a symlink cannot be converted into an upload link, it will be used as a regular upload,
i.e., the contents of the symlink destination will be uploaded by \code{\link{startUpload}}.
In this case, an error will be raised if the symlink is dangling as there is no file that can actually be uploaded.
If \code{links="always"}, an error is raised instead upon symlink conversion failure.

This function is intended to be used with \code{\link{cloneVersion}}, which creates symlinks to files in \code{cache}.
}
\examples{
tmp <- tempfile()
out <- cloneVersion("test-R", "basic", "v1", destination=tmp)
write(file=file.path(tmp, "heanna"), "sumire")
prepareDirectoryUpload(tmp)

}
\seealso{
\code{\link{startUpload}}, to actually start the upload.

\code{\link{cloneVersion}}, to prepare the symlinks.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/translateTextQuery.R
\name{translateTextQuery}
\alias{translateTextQuery}
\title{Translate a plain-text query to a gypsum.search.clause}
\usage{
translateTextQuery(query)
}
\arguments{
\item{query}{String containing a query in user-friendly format to a \link{gypsum.search.clause}.}
}
\value{
A \link{gypsum.search.clause} representing \code{query}.
}
\description{
Translate a plain-text query in user-friendly format to a \link{gypsum.search.clause},
equivalent to that created by \code{\link{gsc}} with the corresponding boolean operations.
}
\details{
For text searches, we support a more human-readable syntax for boolean operations in the query.
The search string below will look for all metadata documents that match \code{foo} or \code{bar} but not \code{whee}:

\preformatted{
(foo OR bar) AND NOT whee
}

The \code{AND}, \code{OR} and \code{NOT} (note the all-caps!) are automatically translated to the corresponding search clauses.
This can be combined with parentheses to control precedence; otherwise, \code{AND} takes precedence over \code{OR}, and \code{NOT} takes precedence over both.
Note that any sequence of adjacent text terms are implicitly AND'd together, so the two expressions below are equivalent:

\preformatted{
foo bar whee
foo AND bar AND whee
} 

Users can prefix any sequence of text terms with the name of a metadata field, to only search for matches within that field of the metadata file.
For example:

\preformatted{
(title: prostate cancer) AND (genome: GRCh38 OR genome: GRCm38)
} 

Note that this does not extend to the \code{AND}, \code{OR} and \code{NOT} keywords,
e.g., \code{title:foo OR bar} will not limit the search for \code{bar} to the \code{title} field.

If a \code{\%} wildcard is present in a search term, its corresponding text search clause is configured to perform a partial search.
}
\examples{
str(translateTextQuery("foo AND bar"))
str(translateTextQuery("foo AND bar\%"))
str(translateTextQuery("(foo AND NOT bar) OR whee"))
str(translateTextQuery("blah:foo whee AND stuff: bar blob"))

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessToken.R
\name{accessToken}
\alias{accessToken}
\alias{setAccessToken}
\title{Get and set GitHub access tokens}
\usage{
accessToken(full = FALSE, request = TRUE, cache = cacheDirectory())

setAccessToken(
  token,
  app.url = restUrl(),
  app.key = NULL,
  app.secret = NULL,
  github.url = "https://api.github.com",
  user.agent = NULL,
  cache = cacheDirectory()
)
}
\arguments{
\item{full}{Logical scalar indicating whether to return the full token details.}

\item{request}{Logical scalar indicating whether to request a new token if no cached token is available or if the current token has expired.}

\item{cache}{String containing a path to the cache directory, to store the token across R sessions.
If \code{NULL}, the token is not cached to (or read from) disk, which improves security on shared filesystems.}

\item{token}{String containing a GitHub personal access token.
This should have the \code{"read:org"} and \code{"read:user"} scopes.
If missing, the user will be prompted to use GitHub's Oauth web application flow to acquire a token.
If \code{NULL}, any existing tokens are cleared from cache.}

\item{app.url}{String containing a URL of the gypsum REST API.
This is used to obtain \code{app.key} and \code{app.secret} if either are \code{NULL}.}

\item{app.key}{String containing the key for a GitHub Oauth app.}

\item{app.secret}{String containing the secret for a GitHub Oauth app.}

\item{github.url}{String containing the URL for the GitHub API.
This is used to acquire more information about the token.}

\item{user.agent}{String specifying the user agent for queries to various endpoints.}
}
\value{
\code{setAccessToken} sets the access token and invisibly returns a list containing:
\itemize{
\item \code{token}, a string containing the token.
\item \code{name}, the name of the GitHub user authenticated by the token.
\item \code{expires}, the Unix time at which the token expires.
}

If \code{full=TRUE}, \code{accessToken} returns the same list, typically retrieved from one of the caches.
If no token was cached or the cached token has expired, it will call \code{setAccessToken} with default arguments to obtain one if \code{request=TRUE};
otherwise if \code{request=FALSE}, \code{NULL} is returned.

If \code{full=FALSE}, \code{accessToken} will return a string containing a token (or \code{NULL}, if no token is available and \code{request=FALSE}).
}
\description{
Get and set GitHub access tokens for authentication to the gypsum API's endpoints.
}
\examples{
if (interactive()) {
    accessToken()
}
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchQuota.R
\name{fetchQuota}
\alias{fetchQuota}
\title{Fetch project quota details}
\usage{
fetchQuota(project, url = restUrl(), config = NULL)
}
\arguments{
\item{project}{String containing the project name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
List containing \code{baseline}, the baseline quota at time zero in bytes;
\code{growth_rate}, the annual growth rate for the quota in bytes;
and \code{year}, the creation year (i.e., time zero) for this project.
}
\description{
Fetch the quota details for a project.
}
\examples{
fetchQuota("test-R")

}
\seealso{
\code{\link{setQuota}}, to set the quota details.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refreshLatest.R
\name{refreshLatest}
\alias{refreshLatest}
\title{Refresh the latest version}
\usage{
refreshLatest(project, asset, url = restUrl(), token = accessToken())
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
String containing the latest version of the project, or \code{NULL} if there are no non-probational versions.
}
\description{
Recompute the latest version of a project's asset.
This is useful on rare occasions where multiple simultaneous uploads cause the latest version to be slightly out of sync.
}
\examples{
if (interactive()) {
    refreshLatest("test-R", "basic")
}

}
\seealso{
\code{\link{fetchLatest}}, to get the latest version without recomputing it.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/unlockProject.R
\name{unlockProject}
\alias{unlockProject}
\title{Unlock a project}
\usage{
unlockProject(project, url = restUrl(), token = accessToken())
}
\arguments{
\item{project}{String containing the project to remove.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a gypsum administrator account.}
}
\value{
\code{NULL} is invisibly returned if the project was successfully removed.
}
\description{
Unlock a project on the gypsum backend.
This is typically caused by a partial upload that was not properly aborted.
}
\examples{
if (interactive()) {
    unlockProject("test-R")
}
}
\seealso{
\code{\link{abortUpload}}, to correctly abort an upload upon failure.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/publicS3Config.R
\name{publicS3Config}
\alias{publicS3Config}
\title{Public S3 configuration}
\usage{
publicS3Config(refresh = FALSE, url = restUrl(), cache = cacheDirectory())
}
\arguments{
\item{refresh}{Logical scalar indicating whether to refresh the credentials in the in-memory cache.}

\item{url}{String containing a URL to the gypsum REST API.}

\item{cache}{String containing a path to the cache directory, to store the configuration across R sessions.}
}
\value{
List containing:
\itemize{
\item \code{key}, a string containing the read-only S3 access key ID.
\item \code{secret}, a string containing the associated S3 access secret.
\item \code{bucket}, a string containing the name of the bucket.
\item \code{endpoint}, a string containing the URL for the S3 API.
}
}
\description{
Fetch S3 credentials and other configuration details for read-only access to the underlying gypsum bucket.
}
\details{
The configuration is obtained through a query to \code{url} on the first use of this function.
The result is automatically cached in memory and on disk to reduce the number of network requests to the API.
New credentials are automatically fetched if the on-disk cache is older than a week;
this refresh can be performed manually by calling this function with \code{refresh=TRUE}.
}
\examples{
publicS3Config()

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fetchMetadataSchema.R
\name{fetchMetadataSchema}
\alias{fetchMetadataSchema}
\title{Fetch a metadata schema}
\usage{
fetchMetadataSchema(
  name = "bioconductor/v1.json",
  cache = cacheDirectory(),
  overwrite = FALSE
)
}
\arguments{
\item{name}{String containing the name of the schema.
This can be the name of any JSON schema file published at \url{https://github.com/ArtifactDB/bioconductor-metadata-index}.}

\item{cache}{String containing the cache directory.
If \code{NULL}, no caching is performed.}

\item{overwrite}{Logical scalar indicating whether to overwrite an existing file in \code{cache}, if one is present.}
}
\value{
String containing a path to the downloaded schema.
}
\description{
Fetch a JSON schema file for metadata to be inserted into a SQLite database
(see \url{https://github.com/ArtifactDB/bioconductor-metadata-index}).
Each SQLite database is created from metadata files uploaded to the gypsum backend,
so clients uploading objects to be incorporated into the database should validate their metadata against the corresponding JSON schema.
}
\examples{
fetchMetadataSchema()
}
\seealso{
\code{\link{validateMetadata}}, to validate metadata against a chosen schema.

\code{\link{fetchMetadataDatabase}}, to obtain the SQLite database of metadata.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setPermissions.R
\name{setPermissions}
\alias{setPermissions}
\title{Set project permissions}
\usage{
setPermissions(
  project,
  owners = NULL,
  uploaders = NULL,
  append = TRUE,
  url = restUrl(),
  token = accessToken()
)
}
\arguments{
\item{project}{String containing the project name.}

\item{owners}{Character vector containing the GitHub users or organizations that are owners of this project.
If \code{NULL}, no change is made to the existing owners of the project.}

\item{uploaders}{List specifying the authorized uploaders for this project.
See the \code{uploaders} field in the \code{\link{fetchPermissions}} return value for the expected format. 
If \code{NULL}, no change is made to the existing uploaders of the project.}

\item{append}{Logical scalar indicating whether \code{owners} and \code{uploaders} should be appended to the existing owners and uploaders, respectively, of the project.
If \code{FALSE}, the \code{owners} and \code{uploaders} are used to replace the existing values.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to an owner of the \code{project}.}
}
\value{
\code{NULL} is invisibly returned upon successful setting of the permissions.
}
\description{
Set the owner and uploader permissions for a project.
}
\examples{
if (interactive()) {
    # Creating a project for demonstration purposes.
    createProject("test-R-perms", owners="LTLA")

    # Setting extra permissions on this project.
    setPermissions("test-R-perms",
        owners="jkanche", 
        uploaders=list(list(id="lawremi", until=Sys.time() + 1000))
    )
}

}
\seealso{
\code{\link{fetchPermissions}}, to fetch the permissions.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/uploadDirectory.R
\name{uploadDirectory}
\alias{uploadDirectory}
\title{Upload a directory to the gypsum backend}
\usage{
uploadDirectory(
  directory,
  project,
  asset,
  version,
  cache = cacheDirectory(),
  deduplicate = TRUE,
  probation = FALSE,
  url = restUrl(),
  token = accessToken(),
  concurrent = 1,
  abort.failed = TRUE
)
}
\arguments{
\item{directory}{String containing the path to a directory to be uploaded.}

\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.
This should not contain \code{/} or start with \code{..}.}

\item{version}{String containing the version name.
This should not contain \code{/} or start with \code{..}.}

\item{cache}{String containing the path to the cache for saving files, e.g., in \code{\link{saveVersion}}.
Used to convert symbolic links to upload links, see \code{\link{prepareDirectoryUpload}}.}

\item{deduplicate}{Logical scalar indicating whether the backend should attempt deduplication of \code{files} in the immediately previous version.
Only has an effect if \code{files} is not a data frame or if the \code{dedup} field is missing.}

\item{probation}{Logical scalar indicating whether to perform a probational upload.
Such uploads must be approved by the project owner before they are considered official.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{token}{String containing a GitHub access token to authenticate to the gypsum REST API.
The token must refer to a user that is authorized to upload to the specified \code{project}.}

\item{concurrent}{Integer scalar specifying the number of concurrent uploads in \code{\link{uploadFiles}}.}

\item{abort.failed}{Logical scalar indicating whether to abort the upload on any failure.
Setting this to \code{FALSE} can be helpful for diagnosing upload problems.}
}
\value{
On successful upload, \code{NULL} is invisibly returned.
}
\description{
Convenience method to upload a directory to the gypsum backend as a versioned asset of a project.
This requires uploader permissions to the relevant project.
}
\details{
This function is a wrapper around \code{\link{prepareDirectoryUpload}} and \code{\link{startUpload}} and friends.
The aim is to streamline the upload of a directory's contents when no customization of the file listing is required.
}
\examples{
tmp <- tempfile()
dir.create(tmp)
write(file=file.path(tmp, "blah.txt"), LETTERS)
dir.create(file.path(tmp, "foo"))
write(file=file.path(tmp, "foo", "bar.txt"), 1:10)

if (interactive()) {
    # Uploading a probational version for test purposes.
    uploadDirectory(staging, "test-R", "upload-dir-check", version, probation=TRUE)

    # Cleaning up after ourselves.
    gypsum::rejectProbation("test-R", "upload-dir-check", version)
}

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/restUrl.R
\name{restUrl}
\alias{restUrl}
\title{URL for the REST API}
\usage{
restUrl(url)
}
\arguments{
\item{url}{String containing the URL of the REST API.}
}
\value{
If \code{url} is missing, the current setting of the URL is returned.

If \code{url} is provided, it is used to replace the current setting of the URL,
and the \emph{previous} setting of the URL is invisibly returned.
}
\description{
Get or set the URL for the gypsum REST API.
}
\examples{
restUrl()
old <- restUrl("https://some-other.rest-api.io") # replace it.
restUrl()
restUrl(old) # setting it back.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveFile.R
\name{saveFile}
\alias{saveFile}
\title{Save a file from a version of a project asset}
\usage{
saveFile(
  project,
  asset,
  version,
  path,
  cache = cacheDirectory(),
  overwrite = FALSE,
  url = restUrl(),
  config = NULL
)
}
\arguments{
\item{project}{String containing the project name.}

\item{asset}{String containing the asset name.}

\item{version}{String containing the version name.}

\item{path}{String containing the suffix of the object key for the file of interest,
i.e., the relative \dQuote{path} inside the version's \dQuote{subdirectory}.
The full object key is defined as \code{{project}/{asset}/{version}/{path}}.}

\item{cache}{String containing the path to the cache directory.}

\item{overwrite}{Logical scalar indicating whether to overwrite an existing file in \code{cache}.
If \code{FALSE} and the file exists in \code{cache}, the download is skipped.}

\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
The file is downloaded to the local file system. The destination file path is returned.
}
\description{
Download a file from the gypsum bucket, for a version of an asset of a project.
}
\details{
The full object key is defined as \code{{project}/{asset}/{version}/{path}}.
If no file exists in the project-asset-version combination at \code{path}, 
this function will check the \code{..links} file to check whether \code{path} refers to a linked-from file.
If so, the contents of the link destination is downloaded to the cache and a link/copy is created at the returned file path.
}
\examples{
out <- saveFile("test-R", "basic", "v1", "blah.txt")
readLines(out)

}
\seealso{
\code{\link{saveVersion}}, to save all files with the same prefix.

\code{\link{cacheDirectory}}, for file caching.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/listProjects.R
\name{listProjects}
\alias{listProjects}
\title{List all projects}
\usage{
listProjects(url = restUrl(), config = NULL)
}
\arguments{
\item{url}{String containing the URL of the gypsum REST API.}

\item{config}{Deprecated and ignored.}
}
\value{
Character vector of project names.
}
\description{
List all projects in the gypsum backent.
}
\examples{
if (interactive()) {
    listProjects()
}

}
\author{
Aaron Lun
}
